' MinWin
' Windows support
' 17:16 13/10/2010
' Charles Pegge


  basic



  '================
  'EQUATES / MACROS
  '================

  % NULL  0
  % TRUE  1
  % FALSE 0



/*
 * Dialog Box Command IDs
 */

  % IDOK                1
  % IDCANCEL            2
  % IDABORT             3
  % IDRETRY             4
  % IDIGNORE            5
  % IDYES               6
  % IDNO                7



  % CS_VREDRAW      1
  % CS_HREDRAW      2

  % IDI_APPLICATION 32512
  % IDC_ARROW       32512



  'Common RGB Colors

  % BLACK   0x000000
  % BLUE    0xFF0000
  % GREEN   0x00FF00
  % CYAN    0xFFFF00
  % RED     0x0000FF
  % MAGENTA 0xFF00FF
  % YELLOW  0x00FFFF
  % WHITE   0xFFFFFF
  % GRAY    0x808080
  % LTGRAY  0xC0C0C0

  % WHITE_BRUSH     0
  % BLACK_BRUSH     4



  % SW_HIDE             0
  % SW_SHOWNORMAL       1
  % SW_NORMAL           1
  % SW_SHOWMINIMIZED    2
  % SW_SHOWMAXIMIZED    3
  % SW_MAXIMIZE         3
  % SW_SHOWNOACTIVATE   4
  % SW_SHOW             5
  % SW_MINIMIZE         6
  % SW_SHOWMINNOACTIVE  7
  % SW_SHOWNA           8
  % SW_RESTORE          9
  % SW_SHOWDEFAULT      10
  % SW_FORCEMINIMIZE    11
  % SW_MAX              11

/*
 * Dialog Box Command IDs
 */

  % IDOK                1
  % IDCANCEL            2
  % IDABORT             3
  % IDRETRY             4
  % IDIGNORE            5
  % IDYES               6
  % IDNO                7


  % MB_OK                       0x00000000
  % MB_OKCANCEL                 0x00000001
  % MB_ABORTRETRYIGNORE         0x00000002
  % MB_YESNOCANCEL              0x00000003
  % MB_YESNO                    0x00000004
  % MB_RETRYCANCEL              0x00000005
  % MB_ICONERROR    16

  % CW_USEDEFAULT       0x80000000

  % WS_OVERLAPPEDWINDOW 0x00cf0000

  % PM_REMOVE   1


  % SM_CXSCREEN 0
  % SM_CYSCREEN 1

  % WM_NULL             0
  % WM_CREATE           1
  % WM_DESTROY          2
  % WM_MOVE             3
  % WM_SIZE             5
  % WM_ACTIVATE         6

  % WA_INACTIVE     0
  % WA_ACTIVE       1
  % WA_CLICKACTIVE  2

  % WM_SETFOCUS         7
  % WM_KILLFOCUS        8
  % WM_PAINT            15
  % WM_CLOSE            16
  % WM_QUIT             18
  % WM_ERASEBKGND       20

  % WM_INPUT            0x0FF 
  % WM_KEYFIRST         0x100
  % WM_KEYDOWN          0x100
  % WM_KEYUP            0x101
  % WM_CHAR             0x102
  % WM_DEADCHAR         0x103
  % WM_SYSKEYDOWN       0x104
  % WM_SYSKEYUP         0x105
  % WM_SYSCHAR          0x106
  % WM_SYSDEADCHAR      0x107
  % WM_UNICHAR          0x109
  % WM_INITDIALOG       0x110


  % WM_TIMER            0x113
  % WM_HSCROLL          0x114
  % WM_VSCROLL          0x115

'(
#define WM_CTLCOLORMSGBOX               0x0132
#define WM_CTLCOLOREDIT                 0x0133
#define WM_CTLCOLORLISTBOX              0x0134
#define WM_CTLCOLORBTN                  0x0135
#define WM_CTLCOLORDLG                  0x0136
#define WM_CTLCOLORSCROLLBAR            0x0137
#define WM_CTLCOLORSTATIC               0x0138
')

  % WM_MOUSEMOVE        0x200
  % WM_LBUTTONDOWN      0x201
  % WM_LBUTTONUP        0x202
  % WM_LBUTTONDBLCLK    0x203
  % WM_RBUTTONDOWN      0x204
  % WM_RBUTTONUP        0x205
  % WM_RBUTTONDBLCLK    0x206
  % WM_MBUTTONDOWN      0x207
  % WM_MBUTTONUP        0x208
  % WM_MBUTTONDBLCLK    0x209
  % WM_MOUSEWHEEL       0x20A

'(

#define EM_GETSEL               0x00B0
#define EM_SETSEL               0x00B1
#define EM_GETRECT              0x00B2
#define EM_SETRECT              0x00B3
#define EM_SETRECTNP            0x00B4
#define EM_SCROLL               0x00B5
#define EM_LINESCROLL           0x00B6
#define EM_SCROLLCARET          0x00B7
#define EM_GETMODIFY            0x00B8
#define EM_SETMODIFY            0x00B9
#define EM_GETLINECOUNT         0x00BA
#define EM_LINEINDEX            0x00BB
#define EM_SETHANDLE            0x00BC
#define EM_GETHANDLE            0x00BD
#define EM_GETTHUMB             0x00BE
#define EM_LINELENGTH           0x00C1
#define EM_REPLACESEL           0x00C2
#define EM_GETLINE              0x00C4
#define EM_LIMITTEXT            0x00C5
#define EM_CANUNDO              0x00C6
#define EM_UNDO                 0x00C7
#define EM_FMTLINES             0x00C8
#define EM_LINEFROMCHAR         0x00C9
#define EM_SETTABSTOPS          0x00CB
#define EM_SETPASSWORDCHAR      0x00CC
#define EM_EMPTYUNDOBUFFER      0x00CD
#define EM_GETFIRSTVISIBLELINE  0x00CE
#define EM_SETREADONLY          0x00CF
#define EM_SETWORDBREAKPROC     0x00D0
#define EM_GETWORDBREAKPROC     0x00D1
#define EM_GETPASSWORDCHAR      0x00D2
#define EM_SETMARGINS           0x00D3
#define EM_GETMARGINS           0x00D4
#define EM_SETLIMITTEXT         EM_LIMITTEXT   /* ;win40 Name change */
#define EM_GETLIMITTEXT         0x00D5
#define EM_POSFROMCHAR          0x00D6
#define EM_CHARFROMPOS          0x00D7

')

/*
 * Window Styles
 */
  % WS_OVERLAPPED       0x00000000L
  % WS_POPUP            0x80000000L
  % WS_CHILD            0x40000000L
  % WS_MINIMIZE         0x20000000L
  % WS_VISIBLE          0x10000000L
  % WS_DISABLED         0x08000000L
  % WS_CLIPSIBLINGS     0x04000000L
  % WS_CLIPCHILDREN     0x02000000L
  % WS_MAXIMIZE         0x01000000L
  % WS_CAPTION          0x00C00000L     /* WS_BORDER | WS_DLGFRAME  */
  % WS_BORDER           0x00800000L
  % WS_DLGFRAME         0x00400000L
  % WS_VSCROLL          0x00200000L
  % WS_HSCROLL          0x00100000L
  % WS_SYSMENU          0x00080000L
  % WS_THICKFRAME       0x00040000L
  % WS_GROUP            0x00020000L
  % WS_TABSTOP          0x00010000L

  % WS_MINIMIZEBOX      0x00020000L
  % WS_MAXIMIZEBOX      0x00010000L


  % WS_TILED            WS_OVERLAPPED
  % WS_ICONIC           WS_MINIMIZE
  % WS_SIZEBOX          WS_THICKFRAME
  % WS_TILEDWINDOW      WS_OVERLAPPEDWINDOW

/*
 * Common Window Styles
*/

/*
0x000cf000
  % WS_OVERLAPPEDWINDOW (WS_OVERLAPPED     | \
                             WS_CAPTION        | \
                             WS_SYSMENU        | \
                             WS_THICKFRAME     | \
                             WS_MINIMIZEBOX    | \
                             WS_MAXIMIZEBOX)

  % WS_POPUPWINDOW      (WS_POPUP          | \
                             WS_BORDER         | \
                             WS_SYSMENU)
*/
  % WS_OVERLAPPEDWINDOW 0x00cf0000
  % WS_POPUPWINDOW      0x80880000

  % WS_CHILDWINDOW      (WS_CHILD)


/*
 * Extended Window Styles
 */
  % WS_EX_DLGMODALFRAME     0x00000001L
  % WS_EX_NOPARENTNOTIFY    0x00000004L
  % WS_EX_TOPMOST           0x00000008L
  % WS_EX_ACCEPTFILES       0x00000010L
  % WS_EX_TRANSPARENT       0x00000020L

 
  /*
   * Window field offsets for GetWindowLong()
   */
    % GWL_WNDPROC         (-4)
    % GWL_HINSTANCE       (-6)
    % GWL_HWNDPARENT      (-8)
    % GWL_STYLE           (-16)
    % GWL_EXSTYLE         (-20)
    % GWL_USERDATA        (-21)
    % GWL_ID              (-12)






  ' PIXELFORMATDESCRIPTOR flags

  % PFD_TYPE_RGBA       = 0
  % PFD_TYPE_COLORINDEX = 1
  % PFD_MAIN_PLANE      = 0
  % PFD_OVERLAY_PLANE   = 1
  % PFD_UNDERLAY_PLANE  =-1
  '
  % PFD_DOUBLEBUFFER          = &H00000001
  % PFD_STEREO                = &H00000002
  % PFD_DRAW_TO_WINDOW        = &H00000004
  % PFD_DRAW_TO_BITMAP        = &H00000008
  % PFD_SUPPORT_GDI           = &H00000010
  % PFD_SUPPORT_OPENGL        = &H00000020
  % PFD_GENERIC_FORMAT        = &H00000040
  % PFD_NEED_PALETTE          = &H00000080
  % PFD_NEED_SYSTEM_PALETTE   = &H00000100
  % PFD_SWAP_EXCHANGE         = &H00000200
  % PFD_SWAP_COPY             = &H00000400
  % PFD_SWAP_LAYER_BUFFERS    = &H00000800
  % PFD_GENERIC_ACCELERATED   = &H00001000
  % PFD_SUPPORT_DIRECTDRAW    = &H00002000

  ' PIXELFORMATDESCRIPTOR flags for use in ChoosePixelFormat only
  % PFD_DEPTH_DONTCARE        = &H20000000
  % PFD_DOUBLEBUFFER_DONTCARE = &H40000000
  % PFD_STEREO_DONTCARE       = &H80000000

  ' Font Weights
  % FW_DONTCARE   = 0
  % FW_THIN       = 100
  % FW_EXTRALIGHT = 200
  % FW_LIGHT      = 300
  % FW_NORMAL     = 400
  % FW_MEDIUM     = 500
  % FW_SEMIBOLD   = 600
  % FW_BOLD       = 700
  % FW_EXTRABOLD  = 800
  % FW_HEAVY      = 900

  % DEFAULT_QUALITY        = 0
  % DRAFT_QUALITY          = 1
  % PROOF_QUALITY          = 2
  % NONANTIALIASED_QUALITY = 3
  % ANTIALIASED_QUALITY    = 4

  % ANSI_CHARSET        = 0
  % DEFAULT_CHARSET     = 1
  % SYMBOL_CHARSET      = 2

  % OUT_TT_PRECIS       = 4
  % CLIP_DEFAULT_PRECIS = 0

  % DEFAULT_PITCH   = 0
  % FIXED_PITCH     = 1
  % VARIABLE_PITCH  = 2
  % MONO_FONT       = 8


  ' Font Families
  '
  % FF_DONTCARE = 0    ' Don't care or don't know.
  % FF_ROMAN    = 16   ' Variable stroke width, serifed.

  ' Times Roman, Century Schoolbook, etc.
  % FF_SWISS    = 32   ' Variable stroke width, sans-serifed.

  ' Helvetica, Swiss, etc.
  % FF_MODERN   = 48   ' Constant stroke width, serifed or sans-serifed.

  ' Pica, Elite, Courier, etc.
  % FF_SCRIPT     = 64 ' Cursive, etc.
  % FF_DECORATIVE = 80 ' Old English, etc.


  % LF_FACESIZE     = 32




  '==========
  'STRUCTURES
  '==========


  type WNDCLASS
    ;40 bytes
    STYLE         as long
    lpfnwndproc   as long
    cbClsextra    as long
    cbWndExtra    as long
    hInstance     as long
    hIcon         as long
    hCursor       as long
    hbrBackground as long
    lpszMenuName  as long
    lpszClassName as long
  end type


  type point
    x as long
    y as long
  end type


  type MSG
    ; 28 bytes
    hwnd    as long
    message as long
    wParam  as long
    lParam  as long
    time    as long
    pt      as point
  end type


  type RECT
    ; 16 bytes
    left   as long
    top    as long
    right  as long
    bottom as long
  end type


  type rgbacolor
    red   as byte
    green as byte
    blue  as byte
    alpha as byte
    =
    rgba  as dword
  end type

  
  type PAINTSTRUCT
    ; 64 bytes
    hDC        as long
    fErase     as long
    rcPaint    as rect
    fRestore   as long
    fIncUpdate as long
    rgb        as rgbacolor
    Reserved   as 32
  end type


  TYPE PIXELFORMATDESCRIPTOR
    nSize AS WORD
    nVersion AS WORD
    dwFlags AS DWORD
    iPixelType AS BYTE
    cColorBits AS BYTE
    cRedBits AS BYTE
    cRedShift AS BYTE
    cGreenBits AS BYTE
    cGreenShift AS BYTE
    cBlueBits AS BYTE
    cBlueShift AS BYTE
    cAlphaBits AS BYTE
    cAlphaShift AS BYTE
    cAccumBits AS BYTE
    cAccumRedBits AS BYTE
    cAccumGreenBits AS BYTE
    cAccumBlueBits AS BYTE
    cAccumAlphaBits AS BYTE
    cDepthBits AS BYTE
    cStencilBits AS BYTE
    cAuxBuffers AS BYTE
    iLayerType AS BYTE
    bReserved AS BYTE
    dwLayerMask AS DWORD
    dwVisibleMask AS DWORD
    dwDamageMask AS DWORD
  END TYPE


  TYPE LOGFONT
    lfHeight AS LONG
    lfWidth AS LONG
    lfEscapement AS LONG
    lfOrientation AS LONG
    lfWeight AS LONG
    lfItalic AS BYTE
    lfUnderline AS BYTE
    lfStrikeOut AS BYTE
    lfCharSet AS BYTE
    lfOutPrecision AS BYTE
    lfClipPrecision AS BYTE
    lfQuality AS BYTE
    lfPitchAndFamily AS BYTE
    lfFaceName AS 32
  END TYPE



  '==================
  'BASIC DECLARATIONS
  '==================

  Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
  Declare Function InvalidateRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT, ByVal bErase As Long) As Long
  Declare Function ValidateRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
  Declare Function Rectangle Lib "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
  Declare Function Ellipse Lib   "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
  Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
  Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long
  DECLARE FUNCTION SetTimer  LIB "USER32.DLL" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG, BYVAL uElapse AS DWORD, BYVAL lpTimerFunc AS LONG) AS LONG
  DECLARE FUNCTION KillTimer LIB "USER32.DLL" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG) AS LONG




  '=====================
  'LOW LEVEL LATE BINDING
  '=====================

  dim kernel32,user32,GDI32 as long
  kernel32=LoadLibrary `kernel32.dll`
  user32=LoadLibrary `user32.dll`
  GDI32=LoadLibrary `GDI32.dll`

  bind kernel32
  (
    GetCommandLine  GetCommandLineA   ; @0
    GetModuleHandle GetModuleHandleA  ; @4
    ExitProcess     ExitProcess       ; @4
    QueryPerformanceCounter QueryPerformanceCounter ; @4
    QueryPerformanceFrequency QueryPerformanceFrequency ; @4
  )

  bind user32
  (
    LoadIcon         LoadIconA         ; @8
    LoadCursor       LoadCursorA       ; @8
    RegisterClass    RegisterClassA    ; @4
    MessageBox       MessageBoxA       ; @4
    CreateWindowEx   CreateWindowExA   ; @48
    ShowWindow       ShowWindow        ; @8
    UpdateWindow     UpdateWindow      ; @4
    GetMessage       GetMessageA       ; @16
    TranslateMessage TranslateMessage  ; @4
    DispatchMessage  DispatchMessageA  ; @4
    PostQuitMessage  PostQuitMessage   ; @4
    BeginPaint       BeginPaint        ; @8
    EndPaint         EndPaint          ; @8
    GetClientRect    GetClientRect     ; @8  
    DrawText         DrawTextA         ; @20
    PostMessage      PostMessageA      ; @16
    DefWindowProc    DefWindowProcA    ; @16
    EnumChildWindows EnumChildWindows  ; @12
    MoveWindow       MoveWindow        ; @24
    DestroyWindow    DestroyWindow     ; @4
    GetWindowLong    GetWindowLongA    ; @8
    FillRect         FillRect
    GetDC            GetDC             ; @4
    ReleaseDC        ReleaseDC         ;
    SetTimer         SetTimer          ;
    KillTimer        KillTimer         ;
  )


  bind GDI32
  (
    SetBkColor         SetBkColor        ; @16
    SetTextColor       SetTextColor      ; @16
    GetStockObject     GetStockObject    ; @4
    CreateSolidBrush   CreateSolidBrush  ; @4
    ChoosePixelFormat  ChoosePixelFormat
    SetPixelFormat     SetPixelFormat
    CreateFontIndirect CreateFontIndirectA
    SelectObject       SelectObject
    DeleteObject       DeleteObject
    SwapBuffers        SwapBuffers
   )




  s=error() : if s then print s : goto endprog


  function hiwrd   (byval a as long) as long
  shr a,16 : function=a
  end function

  function lowrd(byval a as long) as long
  and a,&hffff : function=a
  end function

  function min(byval a as long, byval b as long) as long
  if a<=b then function=a else function=b
  end function

  function max(byval a as long, byval b as long) as long
  if a>=b then function=a else function=b
  end function

  function minmax(byval a as long, byval b as long, byval c as long) as long
  if b<=a then b=a
  if b>=c then b=c
  function=b
  end function
