

' ##          ##
' ####        ##
' ## ##       ##
' ##  ##      ##
' ##   ##     ##
' ##    ##    ##
' ##     ##   ##
' ##      ##  ##
' ##       ## ##
' ##        ####
' ##          ##


'------------------------------------------
sub enums(byref s as string,byref i as sys)
'==========================================
  dim as sys a,b,c,e,k,m
  dim as string wr,wd,wn
  '
  wr=word(s,i) 'ENUM/DEFS
  '
  if wordahead(s,i)="bit" then k=-3 : i=nwd else k=-2
  '
  nextinstruct(s,i)
  wn=word(s,i) 'NAME PROVIDED?
  '
  if (ascw=lbr)or(ascw=123) then i=swd : ascn=ascw : wn="typedefenum" else nextinstruct(s,i)
  '
  captureb(s,i,m,b,wr) : e=m+b
  a=1 : c=1 : wd=" "
  '
  do
    if m>=e then exit do
    wr=word(s,m)
    if ascn=61 then m+=1 : nextinstruct(s,m) 'SKIP `=`
    if isn(ascn) then wordval(s,m,m) : a=dv : c=dv
    wd+=" "+wr+" "+str(c)+cr
    if k=-2 then c+=1       'NORMAL ENUM
    if k=-3 then a+=a : c=a 'BITWISE ENUM
    if ascn=44 then m+=1    'SKIP COMMA
    nextinstruct(s,m)
  loop
  '
  macoin me
  macsi(wn,me,0) : addm(me)
  macsi(wd,me,1)
  macsi(wd,me,2)
  maco(me,0)=-2
  maco(me,5)=&h24
  addme
  skiplspace(s,i)
end sub



'=====================================
'             VARIABLES
'=====================================
'
'
'  ###         ###   ###   #########
'   ##         ##   #####   ##      ##
'    ##  VAR  ##   ##   ##   ##      ##
'     ##     ##   ##    ##    #######
'      ##   ##   ### DIM ##    ##    ##
'       #####   ##        ##    ##    ##
'        ###   ##          ##    ##    ##
'
'=========================================
'             DIM ----> VAR
'=========================================



'------------------------------------------
sub vars(byref s as string, byref i as sys)
'==========================================
    dim as sys a,b,c,k,m,n,v,w,it,poff,arv,tyi
    dim as string w1,w2,w3,wd,wr,wm,ws,wt,sigs
    '
    ' create variable and optionally associate with structure
    ' macs 0 name
    ' macs 1 macro (no structure spec)
    ' macs 2 regs and dimensions (if array)
    ' macs 3 name of intrinsic type
    '------------------------------
    ' maco 0 0 or type index
    ' maco 1 size
    ' maco 2 offset
    ' maco 3 indirection flag
    ' maco 4 number of dimensions (terms)
    ' maco 5 type code >=512 = user defined
    '------------------------------
    '
    '=====
    varss:
    '=====
    '
    if wordahead(s,i)="var" then i=nwd
    '
    skiplspace(s,i)
    ind=0
    '
    'GET TYPE NAME
    '-------------
    '
    wm=word(s,i)

    if wm="" then
      ers="No variables to declare " : ert= 100 : exit sub
    end if
    '
    '
    'TYPE POINTERS
    '-------------
    '
    do
      w1=wordahead(s,i)
      if (w1="*")or(w1="ptr") then ind+=1 : i=nwd : continue do
      exit do
    loop
    '
    '
    w=wval(wm) : ary=""
    '
    if (w=0)and(ascw<>48) then
      '
      'IDENTIFY TYPE
      '
      it=identype(wm)
      ind+=indt 'ADD TYPE INDIRECTION
      if it<0 then it=-it : wr=macso(it,0) : lent=maco(it,1) : it=maco(it,5)
      if it=0 then
        if ind then
          ind-=1 : it=cpuw : lent=cpuw 'treat void* as direct system type
        else
          ers="direct void type not usable: "+wm+":" : ert=13 : exit sub
        end if
        if it=0 then ers="type not located: "+wm+":" : ert=14 : exit sub
      end if
      tyi=lookupm(wm)
      '
      '
      '---------
      nidentify:
      '---------
      '
      w=lent
      '
      if it>=512 then
        k=it-512  'CLASS OR UDT
      end if
    end if
    ws=""
    '
    '
    'CHECK FOR FUNCTION POINTERS (*foo[n])(..)
    '-----------------------------------------
    '
    '
    if asc(ary)=40 then
      b=2
      w1=word(ary,b)
      if ascw=42 then
        w1=word(ary,b) 'SWALLOW FUNCTION NAME
        w2="" : a=b
        do
          skiplspace(ary,b)
          if ascn=91 then
            a=b
            b=instr(b,ary,"]") : if b=0 then exit do
            b+=1 : w2+=mid(ary,a,b-a)
          else
            exit do
          end if
        loop
        b=a : skiplspace(ary,b)
        if ascn=rbr then skiplspace(ary,b)
        '
        'CAPTURE SIGNATURE
        '
        if ascn=lbr then
          capturi(ary,m,b,a)
          m+=1 : sigs=namesig(ary,m)
        end if
        ary=w2 : k=&h1ff : it=k : w=cpuw 'FUNCTION PTR 32 OR 64 BITS
      end if
    end if
    
    ascn=ascl(s,i)
    '
    '
    '
    '=============
    'each variable
    '=============
    '
    do ' each variable on line
      '
      macoin me
      arv=len(ary)
      '
      maco(me,3)=ind 'INITIAL LEVEL OF INDIRECTION
      macsi(wm+" "+sigs,me,3)
      '
      '===========
      'indirection
      '===========
      '
      do
        if (ascn=58)or(ise(ascn)) then w3="" : exit do
        w3=word(s,i)
        vword(s,i,w3)
        if ascw=44 then continue do
        if instrword(" * ptr pointer ",w3) then
          maco(me,3)+=1 : arv=0 : continue do 'POINTERS
        end if
        exit do
      loop
      '
      if w3="" then exit do
      '
      if ascn=33 then
        maco(me,3)+=256 : skiplspace(s,i) 'ARRAY BYREF
      end if
      '
      c=maco(me,3) and 255
      '
      'WATCH OUT FOR BSTRINGS
      '
      if it=&he1 then
        if (lclv>0)and(asce=1) then ' bstr params
          if c then maco(me,3)-=1 : c-=1 : else it=&hc1 'BSTR BYVAL
        end if
      end if
      '
      maco(me,5)=it  ' type code
      '
      set_macro_name(w3)
      maco(me,0)=k ' structure index
      '
      v=w
      maco(me,1)=w               'ELEMENT LENGTH (ignoring indrection)
      if c then v=cpuw 'POINTER LENGTH
      '
      '=========
      'CONSTANTS)
      '=========
      '
      'constant arrays and compound structures not supported
      '
      if cnst then
        i+=1 'skip assign
        v=metaval(s,i,w1)
        macsi(w1,me,1)
        w1="" : addme : continue do
      end if
      '
      '
      poff=aoff
      wd="" : n=0 : m=1

      '#######  #############
      'ARRAYS   #  #  #  #  #
      '#######  #############
      '         #  #  #  #  #
      '         #############
      '         #  #  #  #  #
      '         #############
      '
      'CHECK FOR ARRAY TYPE
      '
      b=0
      '
      if arv then
        if minormajor then inserts(s,ary,i) : skiplspace(s,i) : b=1
      end if
      '
      if (ascn=lbr)or(ascn=91) then
        '
        'arrays of structures a 4 (2,3,2,4 etc )
        '
        i+=1 : skiplspace(s,i) : a=ascn
        '
        'FIXING ARRAY DIMENSIONS
        '-----------------------
        '
        '
        do
          if (ascn=rbr)or(ascn=93) then
            if n=0 then n+=1 : wd+="A0 " 'UNQUANTIFIED DIMENSION []
            wr=word(s,i)
            '
            'CHECK FOR COMPOUND ARRAY ()() [][] OR FINISH
            '
            '--------
            nextarel: 'SUPPORTS ARRAY TYPEDEFS IN MAJORMINOR MODE
            '--------
            '
            if (ascn=lbr)or(ascn=91) then
              i+=1 'SKIP BRACKET AND CONTINUE
            else
              if b=0 then
                if arv then
                  inserts(s,ary,i) : skiplspace(s,i)
                  b=1 : goto nextarel 'ONCE ONLY
                end if
              end if
              exit do
            end if
          end if
          n+=1 : m=(wval(mword(s,i))-ixb+1)
          if minormajor then
            v*=m : a=v
          else
            a=m
          end if
          wd+=chr(64+n)+str(a)+" " '@A100 @B40 @C 10 ETC
          if ascn=44 then i+=1 : skipspace(s,i) ' swallow
        loop
      end if
      '
      'FLIP DIMENSIONAL ORDER (C standard) MAJOR TO MINOR
      '--------------------------------------------------
      '
      if minormajor=0 then
        if n then
          m=n+64 : b=65 : a=1 : wr=""
          do
            if m<65 then exit do
            a=instr(wd,chr(m))
            a+=1 : v*=wval(mid(wd,a,10))
            wr=chr(m)+str(v)+" "+wr
            m-=1 : b+=1
          loop
          wd=wr
        end if
      end if
      '
      if n then maco(me,4)=n   ' number of dimensions
      '
      'ALIGN SIZE TO 4 OR 8 BYTES
      '--------------------------
      '
      a=cpuw-1
      if v<cpuw then v=cpuw
      if v>cpuw then v=(v+a) and &h7fffffff-a
      '
      'STEP UP OR DOWN
      '---------------
      '
      'ASSIGN
      '
      if vstp then v=vstp 'FORCE STEP SIZE
      '
      if asce=1 then aoff+=v : a=poff else aoff-=v : a=aoff
      '
      maco(me,2)=a   ' offset
      macsi(memreg(regs,a),me,1)
      macsi(wd,me,2)  
      '
      '=======================
      'REGISTERS / VAR LINKAGE
      '=======================
      '
      '
      if ascn=97 then
        if wordahead(s,i)="at" then
          i=nwd
          b=0
          '
          do
            wr=word(s,i)
            if ascw=38 then b-=1 : continue do 'address 
            if ascw=42 then b+=1 : continue do 'indirection
            exit do
          loop
          '
          maco(me,3)+=b*257 'INDIRECT ARRAY RESOLUTION
          '
          a=ascw
          '
          if a=91 then
            i=swd : wr=mword(s,i) 'REG / MEM OPERAND
          elseif a>96 then
            c=lookupm(wr)
            if c then
              b=maco(c,0)
              '
              'CHECK IF VARIABLE IS TO BE A REGISTER
              '
              if b=-10 then
                '
              else
                maco(me,3)+=257*(1+maco(c,3)) 'POINTER VARIABLE: ADD INDIRECTION
                wr=macso(c,1)
              end if
            end if
          elseif a=35 then
            wr="["+wr+"]" 'HOST VAR ADDRESS #VAR
          end if
          '
          macsi(wr,me,1)
          '
          aoff=poff ' no change to offset
          maco(me,2)=0
        end if
      end if
      addme
    loop
    if wordahead(s,i)="var" then mc=0 : goto varss 'FURTHER VAR STATEMENTS
    if lclv=0 then aoffs=aoff
end sub


'#                 #
'###################
'###    TYPES    ###
'###################
'##     #####     ##
'       #####
'       #####
'       #####     ##    ##     ######       #####
'       #####     ##    ##     ##    ##   ##     #
'       #####     ##    ##     ##    ##   ########
'       #####      #######     ######     ##
'       #####           ##     ##         ##     #
'       #####           ##     ##          ######
'      #######     #####

' aml   array size multiplier
' buil  table builder string
' wih   inherited elements to pre-append 
' wmx   max structure length for unions
' vtl   virtual data flag
' po    offset value building def
' pk     k holder
' vo    next offset value building def
' vq    prior offset value building def
' vp    hold offset for inherited strucs

'---------------------------
sub types(byval unip as sys)
'===========================





  '=====================================
  'macso:
  '=====================================
  '0 name
  '1 structure
  '2 
  '3 virtual table maker script
  '=====================================
  'maco:
  '=====================================
  '0 metatype (-3)
  '1 object length
  '2 offset
  '3 
  '4 virtual table length
  '5 flag to indicate vtp field present
  '=====================================



  dim as sys   a,b,c,d,e,f,g,k,m,n,v,w
  dim as sys aml,ctbl,pk,vo,vq,vtl,sih,po,wmx,pp,unif(7),unio(7),unim(7),uni,bb,cmo,indi

  dim as string prf,w1,w2,w3,w4,w5,wd,wm,wn,wr,ws,wt,buil,wih,unin(7),tbls,inhs,wpr

    maco(me,0)=-3 ' is a type

    wm=" "+macso(me,1)+" " : k=1
    w=0     ' offset accumulator
    wmx=0   ' max offset accumulator (unions)
    po=0 : vo=0 : vq=0 : ctbl=0
    '
    '
    '
    vtl=instr(wm,"/")
    '
    if vtl>0 then
      'if vtp<2 then ctbl=1 'VIRTUAL TABLE IS PRESENT
      ctbl=1
    end if
    '
    if (unip and 8) then cmo=1 'C MODE FLAG
    '
    'CHECK FOR UNION (1) OR TYPE (0)
    '-------------------------------
    '
    a=unip and 1
    unif(uni)=a
    unim(uni)=a

    sih=0
    '=======================
    do 'FOR EACH MAIN MEMBER
    '=======================
      '
      maindec:
      '

      pk=k
      '
      'SKIP COMMAS
      'CHECK FOR OVERRIDES
      'SKIP 'HAS' etc
      '
      'READ QUALIFIER WORDS
      '--------------------
      '
      do
        wr=word(wm,k)
        b=dic(" , 1, of 2, from 2, has 1, inherits 2, align 8, ",wr)
        if b=2 then sih=1 : vtp or=1
        if b=8 then
          b=swd : wr=word(wm,k) : v=-wval(wr) : a=w and v 
          if a<w then w=a-v
          'mid(wm,b)=space(k-b) 'blank
        end if
        if b=0 then exit do                
      loop
      '
      a=ascw
      '
      'OVERRIDE PREVIOUS ELEMENTS OF SAME NAME
      '---------------------------------------
      '
      'override methods by appending
  
      '---------------------
      'CHECK FOR END OF BODY
      '=====================
      '
      if wr="" then exit do 'END OF STRUCTURE
      '
      '--------------------------
      'END OF VIRTUAL FUNCTIONS /
      '==========================
      '
      if a=47 then
        '
        if vtl=0 then continue do 'IGNORE ALL BUT THE FIRST '/' ENCOUNTERED
        '
        ' ASSIGN VIRTUAL TABLE OFFSET AND CLEARDOWN
        '
        maco(me,4)=w : w=0 : wmx=0 : po=0 : vo=0 : vtl=0
        '
        if ascn=0 then wm+=cr 'ensure ending with cr for proper line ending
        k+=2                  'skip cr following
        '
        'IS A VIRTUAL TABLE POINTER NEEDED?
        '----------------------------------
        '                   
        if (vtp>0)and(sih=0) then
          '
          'INSERT VTP PLACE
          '
          wm=left(wm,k-1)+htb+"_i_ 0 "+str(cpuw)+" 1 A0 , sys"+cr+mid(wm,k) : k+=21
          w=cpuw : po=w
          '
        end if
        '
        pk=k
        '
        'INHERITED BODY LIST
        '-------------------
        '
        'insert the accumulated subelements
        '
        if len(wih) then
          ws=wih : wih="" : wd=","
          '
          'SPLIT THE STRUCTURE STRING
          '
          wt=" "+mid(wm,pk) : wm=left(wm,pk-1)
          '
          goto insert_subelements
          '
        else
          continue do
        end if
        '
      end if 'end of virtual functions /


      '
      '---------------------------
      'UNIONS AND INNER STRUCTURES
      '===========================
      '
      if unif(uni) then
        '
        'CHECK WITHIN UNION
        '------------------
        '
        if unim(uni) then
          if w>wmx then wmx=w ' MAX VAR OFFSET+SIZE
          w=unio(uni) 'RESTORE OFFSET
        end if
        '
        '
        'CHECK END OF UNION/STRUCT
        '-------------------------
        '
        b=swd
        if unif(uni)=1 then
          if wr="end" then
           if instrword(" union struct ",wordahead(wm,k)) then k=nwd : unif(uni)=a
          end if
        end if
        '
        ' ) } OR END OF UNION/STRUCT
        '---------------------------
        '
        if a=unif(uni) then
          '
          if unim(uni) then
            if w<wmx then w=wmx 'MAX VAR OFFSET+SIZE  IN UNION
          end if
          '
          'SWALLOW WORDS FOLLOWING STRUC/UNION
          '
          do
            if ise(ascn) then exit do else w1=word(wm,k)
          loop
          '
          uni-=1
          mid(wm,b)=space(k-b) 'WIPE
          continue do
        end if
        '
      end if
      '
      'CHECK FOR START OF NESTED UNION / STRUCT
      '----------------------------------------
      '
      d=dic(" struct 1, union 2, type 1,",wr)
      '
      if d then
        uni+=1
        unio(uni)=w : unif(uni)=1 : unim(uni)=d-1 : b=swd
        if isx(ascn) then
          a=k : nextinstruct(wm,k)
          if (ascn<>lbr)and(ascn<>123) then k=a : goto nuname 'brackets not used here
        end if
        if (ascn=lbr)or(ascn=123) then
          'ANONYMOUS
        else
          unin(uni)=word(wm,k)+"." : nextinstruct(wm,k) 'NAME GIVEN
        end if
        '
        '------
        nuname:
        '------
        '
        c=0 : d=1
        '
        if ascn=lbr then d=rbr : k+=1 '(
        if ascn=123 then d=125 : k+=1 '{
        unif(uni)=d
        '
        'CHECK FOR ASSOCIATED STRUC NAME
        '
        if d=125 then
          c=k-1 : capture(wm,m,c,0) : skiplspace(wm,c)
          if ise(ascn)=0 then unin(uni)=word(wm,c)+"." 'capture 1st associated name
        end if
        '
        mid(wm,b)=space(k-b) 'WIPE
        continue do
        '
      elseif a=61 then
        '
        'UNION START MARKER '='
        '
        if w>wmx then wmx=w 'SET UNION MAX SIZE
        w=0 'RESET OFFSET
        mid(wm,swd)=" " 'WIPE
        continue do
        '
      end if 'UNIONS AND INNER STRUCTURES
      '
      '================================
      'TRANSFORM BASIC SYNTAX TO OXYGEN
      'REARRANGE ELEMENT DECLARATION:
      '==============================
      '
      'OVERVIEW:
      '=========
      '
      'C STYLE
      '
      '---------------------------------------------------------------
      ' TYPE/RETURN | NAME | ARRAY OR METHOD/FUNCTION/SUB | (PARAMS) | 
      '===============================================================
      '
      '
      'BASIC
      '
      '-------------------------------------------------------------------
      ' NAME AS | TYPE OR METHOD/FUNCTION/SUB | (PARAMS) | AS RETURN_TYPE |
      '===================================================================
      '
      'TO:
      '===
      '
      '----------------------------------------------------------
      ' TYPE | NAME | METHOD_FLAG: ! | (PARAMS) | AS RETURN_TYPE |
      '==========================================================
      '
      '
      'DECLARE 1 DIM 2 vword
      '---------------------
      '
      dcl=0 : priv=pp
      '
      vword(wm,k,wr)
      '
      if wr="" then
        pp=priv : continue do ' APPLIES TO SEVERAL MEMBERS
      end if
      '
      w1=wordahead (wm,k)
      w2="" : w3=""
      b=swd : n=0 : ascw=0 : indi=0
      '
      '
      '---------------------------
      'SUB FUNCTION METHOD name ..
      '===========================
      '
      mth=dic(" ! 03, sub 01, function 02, method 03, ",wr)
      '
      if mth then
        mid(wm,swd)=space(k-swd) 'BLANK
        '
        a=identype(w1)
        if a then wr=w1 : k=nwd : goto typebfna 'TYPE BEFORE NAME
        '
        w2=w1+"!"
        k=nwd
        n=&h11f
        wr="sys"
        a=k 'HOLDING POSITION FOR LOOKAHEAD
        w1=word(wm,k)
        '
        '
        '----------------------------
        'CHECK FOR CALLING CONVENTION
        '============================
        '
        cco=dic(callco,w1)
        if cco then
          cco-=&h100
          a=k
          w1=word(wm,k)
        end if
        '
        if ascw=lbr then goto pparams else w3="()"  'CREATE EMPTY '()'
        '
        'CHECK FOR RETURN TYPE
        '---------------------
        '
        if w1="as" then
          a=1 : goto astype
        else
          k=a 'backtrack
          ascw=0 : skiplspace(wm,k) : goto reagg 'NO RETURN TYPE
        end if
        '
      end if 'procedures
      '
      '
      'DECLARE name AS TYPE
      '--------------------
      '
      if w1="as" then
        w2=wr : n=1 : k=nwd : a=1 : goto astype
      end if
      '
      '
      if isx(ascn)=0 then
        a=identype(wr)
      else
        a=0
      end if
      '

      '------------------------------------
      typebfna: 'TYPE BEFORE NAME (C STYLE)
      '====================================
      '
      'itr Calling convention
      '
      if (a>0)and(a<&h100)or(a>=512) then
        a=0
        do
          w2=word(wm,k)
          if ascw=42 then a+=1 : continue do
          if w2="ptr" then a+=1 : continue do
          exit do
        loop
        n=1
        if a then w2=string(a,"*")+w2
        '
        'FLAG AS METHOD / ARRAY ETC
        '
        a=0
        '
        if ascn=lbr then
          a=1 : w2+="!" : n=&h11f 'METHOD
        elseif ascn=91 then
          a=1 : n=1 'ARRAY
        end if
        '
        if a then w1=word(wm,k)
        '
      end if
      '
      '
      '--------------------------------------------
      pparams:   '(..) [] ARRAY OR PROCEDURE PARAMS
      '============================================
      '
      if cmo=0 then
        if (w1="(")or(w1="[") then
          k=swd
          capture(wm,m,k,a)
          w3=mid$(wm,m,k-m)
          w1=wordahead(wm,k)
          if w1="as" then k=nwd
          if n=0 then n=1
          if n<2 then wr="sys"
        end if
      end if
      '
      '
      if w1="as" then a=1 else a=0
      '
      '--------------------------------
      astype:  'AS dim type or fun type
      '================================
      '
      if a then
        wr=word(wm,k)
        if ascn=&h70 then
          if wordahead(wm,k)="ptr" then k=nwd : indi+=1 : skiplspace(wm,k)
        end if
        vword(wm,k,wr)
        if ascn=44 then k+=1 'skip comma
      end if
      '
      '
      '----------------------
      'REARRANGE TO O2 SYNTAX
      '======================
      '
      'wr primary type: method or vartype
      'w2 name
      'w3 parameters (..)
      '
      '
      '
      '----------------------------------------
      reagg: 'PUT THE DECLARATION BACK TOGETHER
      '========================================
      '
      if n then
        '
        'INSERT TYPE NAME(!) AS TYPE 
        '
        wm=left(wm,b-1)+wr+" "+w2+" "+w3+cr+mid(wm,k)
        swd=b
        k=b+len(wr)+1
      end if
      '

      bb=swd-1 ' LOCATION OF TRIMBACK POINT
      '
      '
      'IS IT THE DEFAULT TYPE OR
      'IS THE TYPE SPECIFIED BY SIZE?
      '------------------------------
      '
      if (wr="sys")or(mth) then v=cpuw else v=wval(wr)
      '
      lent=v and 31
      '
      '
      'OTHERWISE TRY TO IDENTIFY THE TYPE
      '----------------------------------
      '
      if v=0 then
        n=identype(wr)
        if n<0 then
          '
          'LOOKS LIKE A C TYPE EXPRESSION
          '------------------------------
          '
          ctype(wm,k,wr)
          if wr="void" then typ=cpuw : lent=cpuw 'IN THIS CONTEXT
          v=lent : n=typ ': mid(wm,b)=space(k-b)
          '
        elseif n<512 then
          '
          'COULD BE A PRIMITIVE TYPE
          '-------------------------
          '
          if n=0 then
            '
            'ASSUME UNIDENTIFIED TYPE TO BE SYSTEM TYPE
            '
            n=cpuw : lent=cpuw
            k=swd : wr="sys" 'LONG OR QUAD
          end if 
          v=lent
          '
        else 'n>=512
          '
          'CHECK IF POINTER TO ANOTHER STRUCTURE
          '-------------------------------------
          '
          '
          '
        end if
        if asc(w2)=42 then indt+=1 : k+=1 'indt initially set by identype
        indt+=indi 'indi is ptr flag
        if indt then v=cpuw
      end if
      '
      '
      '
      '=====================
      rprimitive: 'PRIMITIVE
      '=====================
      '
      '
      '
      'PRIMITIVE ELEMENTS AND PROCEDURES
      '---------------------------------
      '
      aml=1 'DEFAULT AS 1 ARRAY ELEMENT
      '
      if v>0 then
        '
        'IF IN C MODE THEN ROUND BRACKETS INDICATE A PROCEDURE POINTER
        '-------------------------------------------------------------
        '
        '
        '
        if ascn=lbr then
          if cmo then
            mth=1 : n=&h11f : k+=1 : skiplspace(wm,k)
            if ascn=42 then k+=1 'SKIP *
          end if
        end if
        '
        a=swd : wn=unin(uni)+word(wm,k)

        if cmo then if ascn=rbr then k+=1 : skiplspace(wm,k) 'SKIP RIGHT BRACKET

        c=ascn
        '
        'ALLOCATE SPACE FOR STATIC ARRAY
        '-------------------------------
        '
        if mth=0 then
          if (c=lbr)or(c=91) then a=k : aml=arraysize(wm,k)
        end if
        '
        'COMPOSE ELEMENT DESCRIPTOR
        '--------------------------
        '
        c=bref
        if cmo then bref=0 'NO AUTO BYREF IN C MODE
        wt=str(w)+" "+str(v)+encodele(wm,wr,k,n,vtl,ws)
        bref=c
        '
        'ADD INSTRUCTION TO VIRTUAL TABLE BUILDER
        '----------------------------------------
        '
        if ctbl then
          if (vtl>0)and(mth>0) then
            if cpuw=4 then
              buil+="o2 e8 00 00 00 00 58 05 gl "+wn+"_"+ws+" 83 c0 06 "+cr+_
              "mov [ecx+"+str(w)+"],eax ;METHOD PTR"+cr ' table build (fwd ref )
            else
              buil+="lea rip rax,"+wn+"_"+ws+" : mov [rcx+"+str(w)+"],rax ; METHOD PTR"+cr
            end if
          end if
        end if
        '
        'INSERT COMPOSED DESCRIPTOR
        '--------------------------
        '
        w+=v*aml            'BYTE OFFSET IN STRUCTURE
        wpr+=htb+wn+" "+wt+cr : skipspace(wm,k)
        '
        'MULTI ELEMENT / PROPERTY
        '------------------------
        '
        'MEMBERS DEFINED TOGETHER EG: SYS A,B,C(10),D
        'this syntax should not be used for methods.
        '
        '
        if ascn=44 then
          k+=1 : nextinstruct(wm,k)
          swd=k : ascn=0
          goto rprimitive 'REPEAT FOR NEXT ELEMENT
        end if
        '
        '
        'OTHERWISE NO FURTHER ELEMENTS IN THIS (COMMA CHAINED) LIST
        '
        'TRIM OFF PROCESSED SCRIPT AND RECOMPOSE BLOCK
        '---------------------------------------------
        '
        w2=rtrim(left(wm,bb))+wpr : wpr="" 
        wm=w2+mid(wm,k) ' reconstruct
        k=len(w2)+1   'SOURCE READER OFFSET
        '
        ' itr space allocated for static arrays
        ' but multidimens not specified (ubound inferred from offs)
        '
        'PROCESS NEXT ELEMENT
        '--------------------
        '
        continue do
        '
      end if 'PRIMITIVES (V>0)
      '
      '#########
      'INHERITED
      '#########
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '#########
      '#########
      '#########
      '
      'GET ELEMENT NAME (OR COMMA FOR INHERITED ELEMENTS)
      '--------------------------------------------------
      '
      skiplspace(wm,k)
      if ise(ascn) then
        wd=","
      else
        wd=word(wm,k)
      end if
      '
      'CHECK FOR ARRAY DEFINITION
      '--------------------------
      '
      'LOOK FOR ROUND OR SQUARE BRACKETS
      '
      if (ascn=lbr)or(ascn=91) then
        aml=arraysize(wm,k) : 'ARRAY SIZE
      end if

      if ascn=97 then if wordahead(wm,k)="as" then k=nwd : w1=wrd(wm,k) ' swallow as ..
      '
      a=n-512 'STRUCTURE INDEX
      e=1
      if a<=0 then e=0
      if e then if wr<>macso(a,0) then e=0
      if e=0 then ers="Undefined "+wr : ert=10 : exit sub
      '
      '
      ws=macso(a,1)
      '
      'CAPTURE INHERITANCE LINKS
      '
      inhs+=" "+str(a)
      m=instr(ws,"$$")
      if m then m+=2 : n=instr(m,ws,"$$") : if n then inhs+=" "+mid(ws,m,n-m)  : ws=mid(ws,n+2)
      '
      m=instr(ws,"/")
      g=1 'select inherited class body size by default
      '
      if vtl=0 then
        if m then ws=mid(ws,m+1) 'OMIT VIRTUAL SECTION IF PARENT IS NOT A CLASS
      else
        'ITR COM LINKAGE
        'if m=0 then ws="/"+cr+ws 'NO VIRTUAL SECTION DEFINED
        '
        if maco(a,4) then
          if ctbl then tbls+=addtablesection(wr,w,a,aoff) : if lclv=0 then aoffs=aoff
          g=4 'read inherited class vtable size
        end if
      end if
      '
      '
      'SPLIT THE STRUCTURE STRING
      '
      wt=" "+mid(wm,k) : wm=left(wm,pk-1)
      '
      '
      'INCORPORATE INHERITED BODY ELEMENT
     '
      if vtl=0 then
        f=1 'INDEX FOR BODY SIZE
        w4=" 1 "
      else
        f=4      'INDEX FOR VTABLE SIZE
        w4=" 2 " 'RENDER STATIC
      end if
      '
      c=maco(a,g) 'SIZE OF INHERITED VTABLE OR BODY
      '
      if wd<>"," then
        wm+=htb+wd+" "+str(w)+" "+str(c)+w4+prf+" A , "+macso(a,0)+cr
      end if
      '
      'CALC OFFSET FOR NEXT INHERITED COMPONENT. (ARRAY SPACE INCLUDED)
      '
      'calculated in advance
      '
      po=w+c*aml
      '
      '
      '==================
      insert_subelements:
      '==================
      '
      '---------------------------
      'PROCESS INHERITED ELEMENTS
      '--------------------------
      '
      b=1
      '
      do 'FOR EACH OF THE INHERITED ELEMENTS
        '
        wn=word(ws,b) 'THE NAME OF THE SUB ELEMENT
        '
        if wn="" then exit do
        m=ascw
        '
        '
        '---------------------------------
        'CAPTURE BODY OF INHERITED ELEMENT
        '=================================
        '
        if m=47 then 
          '
          'end of vt section and start of object body
          '
          '
          if vtl>0 then
            '
            'CAPTURE BODY OF INHERITED COMPONENT
            '-----------------------------------
            '
            vo+=maco(a,1) ' accum size of objects
            vq=vo         ' hold vt offset
            '
            'CHECK FIRST IF THERE ARE ANY ELEMENTS IN THE BODY
            '-------------------------------------------------
            '
            nextinstruct(ws,b)
            '
            if len(ws)>=b then
              wih+=" ?"+str(a)+" "+wd+" "+mid(ws,b)
            end if
            '
          end if
          '
          ws="" : exit do ' captured body section
          '
          'previously held over for the body section
          'It is assumed that we are in in the parantal body section.
          '
        elseif m=63 then 
          '
          'INSERT BODY OF INHERITED SUBELEMENTS INTO MAIN BODY ('?' MARKER)
          '----------------------------------------------------------------
          '
          a=wval(word(ws,b)) ' index
          wd=word(ws,b)     ' type/inherited structure
          wn=word(ws,b)     ' name
          '
          'BODY OFFSET (allowing for static arrays )
          '
          w=po : po=w+maco(a,1)
          '
          '
          'INCORPORATE INHERITED STRUCTURE NAME
          '
          '
          'A HEADER IS ADDED DESCRIBING THE WHOLE INHERITED STRUCTURE
          '
          if wd<>"," then
            '
            'another of these may be present in the virtual section.
            wm+=htb+wd+" "+str(w)+" "+str(maco(a,1))+" 1 "+prf+ " A , "+macso(a,0)+cr
          end if
          '
        end if
        '
        'READ ATTRIBUTES OF EACH INHERITED ELEMENT
        'Recalculate offsets make other adjustments.
        'This applies to both virtual and body sections.
        '
        v=wval(word(ws,b)) ' OFFSET
        w3=word(ws,b)      ' SIZE
        w4=word(ws,b)      ' VAR/FUNCTION CODE (VARF)
        prf=word(ws,b)     ' PUBLIC/PROTECTED/PRIVATE
        '
        'CAPTURE REST OF ATTRIBUTES: CCO VDV SIG SOG PRIV
        '
        c=b : endline(ws,b)
        w5=mid(ws,c,b-c) ' PARAM SIGNATURES
        '
        'ADJUST VAR/FUNCTION CODE VARF
        '-----------------------------
        '
        if vtl then 
          n=wval(w4) ' varf
          m=n
          if n=1 then n=2 'RENDER STATIC
          if sih=0 then
            if n=9 then n=10 'SIGNIFIES INHERITED METHOD
            if n>=10 then
              n+=vq
              if vtp then n+=cpuw 'FURTHER OFFSET IF VTP IS PRESENT
            end if
          end if
          if n<>m then w4=str(n) 'CONVERT BACK TO STRING
        end if
        '
        'PRIVATE FLAG
        '
        'if asc(w5,len(w5))=45 then
        if prf="0" then
          wn="__" ' disinherit name ' priv=1 only
        end if
        '
        'PREFIX NAME DOT TO GIVE THE LOCAL NAME
        '
        if wd<>"," then wn=wd+"."+wn 'IF WD IS A COMMA THEN USE THE ORIGINAL NAME
        '
        '
        'APPEND RECONSTITUTED DESCRIPTOR
        '-------------------------------
        '
        'start with tab
        '
        'add element with adjusted offset
        '
        wm+=htb+unin(uni)+wn+" "+str(v+w)+" "+w3+" "+w4+" "+prf+" "+w5+cr
        '
        '
      loop ' EACH INHERITED SUB ELEMENT
      '
      '
      w=po        'UPDATE OFFSET FOR VFT OR BODY
      k=len(wm)+2 'NEXT LINE TO PROCESS
      '
      'REASSEMBLE MAIN STRUC STRING
      '
      wm+=wt
      '
    loop 'EACH ELEMENT IN MAIN STRUCTURE
    '
    '
    '------------------------------
    'STORE COMPLETED DATA STRUCTURE
    '==============================
    '
    maco(me,5)=vtp
    '
    'COMPACT
    '
    'w1=cr+cr+cr : a=0
    'do
    '  a=instr(wm,w1)
    '  if a then wm=left(wm,a+1)+mid(wm,a+5) else exit do
    'loop
    if len(inhs) then wm="$$ "+inhs+" $$"+cr+cr+wm
    macsi(wm,me,1)
    if wmx>w then w=wmx 'MAX SIZE FOR UNIONS
    maco(me,1)=w        'LENGTH OF STRUCTURE
    '
    '
    'SOURCE LISTING
    '
    if vew>0 then
      appendt(cr+"skip"+sp+"TYPE: "+macso(me,0)+cr+cr+macso(me,1)+cr+"END TYPE"+ep) : bg=j
    end if
    '
    addme()
    '
    '---------------------
    'VIRTUAL TABLE BUILDER
    '=====================
    '
    if ctbl then
      '
      'INFER BASE ADDRESS OF VFT
      '
      a=aoff : if asce<0 then a-=cpuw 'MAY BE LOCAL OR STATIC
      b=me-1
      '
      'VFT BUILDER TO GO AT TOP OF METHODS BLOCK
      '
      w1="push "+qecx+" : lea "+qecx+cm+memreg(regs,a)+cr+buil+"pop "+qecx+cr
      macsi(tbls+w1,b,3)
      '
      'DECLARE THE VACANT VIRTUAL FUNCTION TABLE IMMEDIATELY AFTER CLASS
      '
      w1="sys "+macso(b,0)+"_table("+str(maco(b,4)/cpuw)+")"
      vars(w1,1)
      '
      '
    end if
    '
    '
end sub




'---------------------------------------------------------------------------------------
sub declvars(byref s as string, byval n as sys, byref wa as string, byval noinit as sys)
'=======================================================================================
  dim as sys a
  '
  if n<10 then
    '
    if n=1 then
      localvars()
    elseif (n=3)or(n=4) then
      staticvars()
    end if
    '
    'SETTING A CONSTANT
    '
    if cnst then
      vars(word(s,1)+" "+wa,1)
      wa=""
      exit sub
    end if
    '
    a=aoff : vars(s+"",1) : a-=aoff
    '
    if n=1 then
      if a>0 then wa=stackspace(a,noinit)+wa
    end if
    '
  else 'n>=10
    if n<>18 then wva(n)+="var "+s+cr 'PARAMS DEFERRED
  end if
  '
end sub


'-----------------------------------------------------------------
sub varsal(byref s as string, byref i as sys, byval noinit as sys)
'=================================================================
  dim as sys a
  if o2h then
    if funi then localvars() : lcl(funi)=1 else staticvars()
    a=aoff : vars(s,i) : a-=aoff
    '
    'ALLOCATE SPACE ON STACK FOR LOCAL VARIABLES
    '-------------------------------------------
    '
    if a>0 then appendt(stackspace(a,noinit))
  else
     vars(s,i)
  end if
end sub



