

'       ################
'      #     #          #
'     #       #          #
'    #         #          #
'    #         #          #
'    #      #  #  #    #  #  #
'    #       #####      #####
'    #        ###        ###
'    #         #          #
'    #         #          #
'    #########            #
'    #                    #
'    #                    #
'     #                  #
'      #################
'            #
'           ###
'            # 
'
'  ########################

'  END OF PREPROCESSOR LOOP

'  ########################



'

'=====
finap:
'=====
'   
'   =========================
'   |  |      |   |   || | | |
'   |  | O2   |   |   || | | |
'   |H | O2H  |   |   || | |F|----------> ASSEMBLER
'   |  |      |   |   || | | |
'   |  |      |   |   || | | |
'   =========================
'

'
'  SAVE REGISTERS
'  BOOTSTRAP
'  ALLOCATE STATIC MEMORY
'  FREE LIBRARIES
'  FREE MEMORY
'  RESTORE REGISTERS
'

  if ert=0 then if brc>0 then ers=str(brc)+" excess left brackets in source ((..) " : ert=10
  '
  'TRIM MAIN CODE
  '--------------
  '
  t=left(t,j-1)+cr
  '
  '
  '=============
  'O2H CODE PREP
  '=============
  '
  'BSS DATASPACE ALLOCATION
  '------------------------
  '
  '
  if dep then
    w6="" 'SECONDARY (DYNAMIC) COMPILING TO MEMORY ONLY
  else
    w6=".bssdata"+cr+"$"+hex(sizebss()) 'PRIMARY COMPILING
  end if

  'INITIALISED DATA
  '----------------
  '
  w7="._data"+cr+left(dats,dati)+cr+"00 01 `end_of_data` 01 /+1000"+cr
    '


    '
  if dep then
      '
    w3="" : w4=cr+"._end_"+cr+"ret"+cr 'SHARE PARENTAL STATE
      '
  else 
    '
    '
    'PROGRAM ENTRY FOR PRIMARY COMPILED CODE
    '=======================================
    '
    '---------------------------------------
    'CREATE BSS STATIC SPACE FOR GLOBALS ETC
    'THEN COPY RUNTIME LIBRARY INTO BSS
    '---------------------------------------
    '
    aoff+=15 : aoff and= &hfffffff0  'ROUND UP TO NEAREST 16
    '
    '
    'CODING FOR COMBINED RTFT AND SVT (only ebx is used, esi is free)
    '
    'copy 0-399 then 2048 to 4095 of the RTFT
    'the .bss section is assumed to be pre-initialised with nulls
    '
    w3="mov edi,ebx : call get_bss : mov ebx,eax : mov esi,eax : mov ecx,100"+cr+_
    "(: mov eax,[edi] : mov [esi],eax : add edi,4 : add esi,4 : dec ecx : jg repeat :)"+cr+_
    "add edi,1644 : add esi, 1644 : mov ecx,512"+cr+_ '2048-400-4
    "(: mov eax,[edi] : mov [esi],eax : add edi,4 : add esi,4 : dec ecx : jg repeat :)"+cr
    '
    'NB: STATIC DATA IS PERSISTENT BETWEEN CALLS
    '
    w4=cr+"._end_"+cr+"ret"+cr
    '
  end if


  if (o2h<>0)and(independent=0)and(dep=0) then
    '
    'PROGRAM ENTRY CODE, EXIT CODE
    '-----------------------------


    'PROVIDE PERSISTENT STORAGE FOR EBX AND ESI
    '------------------------------------------
    '
    'EBX contains base address of runtime procedure table


    '-----------------
    'MAIN BASIC PROLOG
    '=================
    
    w3="jmp fwd _main"+cr+_
    "._mem : call get_bss : mov ebx,eax : ret"+cr+_                     'RECOVER EBX
    "._newbuf : push 4096 : push 0  : call [ebx+160]"+cr+_              'CREATE A SYSTEM BUFFER
    "  mov ecx,4096 : mov edx,eax"+cr+_                                 '
    "  ( : mov [edx],0 : add edx,4 : sub ecx,4 : jg repeat : )"+cr+_    '
    "  mov [edi],eax : add edi,8 : ret"+cr+_                            '
    "._main"+cr+_                                                       'START HERE
    "  push ebp : mov ebp,esp : push ebx : push esi : push edi"+cr+_    'SAVE REGISTERS
    w3+_                                                                'CREATE INTIALISED STATIC SPACE
    "  lea edi,[ebx+640]"+cr+_                                          'CREATE SYSTEM BUFFERS 
    "  call _newbuf : call _newbuf : call _newbuf : call _newbuf"+cr+_  '640 to 664
    "  lea edi,[ebx+680] : call _newbuf"+cr+_                           'SET UP BUFFER FOR  LIB HANDLES
    cr
    '
    '
    '-----------------
    'MAIN BASIC EPILOG
    '=================
    '
    'RESTORE REGISTERS AND RETURN
    '----------------------------
    '
    w4=cr+"._end_"+cr+"pop edi : pop esi : pop ebx : mov esp,ebp : pop ebp : ret"+cr+cr
    '
  end if
  '

   'FATAL ERRORS
  '============
  '
  w4+="._error_"+cr+"push ecx : call [ebx+2048] : jmp _end_"+cr   'MBOX
  if dep=0 then
    w4+=".get_bss : call fwd here : .here : pop eax : sub eax,here : add eax,bssdata : ret"+cr
  end if
  '


  if independent then 'INDEPENDENT MODE
    w3="" : w4=""
  end if
  '
  '
  '-----------------------------------------------------------------
  'EXTRACT ALL STATIC ITEMS FROM MAIN BODY AND PLACE ABOVE MAIN BODY
  '=================================================================
  '
  'these are sections between sq and eq markers
  '
  a=1 : k=1 : wm=""
  '
  'FOR THE BENEFIT OF INDEPENDENT CODE
  '
  b=instr(t,"._statics_")
  if b then
    b+=10 : w2=left(t,b-1)+cr : t=mid(t,b)
  else
    w2=""
  end if
  '
  c=len(t)
  '
  do
    a=instr(a,t,sq)
    if (a=0)or(a>c) then exit do
    '
    'OMIT START MARKER
    '-----------------
    '
    a+=1
    '
    'LOCATE END MARKER
    '-----------------
    '
    b=instr(a,t,eq)
    if (b=0)or(b>c) then exit do
    '
    'GET LENGTH BETWEEN MARKERS
    '--------------------------
    '
    d=b-a
    '
    'ADD SECTION TO BUFFER
    '---------------------
    '
    if d then appendm(wm,k,mid(t,a,d))
    '
    'CUT SECTION FROM T,  INCLUDING MARKERS
    '--------------------------------------
    '
    a-=1 : b+=1 : mid(t,a)=mid(t,b)
    '
    'DEDUCT SECTION LENGTH (& MARKERS) TO GET CURRENT T LENGTH
    '---------------------------------------------------------
    '
    c=c-d-2
    '
  loop
  '
  '
  'RECOMPOSE CODE
  '--------------
  '
  t=w3+w2+left(wm,k-1)+left(t,c)+w4
  '
  '
  '
  '==========
  'PE HEADERS
  '==========
  '
  if pef then
    '
    restore pe_header  : w1=readin()
    a=instr(w1,"^")
    b=instr(w1,"*") 'FIRST SUBSTITUTION WILL BE FOR MAGIC NUMBER
    if pem=64 then
      w2="hq"
      w3="2" 'MAGIC NUMBER 020B
      lineblank(w1,a) 'OMIT
    else
      w2="hl"
      w3="1" 'MAGIC NUMBER 010B
      mid(w1,a)=" "
    end if
    mid(w1,b)=w3          'MAGIC NUMBER
    b=instr(b,w1,"*")     'LOCATE NEXT PATCH
    mid(w1,b)=chr(&h32+cnsl) 'SUBSYSTEM 2 OR 3 (3=EXISTING CONSOLE)
    replace w1,"h?",w2    'LONGS (OR QUADS FOR PE32+)
    '
    '
    restore dos_header : w1=readin()+w1
    '
    restore pe_imports : w4=readin
    if pem=64 then w2="gq" : w3="hq" else w2="ga" : w3="hl"
    replace w4,"g?",w2 'ABSOLUTE LONG ADDRESS (OR QUAD FOR PE32+)
    replace w4,"h?",w3 ' LONG NULL (OR QUAD NULL FOR PE32+)
    '
    ' w1 dos header+coff header+optional header
    ' w4 imports section
    '
    ' -----------
    ' bss mapping
    ' ===========
    '
    ' [edi+600] IMPORT FUNCTIONS ADDRESS LIST (BOOTSTRAP LIBRARY)
    ' [edi+608] PROCESS HANDLE
    ' [edi+615] OXYGEN LIBRARY HANDLE
    '
    '
    '
    if independent then
      '
      w2="" : w3="" : wm="" 'OXYGEN NOT USED AT RUNTIME
      '
    else
      '
      'REQUIRES OXYGEN.DLL
      '
      w2="finit : call fwd get_oxygen : cmp eax,0 : jz fwd nend"+cr+_     'FIND OXYGEN DLL O2_LIB
      "call eax : mov ebx,eax"+cr                                         'CALL O2_LIB AND GET O2 RTL TABLE BASE IN EBX
      '
      w3="push [edi+616] : call [ebx+8]"+cr 'FREE OXYGEN LIBRARY
      ' 
    end if
    ' 
    if independent then goto nwrapped
    '


    '-----------------
    if pef=1 then 'DLL
    '=================

      wm="mov eax,[esp+8]"+cr+_
      ".cas : cmp eax,0 : jnz fwd cas : call fwd dll_finish : mov eax,0 : ret 12"+cr+_
      ".cas : cmp eax,1 : jnz fwd cas : call fwd dll_start  : mov eax,1 : ret 12"+cr+_
      ".cas : cmp eax,2 : jnz fwd cas : mov eax,1 : ret 12"+cr+_
      ".cas : cmp eax,3 : jnz fwd cas : mov eax,0 : ret 12"+cr+_
      ".cas : ret 12"+cr+_
      ".dll_start"+cr+_
      "  push ebx : push esi : push edi"+cr+_                             'MOUNT
      "  call get_bss : mov edi,eax"+cr+_                                 'RECORD BOOT INFO
      "  call fwd get_iat : mov ebx,eax : mov [edi+600],ebx"+cr+_         'FOR BOOTSTRAP LIBRARY
         w2+_                                                             'RETURN OXYGEN RTL BASE IN EBX
      "  call fwd _o2_"+cr+_                                              'MAIN PROGRAM
      ".nend : pop edi : pop esi : pop ebx : ret"+cr+_                    'DONE
      ".dll_finish : push ebx : push esi : push edi"+cr+_                 'DEMOUNT
      "  call fwd finish : "+cr+_                                         'USER TERMINATIONS
      "  call get_bss : mov edi,eax : mov ebx,[edi+600]"+cr+_             'BOOTSTRAP LIB TO DEMOUNT OXYGEN
         w3+_                                                             'RELEASE OXYGEN
      "pop edi : pop esi : pop ebx : ret"+cr                              'EXIT
      '
    '--------
    else 'EXE
    '========
      '
      wm=cr+_ 'push ebx : push esi : push edi"+cr+_                       'MOUNT
      "call get_bss : mov edi,eax"+cr+_                                   'RECORD BOOT INFO
      "call get_iat : mov ebx,eax : mov [edi+600],ebx"+cr+_               'FOR BOOTSTRAP LIBRARY
      "push 0 : call [ebx+12] : mov [edi+608],eax"+cr+_                   'PROCESS MODULE HANDLE
      w2+_                                                                'RETURN OXYGEN RTL BASE IN EBX
      "call fwd _o2_"+cr+_                                                'MAIN PROGRAM
      "call get_bss : mov edi,eax : mov ebx,[edi+600]"+cr+_               'GET BOOTSTRAP TO DEMOUNT OXYGEN
      w3+_                                                                'RELEASE OXYGEN LIB HANDLE
      ".nend : push 0 : mov eax,esp : push eax : push [edi+608]"+cr+_     'PUSH MODULE HANDLE
      "call [ebx+20] : call [ebx+24]"+cr 'GetExitCodeProcess ExitProcess  'GET EXIT CODE : EXIT PROCESS
      '
    end if
    '
    w2=".get_iat : call fwd here : .here : pop eax : sub eax,here : add eax,import_address_table : ret"+cr+_
    ".get_bss : call fwd here : .here : pop eax : sub eax,here : add eax,bssdata : ret"+cr
    '
    '
    '
    '-------------------------
    'ACCESS TO RUNTIME LIBRARY
    '=========================
    '
    '
    '
    if hostdll="" then
      hostdll=".nconfig"+cr+"push 0x00006c6c : push 0x642e6e65 : push 0x6779786f : mov eax,esp"+cr+_ 'oxygen.dll'
      "push eax : call [ebx] : add esp,12 : cmp eax,0 : jnz fwd ndll"+cr+_
      "pushad : sub esp,32 : mov ecx,esp : mov [ecx],0x324f : mov [ecx+4],0x6779786f : mov [ecx+8],0x642e6e65"+cr+_
      "mov [ecx+12],0x003f6c6c : push 0 : push ecx : add ecx,4 : push ecx : push 0 : call [ebx+44] : add esp,32 : popad"+cr+_ 'message
      ""
    end if
    '
    '
    ' oxygen.ini or fixed path
    ' ------------------------
    '
    'oxygen.ini : oxyg en.c fg__'  in reverse : __gf c.ne gyxo :  0000676f 632e6e65 6779786f
    w3="push 0x00006766 : push 0x632e6e65 : push 0x6779786f : mov eax,esp"+cr+_
    "push 0 : push 128 : push 3 : push 0 : push 1 : push 0x80000000 : push eax : call [ebx+28]"+cr+_ 'Createfile
    "add esp,12 : cmp eax,0 : jz fwd nconfig : mov esi,eax"+cr+_
    "sub esp,2052 : mov edi,esp : mov [edi],0"+cr+_ 'CREATE buffer
    "push 0 : mov eax,esp : push 0 : push eax : push 2048 : push edi : push esi : call [ebx+32]"+cr+_ 'readfile
    "push esi : call [ebx+36]"+cr+_ 'close handle
    "mov ecx,edi : dec ecx : ( : inc ecx : mov al,[ecx] : cmp al,32 : ja repeat : ) : mov [ecx],0"+cr+_ place null terminator
    "push edi : call [ebx] : add esp,2056 : cmp eax,0 : jnz fwd ndll"+cr+_ 'attempt to load oxygen ' free config buffer
    hostdll
    '
    '
    wm+=w2+_
    ".get_oxygen"+cr+_
    "push edi"+cr+w3+"pop edi : ret"+cr+_ 'DEPENDING ON DLL AND PATH
    ".ndll"+cr+_
    "pop edi : mov [edi+616],eax"+cr+_ 'SAVE O2 LIB HANDLE 'get proc address 'o2_lib'
    "mov edx,eax : sub esp,16 : mov eax,esp : mov [eax],0x6c5f326f : mov [eax+4],0x00006269"+cr+_
    "push eax : push edx : call [ebx+04] : add esp,16 : ret"+cr+_ 'GetProcAddress of o2_lib
    cr
    '
    '
    '
    '--------
    nwrapped:
    '========
    '
     '
    '------------
    'EXPORT TABLE
    '============
    '
    w2="" : w3=""
    '

    if eord then
      w3=" hl"+hex(eord)
      w2=""+cr+cr+_
      ".exports hl0 hl0 hl0 ga export_name"+cr+_
      "hl1"+w3+w3+" ga export_funcs ga export_names ga export_ordls hl0"+cr+_
      "/+4 .export_name `"+pexn+"` 00"+cr+_
      exportdata(eord)+_
      cr+"01 `end_of_exports` 01"+cr+"/+1000"+cr
      w3=""
      expf=1
    end if
    '
    w5="" : rsrf=0
    '
    #include "o2reso.bas" 'RESOURCES SECTION




    '-----------------
    'SECTION DIRECTORY
    '=================
    a=128
    '
    'EXPORT SECTION
    '--------------
    '
    if expf then w3="ga exports" else w3="hl0"
    w1+=w3+" hl0"+cr : a-=8'EXPORT SECTION
    '
    'ALWAYS AN IMPORT SECTION
    '------------------------
    '
    w1+="ga imports hl200"+cr : a-=8
    '
    'EMBEDDED RESOURCES SECTION
    '--------------------------
    '
    if rsrf then w3="ga resources" else w3="hl0"
    w1+=w3+" hl0"+cr : a-=8
    '
    'PAD OUT REST OF DIRECTORY WITH NULL ENTRIES
    '-------------------------------------------
    '
    w1+="$"+hex(a)+cr


    '-------------------------------------
    'SECTION TABLE/HEADERS (40 BYTES EACH)
    '=====================================
    '
    'following section directory of 16 entries = 80h bytes
    'BASE ADDRESS RVA 178 or 188 in PE32+
    '
    '
    'with default values
    '
    '----------------------------------------------------------------------------------------'
    '                  name                virtsz virtaddr      rdsz  rdpt..  characteristics'
    '========================================================================================'
    '                  0                   8       12           16      20... 36             '
    '----------------------------------------------------------------------------------------'
                 w1+= "`.text`    00 00 00 hl0000  ga _code_    hl0000  $10   hl60000020"+cr ' code executable readable
                 w1+= "`.data`    00 00 00 hl4000  ga _data     hl0200  $10   hlc0000040"+cr ' initialised readable writable
                 w1+= "`.bss`  00 00 00 00 hl4000  ga bssdata   hl0000  $10   hlc0000080"+cr ' uninitialised readable writable
    if expf then w1+= "`.edata`      00 00 hl0200  ga exports   hl0200  $10   hlc0000040"+cr ' initialised readable writable
                 w1+= "`.idata`      00 00 hl0200  ga imports   hl0200  $10   hlc0000040"+cr ' initialised readable writable
    if rsrf then w1+= "`.rsrc`    00 00 00 hl0200  ga resources hl0200  $10   hl40000040"+cr ' initialised readable
    '----------------------------------------------------------------------------------------'
    '
    'field descriptions
    '------------------
    '
    ' 00  name upto 8 bytes
    ' 08  virtual size (this is null padded if freater than the raw data size)
    ' 12  virtual address (offset in memory 4096 byte steps)
    ' 16  raw data size (rounded to 512 bytes)
    ' 20  raw data offset in file (512 byte steps)
    ' 24  pointer to relocations (null)
    ' 28  pointer to line numbers (null)
    ' 32  Number of relocations   (0)
    ' 34  Number of line numbers  (0)
    ' 36  Characteristics Bits:
    '      00 reserved
    '      01 reserved
    '      02 reserved
    '      04 reserved
    '      08 obsolete
    '      10 reserved
    '      20 contains executable code
    '      40 contains initialised data
    '      80 contains uninitialised data
    '     100 reserved     
    '     200 reserved contains comments (object files only)
    '     400 reserved
    '     800 will not become part of image (object files only)
    '    1000 contains COMDAT data
    '    8000 contains data referenced through global pointer
    '   10000 reserved
    '   20000 reserved
    '   40000 reserved
    '   80000 reserved
    '  100000 align on 1 byte boundary (object files only)
    '  200000 align on 2 byte boundary (object files only)
    '  300000 align on 4 byte boundary (object files only)
    '  400000 align on 8 byte boundary (object files only)
    '  500000 align on 16 byte boundary (object files only)
    '  600000 align on 32 byte boundary (object files only)
    '  700000 align on 64 byte boundary (object files only)
    '  800000 align on 128 byte boundary (object files only)
    '  900000 align on 256 byte boundary (object files only)
    '  A00000 align on 512 byte boundary (object files only)
    '  B00000 align on 1024 byte boundary (object files only)
    '  C00000 align on 2048 byte boundary (object files only)
    '  D00000 align on 4096 byte boundary (object files only)
    '  E00000 align on 8192 byte boundary (object files only)
    ' 1000000 contains extended relocations
    ' 2000000 can be discarded
    ' 4000000 cannot be cached
    ' 8000000 is not pageable
    '10000000 can be shared in memory
    '20000000 can be executed as code
    '40000000 can be read
    '80000000 can be written to


    'THIS JUMP WILL NOT APPEAR IN THE PE FILE
    '
    w1+="/0ff0 e9 gf _o2_ "+cr+"/+1000"
    '
    '---------------------------
    'BRING ALL SECTIONS TOGETHER
    '===========================
    '
    'also adding section for uninitialised data (.bss)
    '
    '
    function="o2 ("+cr+w1+ep+"._code_ : ._main_"+cr+wm+"._o2_"+cr+t+"o2 01 `end_of_code` 01 /+1000"+cr+_
    "o2"+sp+".base_of_data"+cr+w7+w6+cr+w2+w4+w5+ep


  '------------------------------------------------------
  else 'NOT PE FORMAT BUT DIRECTLY EXECUTABLE CODE STRING
  '======================================================


    if dep then
      function=t 'SECONDARY COMPILE
    else
      function=t+"o2"+sp+"/+1000 "+cr+w7+w6+ep 'PRIMARY COMPILE
    end if



  end if
  '
  '
  '
  'DIAGNOSTICS
  '-----------
  '
  'if vew=0 then open "t.txt" for output as 3 : print #3,t+"o2"+sp+"/+1000 "+cr+w7+w6+ep : close 3

  '
  if len(ers) then if ert=0 then ert=1000
  '
  '

  '
  'cleardown_prep:
  '----------------
  '
  s="" : t="" : impo=0 : libe=0 : o2h=0 : lbw="" : ipath="" : lpath="" : opns="" : opnsl=""



  'END FIN
