  ' 06:49 09/06/2008 structures variables,arrays data & macro % params
  ' 10:26 19/06/2008 symbol = () = {} etc 
  ' 12:00 21/06/2008 macro params %a %b %e
  ' 20:15 24/06/2008 symbol pair macros and vald strd functions
  ' 11:36 29/06/2008 macro names containing several words and symbols `:)` `:D` `++` `old harry` etc
  ' 11:29 04/07/2008 reincorporate o2asm.dat back into dll
  ' 17:55 20/08/2008 s=`hello` and fix mixed macro params
  ' 19:18 23/08/2008 add line break %l to macro params. Fix thinCore ParseString bug
  ' 09:48 27/08/2008 OOP with virtual tables
  ' 23:16 27/08/2008 indirection asignment *s=sizeof a
  ' 09:48 31/08/2008 function signature checking and function overloading. also `with` function
  ' 06:19 01/09/2008 static scoping (maintaining indexer). also KERNEL const
  ' 04:49 02/09/2008 composites, typeof
  ' 05:32 05/09/2008 'of' single inheritance for COM. also simpler unstructured vt
  ' 15:26 07/09/2008 '-' private members and abstract members . also fix hash array carryover
  ' 21:20 08/09/2008 defs
  ' 04:42 10/09/2008 use sysalloc for getmemory
  ' 09:29 17/09/2008 & dynamic objects. Also remove reg asignments redundant ops
  ' 17:07 21/09/2008 indexers local indexers static.  colon statement separators :
  ' 21:15 22/09/2008 structureof scriptof typeof statusof
  '-------------------------------------------------------------------------------------------
  ' 27/09/2008  o2h commenced
  ' 01/06/2010  64bit encoding
  ' 04/07/2010  implicit this masks global variables but not kernel symbols
  ' 05/0702010  real line numbers and error trapping
  '-------------------------------------------------------------------------------------------
  '
  '09:04 27/06/2010
  '
  '
  '===========================
  'PREPROCESSOR FOR O2 AND O2H
  '===========================


  'RESOLVE HIGH LEVEL EXPRESSION, MACROS ETC INTO ASSEMBLER


  '----------------------------------------------
  function translate(byref ss as string) as string
  '==============================================


  '===========================
  'LOCAL VARIABLES DESCRIPTION
  '===========================

  ' s     source string
  ' fp    include string index
  ' qf    inline quote flag
  ' nl    new line flag (used to check for colon labels)
  ' i     source index
  ' sst() source string buffers for include
  ' a     general ascii value
  ' k     general purpose
  ' m     general purpose
  ' n     general purpose
  ' v     general purpose
  ' w     general purpose
  ' w1    param
  ' w2    param
  ' w3    param
  ' w4    param
  ' w5    param
  ' w6    param
  ' w7    param
  ''' wc    inherited elements to append
  ' wd    word string
  ' wr    word string
  ' wm    word string
  ' wn    word string
  ' ws    word string
  ' wt    word string
  ' typo  type definition flag
  ' aoff  offset value for local vars etc
  ' poff  previous offset
  ' sregs nesting for indexers
  ' asce  ascending/descending flag
  ' regs  macro used to specify index regs for variables
  ' adr   address indirection flag for proc params
  ' sigs  parameters type signature
  ' sigd  parameters indirection signature
  ' mq1   hold index mq
  ' mqf   hold proc descriptor mq
  ' mqp   proc mq
  ' op1   hold op
  ' opp   proc op
  ' sih   single inheritance
  '-------------------------
  ' typa  type of variable
  ' typa1 type of first variable
  ' typa1 length of first variable
  ' typc  type of accumulator in use
  ' typp  return type of procedure
  ' ccp   call convention type of provedure
  ' typl  left hand (assigment type in use
  ' bs    bracketed expression present and skipped
  ' va    hold varf
  ' bv    byval flag
  ' tpt   indirection counter
  ' psg   preassign string
  ' wsg   preassign operand
  ' ali   alias   for imported or expoted functions
  ' lby   library for imported functions
  ' it    identified type
  ' atf   flag indicating exported function
  ' lcl   flag stack params or locals
  ' lcls  flag local/param strings used
  ' blcl   block local ebp code (positions)
  ' tm    t marker for splitting t
  ' dc dd de def flags
  ' fro   for flag
  ' prf   private flag for inherited elements
  ' noin  noinit flag prevents local vars being set to 0
  ' ctbl  class table flag
  ' wlc   wlc local vars flag
  ' eord  export ordinal counter
  ' mage  binary image (for pe formatting)
  ' clss  class record
  ' clsi  class level
  ' reto  tally offset for ret n instruction
  ' retb  tally base offset for ret n instruction
  ' th    ths this flag holder
  ' ml    mp lower local boundary holder
  ' tdst  typedef struc flag
  ' un    outer union flag
  ' dcp   declared C prototype
  ' deco  C style typdef function function flag
  ' pn    parameter counter for function prototypes
  ' leaf  leaf flag
  ' fql   include filename and hash array index
  ' agt   assignment flag for ':='
  ' ccx   calling convention extern block default
  ' atx   external flag block default for proc internals
  ' etx   export flag block default for proc internals
  ' wx    headers for exposed procedures
  ' opa   flag for optional params
  ' byl   array byref local flag
  ' typd  inferred type in dim/declare statements
  ' cnsl  console mode flag for PE file SubSytem 3 (normally 2)


  '===============
  'LOCAL VARIABLES
  '===============


  dim as sys a,b,c,d,e,f,i,k,m,n,p,q,u,v,w,qf,nl,typo,poff,pk,adr,mq1
  dim as sys bs,va,bv,tpt,it,tm,dc,dd,de
  dim as sys op1,typa,typc,typa1,typl,lent1,mqf,mqp
  dim as sys opp,fro,ctbl,wlc,eord,clsi,tdst,un,dcp,deco
  dim as sys clss(31),pn,leaf,fql,agt,ccx,atx,etx,opa,byl,typd,cnsl

  dim as sys relaxed=1,independent=0,linemarkers=1


  dim as string w1,w2,w3,w4,w5,w6,w7,wd,wm,wn,wr,ws,wt,s
  dim as string psg,wsg,ali,lby,sigs,sigd,prf,mage,wx

  '==============
  'INITIALISATION
  '==============

  start_prep:


  s=ss+cr
  if linemarkers then lineMark(s)
  t=space(len(s)+1000)
  i=1 : j=1
  '
  mex=len(s)*10+100000
  if mex<2e6 then mex=2e6

  GlobalClear()
  regnames() 'DEFAULT TO 32 BIT REGISTERS


  'skiplspace(s,i) : wr=wordahead(s,i)


  if dep then goto mainstart 'BYPASS FOR SECONDARY COMPILING


  '
  'STATICS OFFSET
  '--------------
  '
  'The run-time function table is combined with static variable table 
  '
  aoff=&h1000 'COMBINED RTFT AND SVT


  minormajor=0 'SET ARRAY DESCENDING ORDER (C STANDARD)




  sps=string(4000000,chr(0)) : spe=8 ' STRING POOL BUFFER



  '=========================
  'LOAD ASSEMBLy CODE TABLES
  '=========================


  if ope=0 then
    loadops() ' loads assembler once when required
    if ert>0 then ope=0: goto exitap
  end if
  '
  '=======================
  'EMPTY DEFINITION TABLES
  '=======================
  mle=512
  init4 @mach(0),mle*smach,0  'clear hash table base
  init4 @maco(0,0),me*smaco,0 'clear previous
  me=1 : mp=0

  ixb=1 'DEFAULT INDEX BASE



  '===============
  'LOAD INTRINSICS
  '===============

  restore kernel_funs

  do
    read w1,a
    if w1="" then exit do
    macsi(w1,me,0) : addmin(me) : maco(me,0)=a
    if a=-9 then
      read maco(me,3)
    elseif a=-4  then
      read b : w1="[ebx+"+str(b)+"]" : macsi(w1,me,1) 'INTRINSIC O2 PROCS
    elseif (a=-1)or(a=-17)or(a=-19) then
      read w1 : macsi(w1,me,1)      ' INTRINSIC MACROS
    elseif a=-10 then
      read maco(me,1),maco(me,2),maco(me,3)            ' REGISTERS
    elseif (a<=-11)and(a>=-15) then
      read maco(me,3)
      if a=-15 then read b : maco(me,5)=b : maco(me,1)=b and 31
    elseif a=-16 then
      read w1 : macsi(w1,me,3)                         ' INTRINSIC OVERLOADED O2H PROCS
    end if
    me+=1
  loop


  'FIRST WORD COMMANDS

  'to come before declarations


  w1=wordahead(s,i)
  if w1="#view" then vew=2 : i=nwd
  if w1="#prep" then vew=3 : i=nwd



  '
  '####################
  '
  ' #######    ######                  #
  '  ##    #  #      #                 ##
  '  ##    #  #      #  ###################
  '  ##    #  #      #  ### MAIN ############
  '  ##    #  #      #  ###################
  '  ##    #  #      #                 ##
  ' #######    ######                  #
  '
  '
  '---------
  mainstart:
  '---------

  regs=regss
  mest=me
  mesb=me


  '========
  mainloop:
  '========

  nl=1 : bg=j : skiplspace(s,i) : typa1=0
  '
  '
  do
  '
  '
  if ert then goto exitap
  mct=0 : sig="" : mq=0
  '
  wr=pword(s,i)
'messagebox 0,wr,"Tracer",getvarptr("#gravity")
  '
  if isq(ascw) then
    appendt(stodata(wr))
    continue do
  end if
  '
  '++ -- PRE POST
  '
  if (ascw=43)or(ascw=45) then
    if ascn=ascw then i=swd : goto generalexp
  elseif typ then
    if (ascn=43)or(ascn=45) then
      if ascn=asc(s,i+1) then
        i=swd : goto generalexp
      end if
    end if
  end if

  'COMMENTS
  '--------
  '
  if isc(ascw) then
    endline(s,i)
    if vew=0 then  appendt(cr) : goto mainloop 'REMOVE LINE COMMENTS IN FULL COMPILE
    goto addsrc
  end if
  '
  md=0
  '
  if o2h then
    '
    if (ascw>=60)and(ascw<=62) then goto unass
    '
    if mc=-14 then
      md=maco(mp,3)
      goto o2hmain
    end if
    '
  end if
  '
  if mc=-13 then
    md=maco(mp,3)
    goto oxygenword
  end if
  '
  if mc=0 then
    if wr="end" then
      w1=wordahead(s,i)
      if w1="asm" then i=nwd : o2h=1 : goto mainloop
    end if
  end if

  op=1 : typa=cpuw
  '
  'REGISTERS
  '
  if mc=-10 then
    typa=typ : if nl then typa1=typa  
  end if
  '
  '
  '
  'CHECK FIRST WORD IN STATEMENT
  '=============================
  '
  if nl then
    '
    'LINE NUMBERS
    '------------
    '
    if (nan=0)and(cnd=0) then
      if ascn=58 then if i=swd+lenw then i+=1
      appendt("._"+wr+cr) : bg=j
      continue do
    end if
    '
    'COLON LABELS: CHANGE TO DOT LABELS
    '----------------------------------
    '
    if ascn=58 then
      '
      'CHECK ASSIGNMENT OPERATOR AHEAD :=
      '
      if asc(s,i+1)=61 then
        if abs(cnd)=1 then agt=1
        i+=1 : ascn=61 : goto nlabel
      end if
      '
      if i=swd+lenw then
        '
        w4=""
        '
        'MAKE LABEL RECORD
        '
        'macoin(me) : macsi(wr,me,0) : maco(me,0)=-18 : addm(me) : addme
        '
        w2=wr
        ali=mid$(s,swd,lenw) 'NO CASE CONVERSION
        i+=1 : skiplspace(s,i)
        '
        'EXPORTING AND HOST-LINKING LABELS
        '
        ' label: alias "Label" (a as sys,b as sys) at #HostVariable export
        '
        do
          w1=wordahead(s,i)
          if ascn=lbr then i+=1 : wr+=splitsi(namesig(s,i),w1) : continue do        'PARAM SIGNATURE (..)
          if w1="alias" then i=nwd : ali=noquotes(word(s,i)) : continue do          'ALIAS
          if w1="export" then i=nwd : exportadd(w2,ali,eord) : continue do          'ADD TO EXPORT LIST FOR DLLS
          if w1="at" then i=nwd : w1=mword(s,i) : atadd(s,i,wr,w1,w4) : continue do 'GIVE ADDRESS TO HOST VARIABLE #
          exit do
        loop
        '
        'IS IT DATA OR CODE?
        '
        b=i
        nextinstruct(s,b)
        if wordahead(s,b)="data" then
          ape(dats,dati,"."+wr+cr)
        else
          inserts(s,w4+cr+"."+wr+cr,i)
        end if
        '
        skiplspace(s,i)
        lbw=wr : w4=""
        continue do
      end if
    end if
    '
    '======
    nlabel:
    '======
    '
    typc=0
    asi=0
    '
    if mq then
      if ascw=91 then mq1=mq : typa1=typ : lent1=maco(mq1,1)
    end if
    '
    if cnd then goto nctype 'NOT A TYPE
    '
    '-------------------
    'TYPES (C STYLE DIM)
    '===================
    '
    a=0
    '
    'CHECK FOR BUILT-IN STRING FUNCTION
    '----------------------------------
    '
    if mc=-16 then
      if wr="string" then a=-1 'THIS IS A STRING PRIMITIVE
    end if
    '
    'CHECK FOR TYPE OR DERIVED TYPE, ENUMERATION, C PRIMITIVE
    '--------------------------------------------------------
    '
    if (mc=-3)or(mc=-8) then
      '
      'CHECK FOR FUNCTION POINTER TYPES
      '--------------------------------
      '
      if mc=-8 then
        m=maco(mp,4) 'LOCATE THE FUNCTION ATTRIBUTES
        b=maco(m,0)
        if (b=-5)or(b=-6)or(b=-7) then
          wr=mword(s,i) 'ASSUME NO * POINTER HERE
          c=cloneit(wr,m) 'COPY THE PROCEDURE ATTRIBUTES TO A NEW ENTITY
          if ert then goto exitap
          wr=newvector(c) 'CREATE ANOTHER MEMORY VECTOR FOR IT
          if ascn=61 then inserts(s,wr+" ",i) 'ASSIGN VALUE? EG: [EBX+104]= ...
          goto mainloop
        end if
      end if
      '
      a=1 'C style UDT variable 'VAR
      '      
    elseif mc=-2 then
      i=swd : goto vardef 'ENUMERATION
    elseif mc=-15 then
      a=-1 'IDENTIFIED C PRIMITIVE
      if wr="sys" then lent=cpuw : typ=cpuw
    end if
    '
    if a then
      '
      do
        if ascn=42 then
          i+=1 'SUPPORT FOR POINTER TYPES INCLUDING VOID*
          wr+="*" : skiplspace(s,i)
        else
          exit do
        end if
      loop
      '
      d=0 : w4=wr
      '
      '------
      rpfxcc:
      '------
      '
      skipspace(s,i) : w3=wordahead(s,i) : c=lookupm(w3)
      '
      nextinstruct(s,nwd) : b=ascn 'SHOULD BE A BRACKET (LBR) IF W3 IS A PROCEDURE NAME
      '
      if c then
        '
        'CHECK FOR HIGH LEVEL MACRO
        '
        if maco(c,0)=-20 then
          swd=i : i=nwd : w4=himac(c,s,i) 'STUB FOR ATTRIB? CDECL ETC
          goto rpfxcc
        end if
        '
      end if
      '
      'CHECK FOR FUNCTIONS
      '-------------------
      '
      a=0 : skipspace(s,i)
      '
      if ascn=lbr then
        '
        'FUNCTION_POINTER: EXAMPLES
        ' long (*foo)(...)
        ' VOID (APIENTRY *foo)(...)
        '
        a=1
        '
      elseif b=lbr then
        a=2 'FUNCTION long foo(...)
      end if
      '
      'IS A VARIABLE (INCL ENUMERATION)
      '-----------------------------
      '
      if a=0 then i=swd : inserts(s,"dim as "+wr+" ",i) : goto mainloop
      '
      'OTHERWISE  A PROCEDURE
      '
      '
      '=================================================================
      fundec: ' ENTRY POINT FOR EG: TYPEDEF INT ( *FUNC) (LONG* pv,...);
      '=================================================================
      '
      'FUNCTION OR SUB
      '
      ' itr calling convention and library name
      '
      'VOID* EXCLUDED
      '
      if wr="void" then
        w1="sub " : w2="" : d=12
      else
        '
        'NOTE THAT VOID* IS A FUNCTION
        '
        w1="function " : w2=" as "+wr : d=11
      end if
      '
      if a=1 then
        '
        'IS PROCEDURE POINTER
        '--------------------
        '
        '
        i+=1 : skiplspace(s,i)                 'SKIP LEFT BRACKET
        w4=word(s,i)                           'GRAB ANY MACRO OR '*'
        if ascn=42 then i+=1 : skiplspace(s,i) 'CAPTURE '*'
        wr=uword(s,i) : skipspace(s,i)         'CAPTURE NAME OF FUNCTION IN UNALTERED CASE
        if ascn=41 then i+=1                   'CAPTURE RIGHT BRACKET
      else
        '
        'OTHERWISE DIRECT
        '----------------
        '
        wr=uword(s,i)
        '
      end if
      '
      nextinstruct(s,i)
      '
      if deco then
        me-=1 : set_macro_name(wr) : addm(me) : me+=1 'SET NAME OF TYPEDEF ENTITY
        wr="typedef_"+wr
        deco=0
      end if
      '
      'LIBRARY SPECIFIED?
      '------------------
      '
      '
      'CAPTURE ARGUMENTS
      '-----------------
      '
      ascn=asc(s,i) : w4=""
      if ascn=lbr then capture(s,m,i,0) : w4=mid(s,m,i-m)
      '
      nextinstruct(s,i)
      '
      if (ascn<>123)and(ascn<>lbr) then
        w1="declare "+w1 : dcp=1
      end if
      '
      '
      'CLEANUP PROTOTYPE
      '-----------------
      '
      w3="" : a=1
      '
      do
        w5=word(w4,a)
        if lenw=0 then exit do
        if w5="const" then continue do 'OMIT
        b=lookupm(w5)
        if b then 
          if maco(b,0)=-20 then
            c=a
            w6=himac(b,w4,c)
            if len(w6)=0 then a=c : continue do
          end if
        end if
        w3+=w5
        if ascn=44 then a+=1 : w3+=","
        if ascn<>41 then w3+=" "
      loop
      '
      wr=w1+wr+w3+w2+cr
      '
      inserts(s,wr,i)
      goto mainloop 'TRANSLATED INTO SEMI-BASIC
      '
    end if
    '




    if cnd=0 then

      '----------------------
       brackets: 'FOR SCOPING
      '======================

      if ascw=lbr then ' (
        nest()
        if ert then goto exitap
        appendt(sp)
        goto mainloop
      end if

      if ascw=rbr then ' )
        unnest : if ert then goto exitap
        appendt(ep)
        if len(wx) then inserts(s,wx,i) : wx=""
        goto mainloop
      end if

    end if 'CND=0


    '
    'END OF `FIRST WORD ON LINE` CHECK
    '
  end if 'nl=1
  '
  nl=0
  '
  '
  '======
  nctype:
  '======
  '
  if o2h then
    '
    'START BLOCK {
    '=============
    '
    if ascw=123 then
      i=swd : cbrencah(s,i,0)
      if ert then goto exitap
      goto mainloop
    end if
    '
    'END BLOCK }
    '===========
    '
    if ascW=125 then
      if cbri>0 then
        cbri-=1
        a=cbrk(cbri)
        if a=1 then
          w1=wordahead(s,i)
          c=0
          if w1="else" then
            if ascl(s,nwd)=&h69 then
              b=nwd
              w1=wordahead(s,b)
              if w1="if" then c=1
            end if
          end if
          if w1="elseif" then c=1
          if c=1 then a=0 else md=17 'END IF
        end if
        if a=2 then md=18 'END DO
        if a=4 then md=34 'NEXT
        if a=5 then md=20 'END SELECT
        if a>1100 then n=a-1100 : goto endpro
        if a>1000 then md=a-1000
        if a then
          goto endings
        else
          goto mainloop
        end if
      end if
    end if
    '
  end if
  '
  'QUALIFY FOR AUTODIM (ARRAYS EXCLUDED)
  '-------------------------------------
  '
  if (mp<>0)or(relaxed=0) then goto nrelaxed 
  if ascw=91 then goto nrelaxed
  if (ascw<=&h60)or(ascw>&h7a)or(asc(s,i+1)=62) then  goto nrelaxed ' or(lenw>3)
  if instrword(" and or xor not ",wr) then goto nrelaxed
  if ascn<>61 then goto nrelaxed
  '
  '------------------------------
  'IF RELAXED CREATE NEW VARIABLE
  '==============================
  '
  '
  'EXPRESSION
  '----------
  '
  'itr restricted to primitives or non-pointered types
  '
  i+=1 : typa1=0
  op=0 : w2=express(s,i,0," ") : c=typg        'INHIBIT CONCATENATION WITH " "
  if ert then goto exitap
  if c=0 then c=cpuw                    '
  if (c>=&ha0)and(c<&he1) then c=&he1   'DEFAULT TO NATIVE STRING
  if opg>=1024 then opg-=1024           '
  if opg<2 then if (c=&hc1) then c=&he1 'DYNAMIC STRING
  if c<512 then w1=revdic(idtype,c) else w1=macso(c-512,0)
  typa1=c
 '
  'CREATE VARIABLE BUT DO NOT INITIALISE
  '-------------------------------------
  '
  if c>(&hc0)and(c<&h100) then a=a else a=1 'ONLY STRINGS REQUIRE INIT
  varsal(w1+" "+wr,1,a) : if ert then goto exitap
  '
  w3=ins(2,c,macso(me-1,1)) : appendt(w2+w3)
  '
  if fro then w1="" : wr=macso(me-1,1) : goto frostt 'FOR I=1 TO ...
  if cnd then wr=macso(me-1,0) : inserts(s,wr+"="+wr,i)
  goto mainloop
  '
  '
  '--------
  nrelaxed:
  '========
  '
  '
  'COLONS AS STATEMENT SEPARATORS OR ASM PREFIXES
  '----------------------------------------------
  '
  if ascw=58 then appendt(": ") : goto mainloop
  '
  '
  if ascw=35 then
    '
    'RUN TIME HOST VARIABLE ADDRESS RESOLUTION ##V
    '---------------------------------------------
    '
    b=asc(wr,2)
    if (b=35) then
      if asc(s,swd+2)=35 then
        '
        'VIEW MARKERS ###
        '
        if vwb=0 then vwb=1 : w1="#view" else vwe=1 : w1="#endv"
        appendt(w1+cr) : goto mainloop
      end if
      '##var runtime binding
      inserts (s,"proc [ebx+40] "+chr(34)+mid(wr,3)+chr(34)+cr,i)
      continue do
    end if
  end if


  '
  ' ####  #######################  ####
  '#                                   #
  ' ####  CONDITIONAL EXPRESSIONS  ####
  '    #                           #
  '    #  #######################  #
  '    *                          *


  '==========
  if cnd then
  '==========

    '
    if ascw=37 then wr=pword(s,i) ' IGNORE %
    '
    if fro then
      '
      ' ####   ####   #####
      ' #     #    #  #    #
      ' ####  #    #  #####
      ' #     #    #  #    #
      ' #      ####   #    #
      '
      'SKIP EQUALS SIGN
      '
      w1=wrd(s,i)
      '
      'SET INITIAL VALUE OF ITERATOR
      '
      op=0 : w1=express(s,i,typa1,ins(2,typa1,wr)) : if ert then goto exitap
      '
      'SKIPPED `TO`
      '
      'SET LOOP POINT
      '
      '----------------------------------------
      frostt: 'ENTRY POINT FOR RELAXED ITERATORS
      '========================================

      '
      'w1+=sp+".for"+cr ' start of loop
      w1+=".next"+cr ' start of loop
      '
      'SET LIMIT VALUE FOR ITERATOR
      '
      w2=wrd(s,i) 'SWALLOW 'TO'
      '
      op=0 : w1+=express(s,i,typa1,"") : if ert then goto exitap
      '
      'PRESUME INCREMENT
      '
      b=0 : c=0 : op=12 : cnd=0
      '
      'IF STEP IS SPECIFIED
      '
      if (iss(ascn)=0)and(ascn<>123) then
        '
        ' skipped `step` in expression
        '
        'CHECK FOR DESCENDIING STEP
        '
        if ascn=45 then b=1 : i+=1 : skiplspace(s,i) : op=13
        '
        w3=pword(s,i)
        '
        'CHECK FOR VARIABLE
        '
        if nan then c=43 : if b then c=45
        '
        'BUT IF LITERAL NUMBER
        '
        if nan=0 then if dv<>1 then c=43 : w3=str(dv) : if b then c=45
        '
      end if
      '
      'INC/DEC
      '
      if c=0 then w2=ins(op,typa1,wr)
      '
      'ADD STEP (DEFERRED TILL NEXT)
      '
      if c>0 then w2=ins(1,typa1,wr)+ins(c,typa1,w3)+ins(2,typa1,wr) ' step by var
      '
      'COMPARE
      '
      w1+=ins(3,typa1,wr) ' compare
      '
      'FPU POP AND DISCARD
      '
      if typa1>&h40 then w1+="fcomp st(0),st(0)"+cr
      '
      'CONDITIONAL EXIT
      '
      w4="jl fwd end_for"+cr : w3="jl" 'ASCENDING SIGNED CPU INT (DEFAULT)
      if b=0 then
        if typa1>=&h20 then w3="jb" 'ASCENDING UNSIGNED CPU/FPU
      end if
      if b=1 then
        if typa1< &h20 then w3="jg" 'DESCENDING SIGNED CPU INT
        if typa1>=&h20 then w3="ja" 'DESCENDING UNSIGNED CPU/FPU
      end if
      '
      'STACK STEPPER
      '
      mid(w4,1)=w3 : w1+=w4 : nxs(nx)=w2 : nx+=1
      '
      'CHECK AHEAD FOR {
      '
      a=cbrencah(s,i,4)
      '
      'DONE FOR
      '
      fro=0 : goto cleardown
      '
    end if 'FRO: FOR TO NEXT STATEMENTS
    '
    '
    '================
    'VARIABLE ON LEFT
    '================
    '
    if ascw=91 then
      psg=wpfx
    end if
    '
    '
    '==============================
    'single word conditionals
    'if n then ...
    'while n ...
    '==============================
    '
    n=0
    '
    if isx(ascn) then
      n=1
    elseif ascn=123 then
      n=1
    elseif (ascn=&h74)and(varf<7) then
      w1=wordahead(s,i)
      if w1="then" then
        i=nwd : n=1
      end if
    end if
    '
    if n then
      '
      w1=""
      if varf>=8 then
        inserts(s,ow+" ",i) : op=0
        w1=express(s,i,cpuw,"") : wr=qeax : psg=""
        if ert then goto exitap
      end if
      '
      w1+=psg+ins(&h20,typ,wr) ' compare operand with 0
      '
      if cnd<0 then a=1 else a=0
      '
      '
      '==========
      'IF / WHILE
      '==========
      '
      if ctb(nsl-1)=1 then
        w3=" fwd end_con" 'IF
      else
        w3=" fwd end_do" 'WHILE
      end if
      '
      if a=0 then w2="jz" else w2="jnz"
      '
      w1+=w2+w3+cr
      '
      skiplspace(s,i)
      goto xcnd
      '
    end if 'single word conditional
    '
    '
    '================================
    'LEFT SIDE FUNCTION OR EXPRESSION
    '================================
    '
    '
    'SINGLE NUMBER
    '
    if isn(ascw)and(isi(ascn)) then goto ncond
    '
    '
    'END OF EXPRESSION OR <=>
    '
    if isi(ascw) then goto unass
    '
    '
    'PROCEDURE OR EXPRESSION
    '
    '=====
    ncond:
    '=====
    '
    if agt then w1=":" : agt=0 else w1=""
    inserts(s,ow+" "+w1,i)
    goto mainexp
    '
    '
    '  ###  ####
    '   #   #
    '   #   ####
    '   #   #
    '  ###  #
    '
  end if ' cnd ALL CONDITIONALS
  '
  '
  '
  '============
  'DO PROCEDURE
  '============
  '
  'itr [asm] params
  '
  if varf>=8 then
    if o2h then
      if ascn<>91 then goto procs
    else
      goto procs
    end if
  end if




  '==========================
  'ASSIGN TO VARIABLE ON LEFT
  '==========================
  '
  '                    ####          ####
  '                    ##              ##
  'RESOLVED VARIABLES: ##  [reg+offs]  ##
  '                    ##              ##
  '                    ####          ####
  '
  '
  if ascw=91 then
    '                ##     ##
    '               ##       ##
    '============  ##         ##
    'ARRAY ASSIGN  ##  INDEX  ##
    '============  ##         ##
    '               ##       ##
    '                ##     ##
    '
    'CONVERT SQUARE ARRAY BRACKETS
    '
    a=typa1
    if ascn=91 then
      if o2h then
        if varf<8 then fixsqbr(s,i) else goto procs
      end if
    end if
    '
    '
    if ascn=lbr then
      if varf>=8 then a=cpuw
      psg=arrayres(s,i,a,wr) 'may affect wpfx
      'psg=wpfx+psg
      'if a<&h40 then psg=ins(4,a,"")+psg+ins(6,a,"")
      if varf>=8 then goto procs 'ARRAY OF FUNCTIONS
      typa1=a
      bg=j : wsg=wr : appendt(wr)
      continue do
    end if 'arrays
    '
    '
    '=============================
    'FOR SIMPLE LEFT SIDE VARIABLE
    '=============================
    '
    bg=j : psg=wpfx : goto addsrc
    '
  end if ' a=91

  if mc=-10 then bg=j : psg=wpfx : goto addsrc

  '-----
  unass:
  '=====

  if (ascw<>61)and(ascn<>61) then goto nassign
  cpa=identopeq(s,i,w1) : w2=cm+qeax
  nextinstruct(s,i)

  '
  '      #
  '      #     ########
  '   #######
  '      #     ########
  '      # 
  '


  '---------
  'LEFT SIDE
  '=========

  '
  '
  'BACKTRACK OUTPUT STREAM
  '-----------------------
  '
  j=bg
  '
  '
  '------------------------------
  'CHECK FOR MULTIPLE ASSIGNMENTS
  '==============================
  '
  '
  'ARRAY ASSIGNMENTS & OBJECT ASSIGNMENTS
  '
  if ascn=62 then
    i+=1
    if vew>0 then appendt(";MULTIASSIGN =>"+cr)
    if wsg<>pedi then psg+=ledi+wsg+cr
    appendt(psg+"push "+qedi+cr)
    b=typa1 : c=mq1
    asgm=1 : asgo=0 : asgi=maco(c,1) : asgj=0 : asgk=0
    if b>=512 then asgs=macso(b-512,1)
    skiplspace(s,i) : if (ascn=lbr)or(ascn=123) then i+=1 : skiplspace(s,i)
    '
    'READ IN DATA SERIES
    '
    psg="" : goto mainexp
    '
  end if
  '
  '
  '
  if (o2h)and(mq1>0) then
    n=ascn : asg=psg+ins(cpa,typa1,wsg) : ascn=n
  else
    asg=psg+w1+wsg+w2+cr
  end if
  '
  if iss(ascn) then w1=asg : asg="" : goto cleardown 'DONE += ETC
  '
  '
  '----------
  'RIGHT SIDE
  '==========
  '
  '
  '-------
  mainexp:
  '=======
  '
  '
  'SIMPLE INTEGER ASSIGNMENTS
  '--------------------------
  '
  if isn(ascn)=0 then goto nsimpass
  if typa1>=&h40 then goto nsimpass
  if cpa=14 then goto nsimpass
  if cpa=15 then goto nsimpass
  b=typa1 and 31 'SIZE
  if b>=8 then goto nsimpass
  w2=wordahead(s,i)+cr
  a=ascl(s,nwd)
  if ise(a) then
    '
    a=len(asg)
    if (b=0)or(b=cpuw)or(b=4) then
      '
      'LONG,DWORD ALSO QUAD,QWORD FOR 64 BIT
      '
      w1=left(asg,a-5)+w2 'eg: MOV [EBX+4048],73
    else
      '
      ' BYTE AND WORD
      '
      if b=1 then w3="byte " else w3="word "
      w1=left(asg,a-len(wsg)-6)+w3+wsg+","+w2 'eg: MOV BYTE [EBX+4096],768
    end if
    i=nwd : goto cleardown
  end if
  '
  '--------
  nsimpass:
  '--------
  '
  '
  'LOW LEVEL STRING LITERALS
  '-------------------------
  '
  if o2h=0 then if isq(ascn) then w1=word(s,i)+cr+asg : goto cleardown
  '
  ' 
  '==============================
  generalexp: 'GENERAL EXPRESSION
  '==============================
  '
  op=0 : w1=express(s,i,typa1,asg) : if ert then goto exitap
  '
  '
  'ACTION FOLLOWING CONDITIONAL
  '----------------------------
  '
  '
  if cnd then
    '
    if ctb(nsl-1)=1 then
      w3=" fwd end_con"
    else
      w3=" fwd end_do"
    end if
    '
    if abs(cnd)=1 then
      '
      if cnd<0 then
        w2="jnz"
      else
        w2="jz"
      end if
      '
      w1+="or "+qeax+cm+qeax+stp+"._cnd"+cr+w2+w3+cr 'SKIP IF TRUE / IF FALSE
    else
      w1+=w3+cr 'SIMPLIFIED BY USING DIRECT COMPARISON < > <= >= <> =
    end if
    '
    '----
    xcnd:
    '====
    '
    '
    'DETECT IMPLICIT ENDIF AT END OF LINE
    '------------------------------------
    '
    if nsl then
      c=ctb(nsl-1)
      if cbrencah(s,i,c)=0 then
        if c=1 then
          if iss(ascn)=0 then
            m=i : endline(s,i)
            inserts(s,mid(s,m,i-m)+cr+"endif",i)
          end if
        end if
      end if
    end if
    '
    cnd=0
    '
  end if ' cnd
  '
  '
  '
  goto cleardown 'ASSIGNMENT COMPLETED


  '
  '-------
  nassign:
  '=======  

  '
  '---------------------------------
  'ASM CALL/JMP OR IMPLIED PROCEDURE
  '=================================
  '
  if wr="call" then
    typ=0
    if wordahead(s,i)="far" then goto fargo
    '
    wr=pword(s,i)
    if isx(ascn) then
      appendt("call "+wr)
      if ascn<=13 then appendt(cr)
      goto mainloop
    end if
    if varf<8 then varf=8
    goto procs
  end if
  '
  if wr="jmp" then
    if wordahead(s,i)="far" then
      '
      fargo:
      '
      m=i : endline(s,i)
      appendt(wr+" "+mid(s,m,i-m)+cr)
      goto mainloop
    end if
  end if
  '
  '
  if (wr<>"proc") then goto nproc
  '
  '------------------
  'EXPLICIT PROCEDURE
  '==================
  '
  wr=pword(s,i)
  '
  '----------------------------
  'ALL COMMAND LEVEL PROCEDURES
  '============================
  '
  '
  '-----
  procs:
  '=====
  '
  'PSEUDOVARIABLES
  '---------------
  '
  if ascn=61 then mid(s,i)=" "  ' SIMPLE PSEUDO ASSIGN
  '
  'WATCH OUT FOR COMMAND FUNCTIONS LIKE MID()=
  '--------------------------------------------
  '
  if mc=-16 then
    if wr="print" then fpu=1
    if instrword(" mid ",wr) then
      inserts(s,"_"+wr+" ",i) : wr=mword(s,i)
    end if
  end if
  '
  w1=procedures(s,i,wr)+asg : xpr=0 : if ert then goto exitap
  '
  '---------
  cleardown:
  '=========
  '
  if dts(funi) then w1+=rtl(deltmpa)+cr : dts(funi)=0 'delete temp strings
  '
  appendt(w1) 'FULLY RESOLVED TO ASSEMBLY CODE
  '
  if ert then goto exitap
  skiplspace(s,i)
  cpa=0 : fpu=0 : nprec=0
  psg="" : asg=""
  '
  '
  goto mainloop
  '
  '
  '-----
  nproc:
  '=====

  '
  '=======
  'EQUATES
  '=======
  '
  '
  '   ###    ##
  '   # #   ##
  '   ###  ##
  '       ##
  '      ##  ###
  '     ##   # #
  '    ##    ###
  '
  '
  '
  '$ % EQUATES
  '-----------
  '
  if (ascw=36)or(ascw=37) then
    m=swd : a=ascw : wr=word(s,i)
    '
    if (a=36)or(a=37) then
      if ascn=61 then
        i+=1
      end if
    end if
    '
    typo=19 : goto isdefi
    '
  end if



'##############################

'     #####    #####   #     #
'    #     #  #     #  #     #
'    #     #        #  #     #
'    #     #   #####   #######
'    #     #  #        #     #
'    #     #  #        #     #
'     #####   #######  #     #

'##############################


if (mc<>-14) then goto end_o2h

'###############################
DECLARATIVES: ' DECLARE DIM ENUM
'###############################

o2hmain:
  '
  'O2H KEYWORDS
  '
  md=maco(mp,3)
  '
  '
  '------------------------------------------------
  'DECLARE NEW OPERATOR SYMBOL:  operator abc `+?+`
  '------------------------------------------------
  '
  if md=3 then
    w1=word(s,i)
    macoin me
    set_macro_name(w1)
    maco(me,0)=-21
    '
    'OP CODE PRECEDENCE LEVEL
    '
    if isx(ascn)=0 then maco(me,4)=wval(word(s,i)) ' OPERATOR PRECEDENCE
    '
    addme : if ert then goto exitap
    continue do
  end if

  '
  if md=1 then goto defs 'ENUM
  '
  '
  '============
  'DECLARATIVES
  '============
  '
  '  #########   ###  ##       ##
  '   #       #   #   # #     # #
  '   #       #   #   #  #   #  #
  '   #       #   #   #   # #   #
  '   #       #   #   #    #    #
  '   #       #   #   #         #
  '  #########   ###  #         #
  '
  '
  n=0 ': d=0
  '
  if md=4 then 'DIM
    n=1 : if funi=0 then n=4 'LOCAL/GLOBAL
    if wr="const" then cnst=1
  elseif md=05 then
    n=01 'LOCAL
    if funi=0 then ers="Locals must be inside a procedure block" : ow="" : ert=99 : goto exitap
  elseif md=06 then
    n=03 'STATIC
    if funi=0 then ers="statics must be inside a procedure block" : ow="" : ert=99 : goto exitap
  elseif md=07 then
    n=04 'GLOBAL
    if funi then ers="Globals must be outside procedure block" : ow="" : ert=200 : goto exitap
  elseif md=08 then
    n=18 'DECLARE
  elseif md=09 then
    n=11 'FUNCTION
  elseif md=10 then
    n=12 'SUB
  elseif md=11 then
    n=13 'METHOD
  elseif md=27 then
    n=14 'OPERATION
  end if
  '
  w=swd 'SET BLANKOUT MARKER
  '
  'ENDINGS
  '--------
  ' "=" at         then n=19    ' assignment expressions
  ' "export"       then n=23    ' export addresses
  '
  '
  'DISTINGUISH FROM ASSEMBLER sub
  '------------------------------
  '
  if n=12 then
    '
    w1=wordahead(s,i) : a=asc(s,nwd)
    '
    if asc(w1)=91 then
      n=0
    elseif a=lbr then
      n=12
    elseif a=44 then
      n=0
      w1=wordahead(s,nwd) : a=asc(s,nwd) ',..MULTILINE SUB
      if ise(a) then n=12
    elseif instrword(" byte word dword qword eword ptr float ",w1) then
      n=0
    end if
    '
    if n then if w1="finish" then tmnt=1
    '
  end if


  if n then 'TRANSLATE DIM TO VAR AND INITIALISE
    '
    wt="" : wm="" : ws="" : w1="" : w2="" : w4=""
    q=0 : u=0 : dd=0 : de=0 : sigs="" : sigd="@" : w5="" : w6="" : w7="" : pn=0 : typd=0
    '
    'PREPARE FOR PROCEDURES
    '----------------------
    '
    if n>10 then
      '
      'IF INNER PROCEDURE
      '------------------
      '
      'FUNCTION= METHOD= (non header)
      '------------------------------
      '
      if ((n=11)or(n=13)) then
        if ascn=95 then
          a=0
        elseif (ascn<=96)or(ascn>122) then
          a=1
        elseif instrword(" and or xor ",wordahead(s,i)) then
          a=1
        else
          a=0
        end if
        if a then
          wr="_return"
          if typ=cpuw then a=lookupm(wr) : wr=macso(a,1) 'ANON TYPE
          inserts(s,wr,i)
          continue do
        end if
      end if
      '
      '
      'PROCUDURE HEADER
      '----------------
      '
      funi+=1
      '
      typp(funi)=0
      th(funi)=0
      noin(funi)=0
      ml(funi)=0
      funn(funi)=0
      lcl(funi)=0
      lcls(funi)=0
      mlcl(funi)=0
      '
      wva(n)="" : wlc=0          'CLEAR STATE
      ccp(funi)=ccx              'DEFAULT CALLING CONVENTION
      atf(funi)=atx              'DEFAULT EXTERNAL FLAG
      if n=18 then w1=word(s,i)  'DECLARE
      ali=noquotes(uword(s,i))   'ALIAS NAME WITH QUOTES REMOVED
      wn=wword(ali,1)            'CASE CONVERTED NAME
      skiplspace(s,i)
      '
      '
      if vew>0 then
        if(n>=11)and(n<=14) then appendt(cr+cr+ucase("'"+wr+" "+wn)+cr+cr) : bg=j
      end if
      '
      c=0
      '
      funn(funi)=n
      '
      do
        w1=wordahead(s,i)
        if w1="lib"   then i=nwd : lby=noquotes(mword(s,i)) : continue do
        if w1="alias" then i=nwd : ali=noquotes(word(s,i)) : continue do
        a=dic(callco,w1) 'EXPLICIT CALLING CONVENTION
        if a then c=a : i=nwd : continue do
        exit do
      loop
      '
      if n=18 then
        if lby="" then lby=libr 'POSSIBLE DEFAULT LIBRARY NAME
      else 
        lby=""
        ths=0
        if funi>1 then ml(funi)=me : mel=me 'LOCAL FENCE
      end if
      '
      '
      'CALLING CONVENTIONS
      '-------------------
      '
      if c=0 then
        'itr linux cdecl
        if cpuw=8 then c=2
      end if
      '
      ccp(funi)=c and 255
      '
      dd=bref
      '
      'CHECK (PARAM BLOCK) PRESENT
      '---------------------------
      '
      if n<>18 then nextinstruct(s,i)
      '
      if (ascn=lbr) then
        i+=1 : nextinstruct(s,i)
      elseif (ascn=61)or(ascn=123) then
        goto ndimbr
      elseif (n=12)or(n=14) then
        goto ndimbr
      end if
      '
      w1=wordahead(s,i)
      if instrword(" : as at dim static local return function method exit end ",w1) then
        goto ndimbr
      end if

    end if 'N>10

    '
    '
    'STATICS ARE MARKED FOR TRANSFER TO STATIC ZONE AT TOP OF PROG
    ' 
    if n=3 then w6=sq+cr : w7=eq+cr
    w4=""

    '
    '    #
    '  ##
    ' ##
    ' ##  PROCESS EACH DECLARATION PARAMETER
    ' ##
    '  ##
    '    #
    '
    do
      '
      m=0 : skiplspace(s,i) : b=ascn
      '
      if n>10 then
        if isc(ascn) then nextinstruct(s,i) : b=ascn
      end if
      '
      if b=rbr then
        i+=1 : skiplspace(s,i) : m=2
      elseif iss(b) then
        if wordahead(s,i)=")" then i=nwd
        m=2
      elseif n=1 then
        wlc=1
      end if 
      '
      if n<10 then if len(wt) then if ws="" then m=0 : nextinstruct(s,i)  
      '
      'END OF DIM OR DELARATION
      '------------------------
      '
      if m=2 then
        '
        'LOCAL VARIABLES SETUP INLINE
        '
        '
        'ASSIGN TYPE IF NEEDED
        '
        if len(ws) then
          if wt="" then
            if typd then wt=revdic(idtype,typd) else wt="sys"
          end if
          pn+=1 : if leaf then varreg(pn,de,wt,ws)
          declvars(wt+ws+cr,n,w4,noin(funi))
          if ert then goto exitap
          if n=1 then lcl(funi)=1
        end if
        '
        'INITIALISATION
        '
        'includes stack allocation and zero and explicit vales
        '
        if n<10 then
          '
          if len(w4) then
            inserts(s,w4,i) : w4=""
          end if
          cnst=0
          goto mainloop
          '
        else
          '
          ws="" : exit do 'FURTHER PROCESSING FOR PROCEDURES
          '
        end if
      end if
      '
      '
      'NEXT PARAMETER OR TYPE IN THE LIST
      '==================================
      '
      skipcomcom(s,i)
      '
      do
        wr=word(s,i)
        '
        if (ascw=36)or(ascw=37) then 'STRIP LEFT % OR $ (thinBasic)
          i=swd+1 :continue do
        else
          exit do
        end if
      loop
      '
      if ascw=lbr then continue do
      '
      '
      byl=0 : c=0
      do
        ow=wr
        b=dic(" byval 1, byref 2, optional 8, ",wr)
        if b then
          if b<=2 then c=b : dd=b-1 : byl=dd
          if b=8 then opa=49
          wr=word(s,i)
        else
          exit do
        end if
      loop
      '
      '
      'IDENTIFY TYPE
      '=============
      '
      '
      f=0
      '
      if n<>18 then
        '
        'IMPLICIT SYSTEM TYPE
        '--------------------
        '
        if (ascn=44)or(ascn=rbr) then goto defaultype 'NO TYPE SPECIFIED
        '
      end if
      '
      f=0
      if wr="as" then 
        wr=word(s,i) : f=1
        if n>10 then byl=dd
      elseif c then
        if n=18 then if identype(wr) then f=1
      end if
      '
      a=0
      '
      if f=0 then
        '
        'C SYNTAX
        '--------
        '
        a=1
        '
        if (ascn=97) then
          w1=wordahead(s,i)
          if (w1="as")or(w1="at") then a=0 'CANNOT BE A TYPE
        end if
      end if
      '        
      if a then
        a=0
        if isa(ascn)or(ascn=42)or(n=18) then a=1 'c TYPE
        if dcp then a=1 'DECLARED C PROTOTYPE
        if a then
          i=swd
          '
          '=====
          rnxdw:
          '=====
          '
          wr=mword(s,i)
          '
          if (mc=-4)or(mc=-13)or(mc=-14) then
            '
            if n<>18 then ers="reserved word" : ert=319 : goto exitap
            a=0
            '
          elseif mc=-3 then 'TYPE
            a=2
          elseif mc=-8 then 'A TYPE INDEXING A TYPEDEF
            '
            if wr="void" then
              if ascn<>42 then continue do
            end if
            a=2
            '
          else 'PRIMITIVES
            '
            'VOID, SUB
            '
            if ascw=&h76 then
              if wr="void" then
                if (ascn=44)or(ascn=rbr)or(isx(ascn)<>0) then
                  continue do 'IGNORE VOID
                end if
                '
                'OTHERWISE ASSUME THIS IS GOING TO BE A PROCEDURE POINTER
                '
                wr="sys" 'IMPOSE SYS TYPE TO CARRY POINTER
                '
              end if
            end if
            '
            'PRIMITIVE (ALSO RESOLVES MACROS)
            '--------------------------------
            '
            a=identype(ow)
            '
            'PROCEDURES
            '----------
            '
            'PARAM PROTOTYPE STUB SKIP    void(*foo)(a,b,c), ...
            'PARAM ARRAY PROTOYPE SKIP ()
            '
            do
              if ascn=lbr then
                capture(s,m,i,0) : skipspace(s,i)
                '
                'eg: void (*foo)(...)
                '
              else
                exit do
              end if
            loop
          end if
        end if
      end if 'a C type
      '
      if a then
        u=1 : f=1
        if b<>2 then dd=0 'NOT EXPLICITLY BYREF
        do
          if ascn<>42 then exit do
          '
          dd+=1 : i+=1 : skiplspace(s,i) 'INDIRECTION
          '
          if wr="void" then
            wr="any" 'PARAM COMPATIBILITY SIG
          else
            if n>10 then byl=dd
          end if
        loop
      end if
      '
      '
      '----------
      defaultype:
      '----------
      '
      if f+u=0 then
        '
        'DEFAULT LONG/QUAD TYPE FOR FUNCTION PARAMS
        '------------------------------------------
        '
        if n>10 then
          typd=0
          '
          'CHECK FOR INFERRED TYPE IN A PROTOTYPE
          '
          if ascn=61 then
            a=i
            capts(s,a)
            if (ascn=rbr)or(ascn=44) then
              b=ascn
              w1=mid$(s,i,a-i)
              w4+=wr+w1+cm
              if asc(w1,2)=62 then a=3 else a=2 '=>' support
              nsto=1 : w1=express(w1,a,0,"") : typd=typg : nsto=0
              if typd=&hc1 then typd=&he1
              i=a
              ascn=b
            end if
          end if
          '
          'CHECK FOR NO OTHER WORDS
          '
          if (ascn=rbr)or(ascn=44) then
            if typd then
              w1=wr
              wr=revdic(idtype,typd)
            else
              i=swd : w1=wr
              wr=mword(s,i) : a=identype(wr)
              '
              if a=0 then
                wr="sys" ' 32 / 64 bit according to mode
              else
                w1=""
              end if
            end if
            '
            byl=dd
            sigs+="#"+wr : sigd+="a"+chr(48+dd+opa) 'BUILD SIGNATURE
            pn+=1 : if leaf then varreg(pn,dd,wr,w1)
            declvars(wr+" "+string(dd,"*")+w1+cr,n,w4,1) : ws=""
            if ert then goto exitap
            dd=bref
            continue do
          end if
        end if
        '
      elseif f=1 then
        '
        'EXPLICIT TYPE
        '-------------
        '
        a=lookupm(wr)
        if a then
          if maco(a,0)=-1 then wr=macso(a,1)
        end if
        w3=wr
        b=0 : w5=""
        '
        if ascn=&h70 then
          '
          'RESTRICT TO POSTDEF: DIM B AS BYTE PTR
          '
          if len(ws) then
            if instrword(" ptr pointer ",wordahead(s,i)) then
              i=nwd : dd+=1 : b+=1 : w5=" ptr"
              if n>10 then byl=dd
            end if
          end if
        end if
        '
        if w3="string" then
          if (n=1)or((n>10)and(n<18)) then
            lcl(funi)=1 : lcls(funi)=1 ' FLAG LOCAL DYNAMIC STRINGS
          end if
        end if
        '
        if n>10 then
          sigs+="#"+w3 : sigd+="a"+chr(48+dd+opa) 'BUILD SIGNATURE FOR PROCEDURES
        end if
        '
        skiplspace(s,i)
        '
        '
        'LEAVE DD ALONE IF C TYPE
        '
        if u=0 then
          if n>10 then dd=bref else dd=0 'SET INDIRECTION FLAG TO DEFAULT VALUE READY FOR NEXT PARAM
        end if
        '
        if ws="" then wt=w3+w5 : continue do 'PREDEF
        '
        if wt="" then
          w2=w3+w5 'POSTDEF
        else
          w2=wt    'PREDEF
        end if
        '
        pn+=1
        if leaf then varreg(pn,b,w2,ws)
        declvars(w2+" "+ws+cr,n,w4,noin(funi))
        if ert then goto exitap
        skiplspace(s,i)
        '
        if n=1 then lcl(funi)=1
        '
        if len(wt) then wt=w3             'SET NEXT PREDEF
        '
        if ascn=61 then
          wr=ws : ws="" : w2="" : w3=""
          goto assig ' AS ATYPE = ...
        end if
        ws="" : continue do ' postdef
        '
      end if 'AS TYPE
      '
      '
      '====================
      'ADD VARIABLE TO LIST
      '====================
      '
      ws+=" "+string(dd,"*")+wr : de=dd
      '
      skiplspace(s,i)
      '
      'CAPTURE ARRAY
      '=============
      '
      w3=""
      c=0
      '
      do 'SUPPORT MULTIPLE ARRAY A()()

        if (ascn=lbr)or(ascn=91) then
          '
          'CHECK FOR EMPTY BRACKETS
          '
          w1=wordahead(s,i+1)
          a=asc(w1)
          if (a=rbr)or(a=93) then
            i=nwd : skiplspace(s,i) : c=1 'SIGNAL EMPTY BRACKETS
          else
            capture(s,m,i,a) : skiplspace(s,i)
            w3+=mid(s,m,i-m)
          end if
          if n<10 then if byl then ws+="!"
          continue do
        else
          exit do
        end if
      loop
      '
      w2=""
      '
      if ascn=97 then
        '
        'MAPPING TO REGISTER
        '===================
        '
        if wordahead(s,i)="at" then
          i=nwd
          do
            w2+=word(s,i) : a=ascw ' COLLECT POINTERS
            if a<>42 then exit do
          loop
          if a=38 then w2+=word(s,i)                 'MAP TO ANOTHER VAR
          if a=91 then i=swd : w2+=mid(mword(s,i),2) 'REGISTER ETC
          w2=" at "+w2 : skiplspace(s,i)
        end if
        '
      end if
      '
      '=================
      assig: 'INITIALISE
      '=================
      '
      typd=0
      '
      if ascn=61 then
        '
        'CHECK FOR ARRAY DATA
        '
        if c then
          a=i+1
          skipspace(s,a)
          '
          'ONLY SUPPORTS SINGLE STRING LITERAL
          '
          if isq(ascn) then
            w1=word(s,a)
            w3+="["+str(lenw)+"]"
          end if
        end if
        '
        'CAPTURE EXPRESSION
        '
        a=i
        capts(s,i)
        w1=mid(s,a,i-a)
        if (n<10)and(cnst=0) then
          w4+=w6+wr+w1+cr+w7
        else 'PARAMS DEFAULTS
          w4+=wr+w1+cm
        end if
        '
        if asc(w1,2)=62 then a=3 else a=2 '=>' support 
        nsto=1 : w1=express(w1,a,0,"") : typd=typg : nsto=0
        '
        if typd=&hc1 then typd=&he1
      end if
      '
      ws+=w3+w2 'APPEND ARRAY AND MAPPING
      '
      skiplspace(s,i)
      '
      if ascn=44 then
        if (n>10)and(u=0) then dd=bref else dd=0
      end if
      '
      u=0

    loop ' dim elements
    '
    '
    '  #
    '   ##
    '    ##
    '    ##
    '    ##
    '   ##
    '  #
    '
    '------
    ndimbr:
    '======
    opa=0
    if n>10 then
      '
      macoin me
      d=0 : typp(funi)=0
      w1="" : w5="" : w6="" : wm=""
      if len(sigs) then w2=sigs+sigd else w2=""
      skiplspace(s,i)
      wr=wordahead(s,i)
      '
      '
      '    #       #####
      '   # #     #   
      '  #####     ####
      ' #     #        #
      '#       #  #####
      '
      if wr="as" then
        lcl(funi)=1
        i=nwd : w5=word(s,i)
        if (n=11)or(n=13) then wva(2)=w5 : lcl(funi)=1
        '
        'RETURNING POINTERS (SWALLOW)
        '
        a=0
        do
          skiplspace(s,i)
          if ascn=42 then i+=1 : a+=1 : continue do
          if ascn=&h70 then if wordahead(s,i)="ptr" then i=nwd : a+=1 : continue do
          exit do
        loop
        '
        'ASSUME HIGHER TYPES RETURN A POINTER
        '
        a=identype(w5)
        '
        'STRING INTERPRETED AS BSTR (ALSO TELL GARBAGE COLLECTOR)
        '
        if a=&he1 then a=&hc1 : lcls(funi)=1
        typp(funi)=a
        wm+="as "+w5
        '
      end if
      '
      '############
      '
      '  EXPORT
      '  EXTERNAL
      '  CALLBACK
      '
      '############
      '
      a=etx
      if isx(ascn)=0 then w1=wordahead(s,i) else w1=""
      '
      'EXPORTs
      '-------
      '
      if w1="export" then i=nwd : a=1
      if n=13 then a=0 'but not methods
        '
      if a then
        '
        wm+=" "+wr : d=1
        '
        'ADD TO EXPORT TABLES
        '--------------------
        '
        exportadd(wn,ali,eord)
        '
        atf(funi)=1 : i=nwd
      end if
      if instrword(" extern external callback ",w1) then atf(funi)=1 : i=nwd
      '
      skiplspace(s,i)       '
      '
      '
      '    #   #######
      '   # #     #
      '  #####    #
      ' #     #   #
      '#       #  #
      '
      '
      b=-5 ' metatype
      '
      if ise(ascn)=0 then
        w1=wordahead(s,i)
        '
        if w1="at" then
          i=nwd
          '
          '-----------------------------
          'IN  ARRAY OR PROCEDURE HEADER
          '=============================
          '
          w1=mword(s,i)
          '
          if n<>18 then
            '
            'GIVE PROCEDURE POINTER TO EXTERNAL OR INTERNAL VARIABLE
            '-------------------------------------------------------
            '
            'COULD BE MAPPED TO RUNTIME: at [EBX+offset]
            '
            'OR PROVIDE FUNCTION ADDRESS FOR HOST    ..at #hv
            '
            '
            if ascw<>91 then atf(funi)=1 'SET AS EXTERNALLY ACCESSIBLE PROC
            atadd (s,i,wn+sigs, w1, w6)
            '
          else 'n=18
            '
            '--------------------
            'IN DECLARE STATEMENT
            '====================
            '
            'EXTERNAL / VECTORED FUNCTION DECLARATION
            '
            'declare function xyz() as sys at a   /  at xyz
            '
            'LINK A FUNCTION TO AN EXISTING VARIABLE
            '
            b=-7
            '
            macsi(w1,me,1) 'DYNAMIC VECTOR
            '
          end if
          '
        end if
      end if
      '
      '###############
      'MAP  PROCEDURES
      '###############
      '
      ' FUNCTION SUB DECLARE but not METHOD
      '
      if n<>13 then
        '
        'CREATE PROCEDURE RECORD
        ' excluding methods
        '
        '
        c=0
        '
        'IF IMPORTED
        '-----------
        '
        if n=18 then
          if len(lby) then
            '
            'ADD LIBRARY IF NOT SEEN BEFORE, THEN ADD PROC TO LIST
            '
            b=-6 ' metatype
            c=addlib(lby,ali) : lby=""
            macsi(space(16),me,1) 'RESERVE SPACE FOR ENCODING
          end if
          lbw="declare .. "+wn
        else 'N<>18
          lbw=wn
        end if
        '
        'OPERATION LABELS WITH QUOTES
        '----------------------------
        '
        if n=14 then
          wn=opns+"."+wn+sigs
        end if
        '
        '
        'itr overloaded functions: family must have similar spec.
        '
        '
        if w2="" then w2="#@"    'NO PARAMS
        if w5="" then w5="-"     'NO RETURN
        '
        'DEFAULT PARAMS
        '--------------
        '
        if len(w4) then
          w4=" (,"+w4+")"
        end if
        '
        'FINALISE SIGNATURE + DEFAULTS RECORD
        '------------------------------------
        '
        if b<>-7 then w1="x" 'non vector
        w3="#"+w2+" "+w5+" "+w1+" "+w4+cr 'EG: ##long#string@a0a1 double x (,a=3,b=4,)
        '
        mqf=0 : a=0
        '
        'SELECTED OVERLOADING
        '
        if b=-5 then
          d=lookupm(wn) 'lookup prior
          if d then
            a=maco(d,0)
            if a<=-5 then w3+=macso(d,3) 'overload and append prior
          end if
        end if
        '
        '
        '======================================================================='
        macsi(wn,me,0)        ' name
       'macsi(??,me,1)        ' vectors (assigned for metatypes -6 and -7)
        macsi(ali,me,2)       ' alias for export or import
        macsi(w3,me,3)        ' list of param signatures (overloadable if -5 or -7)
        '-----------------------------------------------------------------------'
        maco(me,0)=b          ' metatype -5 -6 -7
       'maco(me,1)=0          ' stack cleanup nbytes (assigned later)
       'maco(me,2)=0          ' aoff offset for imported proc addr (assigned later)
        maco(me,3)=c          ' library list index
        maco(me,4)=ccp(funi)  ' calling convention
        maco(me,5)=typp(funi) ' return type code
        '======================================================================='
        '
        addm(me) : mqf=me : addme() : if ert then goto exitap
        '
        '
        ali=""
        '
        'DECLARATION
        '-----------
        '
        if n=18 then
          '
          dcp=0
          '
          'LATE BINDING / DYNAMIC LINKING
          '
          if dlbf then mp=mqf : maco(mp,0)=7 : addlproc()
          '
          'NO FURTHER PROCESSING OF DECLARATIVES
          '
          goto ClearDownFuns
          '
        end if

      end if ' n=11 12 18 but not 13

      'CAPTURE FUNCTION/SUB/METHOD BODY
      '--------------------------------
      '
      'LOOK AHEAD (SKIP COMMENTS)
      '--------------------------
      '
      a=0 : c=i : nextinstruct(s,i)
      '
      '
      '===============================
      'SHORT FORM FUNCTION() AS TYPE =
      '===============================
      '
      if ascn=61 then
        m=i : endcomcomline(s,i) : w1="_return"+mid(s,m,i-m) : a=1
      end if
      '
      'FUNCTION() AS TYPE (..)
      '=======================
      '
      '----------
      '(..BODY..)
      '==========
      '
      if ascn=lbr then
        capturi(s,m,b,i) : w1=cr+mid(s,m,b) : a=1
      end if
      '
      '-----------
      ' {..BODY..}
      '===========
      '
      if cbrencah(s,i,n+1100) then c=i
      if ert then goto exitap
      '
      '
      if a then
        inserts(s,w1+cr+"end function"+cr,i)
      else
        i=c ' restore position
      end if
      '
      '================
      'CONSTRUCT PROLOG
      '================
      '
      'COMPOSE LABEL
      '-------------
      '
      if atf(funi) then w1="."+wn+cr else w1=""
      '
      if n=13 then
        wn="."+wn+"_"+w2
      elseif n=14 then
        wn=w1+".`"+wn+"`"
      else
        wn=w1+"."+wn+sigs
      end if

      'STEPOVER THE INLINE PROCEDURE
      '-----------------------------
      '
      wm=w6+"jmp fwd _endp"+cr+"o2 !10"+cr+wn+" ' "+wm+sp
      '
      'SCOPE RESTRICTION
      '------------------

      nest() : if ert then goto exitap
      '
      mest=me 'LOCAL FENCE (SET BEFORE PARAMS AND LOCALS)
      '
      '
      a=2*cpuw 'DEFAULT OFFSET FOR PARAMS ON STACK
      '
      if atf(funi) then
        if cpuw=4 then
          b=3
        else
          b=4  'ALLOW FOR EXTRA REGISTER STORAGE
          if ccp(funi)=0 then ccp(funi)=2 'SWITCH TO MS64 CALLING CONVENTION
        end if
        a+=b*cpuw
      end if
      '
      'BASELINE USED TO ESTABLISH
      'PARAM BYTES TO BE DUMPED ON RETURN
      '
      retb=a
      '
      '
      'METHODS
      '-------
      '
      if n=13 then
        '
        'mapping override of this in exported methods
        '
        ths=mest : th(funi)=ths : lcl(funi)=1
        w1=macso(clss(clsi-1),0)
        '
        if leaf then
          w2=pecx 'REGISTER PARAM BASED `THIS` PTR
        else
          w2="*["+qebp+"+"+str(a)+"]" 'MEM PARAM BASED `THIS` PTR
        end if
        '
        vars(w1+" this at "+w2+cr,1)
        '
        'RESERVE PLACE FOR `THIS` ON STACK
        '
        'BUT ALREADY ACCOUNTED FOR IN 64BIT MODE
        '`THIS` Is FIRST PARAM (SPILLED FROM RCX) 
        '
        if cpuw=4 then a+=4
        '
      end if
      '
      'PROCEDURE PARAMETERS
      '--------------------
      '      
      localvars() : asce=1 : aoffl=a : aoff=a
      '
      if len(wva(n)) then
        if cpuw=8 then vstp=16 'FORCE VAR LOCATION INCREMENT
        vars(wva(n),5) : lcl(funi)=1  'PARAMETERS
        vstp=0
      end if
      '
      reto(funi)=aoff-retb : maco(mqf,1)=reto(funi) 'RETURN DUMPING N BYTES
      '
      '
      '
      'PRESERVE REGS FOR EXTERNAL.EXPORTED FUNCTIONS
      '-----------------------------------------
      '
      if atf(funi) then
        if cpuw=4 then
          wm+="push ebx : push esi : push edi : call _mem"+cr
        else
          wm+="push rbx : push rsi : push rdi : push r15 : call _mem"+cr
        end if
      end if
      '
      '
      '
      appendt(wm) : bgl=i
      
      'THE FOLLOWING LINE MAY BE BLANKED OUT (IF LOCAL VARS NOT USED)
      '--------------------------------------------------------------
      '
      blcl(funi)=j
      '
      if cpuw=4 then
        w1="push ebp : mov ebp,esp"
      else
        w1="push rbp : mov rbp,rsp"
        '
        if leaf=0 then
          '
          'STORE REG PARAMS ONTO STACK
          '
          if atf(funi) then a=48 else a=16
          w1+=memregsl(a,pn)
          '
        else
          lcl(funi)=0 'ASSUME NO LOCALS
        end if
      end if
      '
      '
      'patch in reserved local space later
      '-----------------------------------
      '
      w1+=" : sub "+qesp+cm+space(10)
      plcl(funi)=j+len(w1)-10
      '
      '
      'THE FOLLOWING LINE MAY BE BLANKED OUT (IF LOCAL STRINGS NOT USED)
      '-----------------------------------------------------------------
      '
      blcls(funi)=j+len(w1)+2
      w1+=cr+"mov eax,1 : "+rtl(assloca)+cr
      dls(funi)=1 'place local stop
      '
      '
      'PREPARE FOR CREATING LOCAL VARIABLES
      '------------------------------------
      '
      asce=-1 : aoffl=0 : aoff=0
      '
      '
      'CREATE A RETURN VARIABLE
      '------------------------
      '
      if len(wva(2)) then
        '
        a=typp(funi)
        '
        if a<512 then
          w3=" _return"
          a and=31
        else
          w3=" *_return"
          a=cpuw 'FOR RETURNING A POINTER ONLY
        end if
        '
        if leaf then w3+=" at "+regn(0) 'SPECIFY REGISTER AS PARAMETER
        '
        vars(wva(2)+w3,1)
        '
        'RESERVE STACKSPACE
        '
        if leaf=0 then
          '
          w1+=stackspace(a,noin(funi))
          '
        end if
        '
      end if
      '
      appendt(w1+cr)
      '
      'CLEARDOWN CODE BUFFERS
      '----------------------
      'and resume sequential coding
      '
      wlc=0 : leaf=0 'LEAF APPLIES TO PROC PARAMETERS ONLY.
      '
      for m=0 to 19 : wva(m)="" : next 'CLEAR
      goto mainloop
      '
      '
    end if ' n>10
    '
    continue do ' main
    '
  end if ' n>0
  '
  '
  '
  '
  '=======
  endings:
  '=======
  '
  '
  '
  '############################################
  '
  '    ######  ##    #  #####
  '    #       # #   #   #   #
  '    #####   #  #  #   #   #
  '    #       #   # #   #   #
  '    ######  #    ##  #####  FUNCTION SUB PROC
  '
  '#############################################

  if md=12 then 'END
    '
    w=swd
    wr="" : n=0 : md=0
    '
    if isx(ascn)=0 then
      wr=pword(s,i)
      if isx(ascn)=0 then w1=word(s,i) ' swallow
      if mc=-14 then
        md=maco(mp,3)
      end if
    end if
    '
    if md=9  then         goto endpro     '          SUB
    if md=10 then         goto endpro     '          FUNCTION
    if md=11 then         goto endpro     '          METHOD
    if md=27 then         goto endpro     '          OPERATION
    if md=13 then md=17 : goto endcons    'IF     to ENDIF
    if md=21 then md=18 : goto endcons    'DO     to ENDDO
    if md=23 then md=19 : goto endcons    'WHILE  to ENDWHILE
    if md=29 then md=20 : goto endcons    'SELECT to ENDSEL
    if md=28 then opns="" : goto mainloop '          OPERATIONS
    '
    if md=48 then
      ccx=0 : atx=0 : etx=0 : libr="" : goto mainloop 'EXTERN
    end if
    '
    if wr="with" then
      wi=0 : wth="" : goto mainloop
    end if
    '
    endline(s,i)
    '
    'if instrword(" methods scope block ",wr)>0 then
    if (md=37)or(md=41)or(md=42) then 'METHODS BLOCK SCOPE

      w1=ep

      '
      if md=37 then
        '
        'INSERT TABLE BUILDING CODE ETC
        '------------------------------
        '
        if clsi then
          clsi-=1
          a=clss(clsi)
          w1="._mt_"+cr+macso(a,3)+ep
          wr+=" of "+macso(clss(clsi),0)
        else
          ert=107 : ers="Class not defined" : goto exitap
        end if
      end if
      '
      '
      if vew then
        if wr="}" then wr=""
        w1+=";END "+ucase(wr)+cr+cr
      end if
      '
      inserts(s,w1,i) : goto mainloop
      '
    end if
    '
    if n<10 then ers="Invalid end: "+wr : ert=99 : ow="" : goto exitap
    '
    '
    '
    '
    '========================
    endpro: 'PROCEDURE EPILOG
    '========================
    '
    '
    'RETURN VALUES
    '-------------
    '
    n=funn(funi)
    '
    if lcl(funi) then
      w1=retvalue(n,typp(funi))
    else
      w1=""
    end if
    '
    if (n=11)or(n=13) then
      w1+=".end_return"+cr
    end if
    '
    '
    'RELEASE LOCAL RESOURCES
    '-----------------------
    '
    if lcl(funi) then
      '
      'RESTORE STACK POINTER
      '---------------------
      '
      if cpuw=4 then
        w2="mov esp,ebp : pop ebp"+cr
      else
        w2="mov rsp,rbp : pop rbp"+cr
      end if
      '
      mid(t,plcl(funi))=str(mlcl(funi)) ' patch in reserve stack space
      '
    else 'NO LOCAL PARAMS USED
      '
      'LOCAL VARIABLES NOT USED SO ERASE THE 
      'STACK OPERATIONS LINE IN THE PROLOG
      '
      'TO MAINTAIN 16 BYTE STACK ALIGNMENT IN 64 BIT MODE (CPUW=8)
      '-----------------------------------------------------------
      '
      if cpuw=4 then
        w2=""
        '
        'THE EBP REGISTER IS NOT USED TO HOLD THE STACK POINTER
        '
        blankinstruct(blcl(funi))
        '
      else
        '
        w2="mov rsp,rbp : pop rbp"+cr
        '
      end if
      '
    end if 'LCL FUNI
    '
    '
    if lcls(funi)=0 then
      '
      'IF LOCAL VARIABLE NOT PRESENT THEN REMOVE LINE HERE
      '---------------------------------------------------
      '
      blankinstruct(blcls(funi))
      '
    else
      '
      'RELEASE TEMPORARY AND LOCAL STRINGS
      '-----------------------------------
      '
      if dts(funi) then w1+=rtl(deltmpa)+cr
      if dls(funi) then w1+=rtl(delloca)+cr
      '
    end if
    '
    '
    'RESTORE REGISTERS
    '-----------------
    '
    if atf(funi) then
      if cpuw=4 then
        w2+="pop edi : pop esi : pop ebx"+cr
      else
        w2+="pop r15 : pop rdi : pop rsi : pop rbx"+cr
      end if
    end if
    '
    'BYTES TO DISCARD FROM STACK WHEN RETURNING
    '------------------------------------------
    '
    a=reto(funi) : maco(mqf,1)=a 'LENGTH OF PARAMS
    b=ccp(funi)                  'CALLING CONVENTION
    w2+="ret"
    '
    ''APPLIES TO STDCALL BUT NOT CDECL OR MS64
    'APPLIES TO STDCALL ONLY
    '
    if b=0 then
      if a then w2+=" "+str(a)
    end if
    '
    appendt(cr+".end_proc"+cr+w1+w2+ep+"._endp"+cr)
    '
    unnest
    '
    '
    '=============
    ClearDownFuns:
    '=============
    '
    dts(funi)=0 : dls(funi)=0
    funi-=1
    ths=th(funi) : mel=ml(funi)
    '
    goto mainloop
    '
  end if 'MD=12 END
  '
  '
  '------------------------------
  'CHECK FOR START OF INNER SCOPE
  '==============================
  'BLOCK 41
  'SCOPE 42
  if instrword(" scope block ",wr) then
    cbrencah(s,i,md+1000) : if ert then goto exitap
    inserts(s,sp,i)
    goto mainloop
  end if


  if md=25 then 'EXIT
    if (isn(ascn)=0)and(iss(ascn)=0) then
      wr=word(s,i) : c=0
      '
      if instrword(" function sub method operation ",wr)  then
        wr="proc" : c=1
      elseif instrword(" do if for ",wr) then
        c=2
      elseif instrword(" while ",wr) then
        wr="do" : c=1
      end if
      '
      if c then appendt("jmp fwd end_"+wr+cr) : goto mainloop
      '
    end if
  end if
  '
  '
  '----------
  'OPERATIONS
  '==========
  '
  if md=28 then
    w1=word(s,i)
    if w1="of" then w1=word(s,i) 'SWALLOW `OF`
    opns=w1
    opnsl+=" "+opns+" "
    cbrencah(s,i,md+1000) : if ert then goto exitap
    goto mainloop
  end if


  '-------
  'METHODS
  '=======
  '
  if md=37 then
    w1=word(s,i)
    if w1="of" then w1=word(s,i) 'SWALLOW `OF`
    mp=lookupm(w1)
    if mp=0 then ers="class/type not found: "+w1 : ert=11 : goto exitap
    if maco(mp,0)<>-3 then ers="not a class/type: "+w1 : ert=11 : goto exitap
    '
    maco(mp,2)=1 'SET CLASS METHODS FLAG (internally defined methods)
    '
    if vew>0 then appendt(cr+cr+";METHODS OF "+w1+cr)
    '
    'START SCOPE
    '
    cbrencah(s,i,md+1000) : if ert then goto exitap
    inserts(s,sp,i) 
    '
    clss(clsi)=mp : clsi+=1 : 'REMEMBER CLASS
    goto mainloop
  end if
  '


'   #########
'  ###########
' ## CONTROL ##
'  ###########
'     ##
'     ##
'     ##
'     ##
'    ####
'   ######
'   ######
'  ########
  '
  '
  '------------
  'GOTO / GOSUB
  '============
  '
  if (md=35)or(md=36) then
    w1=word(s,i)
    if isn(ascw) then w1="_"+w1 ' LINE NUMBERS
    if md=35 then w2="jmp long "
    if md=36 then w2="call "
    appendt(w2+w1+cr) : goto mainloop 'GOTO 'GOSUB
  end if
  '
  '
  '--------------
  'RETURN C STYLE
  '==============
  '
  if md=38 then
    if funi then
      '
      n=funn(funi)
      if (n=11)or(n=13) then
        typa1=typp(funi)
        w2="jmp fwd end_return"
      else
        typa1=cpuw 'DEFAULT 'GHOST' TYPE FOR SUBS AND OPERATIONS
        if n then w2="jmp fwd end_proc" else w2="jmp fwd _end_"
      end if
      '
      if typa1>512 then
        typa1=cpuw 'HIGHER TYPES RETURN POINTER
      end if
      '
      if isx(ascn) then
        w1=cr 'NO RETURN PARAM GIVEN
      else
        op=0 : w1=express(s,i,typa1,"") 'THE RESULT IS LEFT IN THE ACCUM (CPU / FPU ETC)
        if ert then goto exitap
      end if
      '
      appendt(w1+w2+cr) : goto mainloop
      '
    end if
  end if
  '
  n=0
  '
  '
  '--
  'IF
  '==
  '
  if md=13 then
    n=1 : w1=sp : cnd=1
  end if
  '
  '
  '--
  'DO
  '==
  '
  if md=21 then
    n=2 : w1=sp+".do"
    if iss(ascn)=0 then
      if wordahead(s,i)="while" then i=nwd : cnd=1
    end if
  end if
  '
  '
  '-----
  'WHILE
  '=====
  '
  if md=23 then n=2 : w1=sp+".do" : cnd=1
  '
  '
  '---
  'FOR
  '===
  '
  if md=31 then
    n=4 : cnd=2 : fro=1 : w1=sp+".for"+cr
  end if
  '
  '
  '------
  'SELECT
  '======
  '
  if md=29 then
    slc(slx)=cas : enu=0 : sle(slx)=enuc : slx+=1
    n=5 : op=1
    if ascn=&h63 then if wordahead(s,i)="case" then i=nwd
    w1=sp+express(s,i,0,"") : typa1=typ : enuc=0
    if mc>0 then if maco(mc,0)=-2 then enuc=mc
    cas=0
  end if
  '
  '
  '----
  'CASE
  '====
  '
  if md=30 then
    '
    if cas then appendt("jmp fwd end_sel"+cr+".end_cas"+cr)
    '
    if wordahead(s,i)="else" then
      i=nwd : skiplspace(s,i) : cas=0 : goto mainloop 'CASE ELSE
    end if
    '
    if ascn=37 then i+=1 'ignore leading '%'
    enu=enuc : wr=pword(s,i) : if ert then goto exitap
    w1=wpfx+ins(3,typ,wr)
    w3=" fwd end_cas"+cr
    if wordahead(s,i)="to" then 
      i=nwd
      enu=enuc : wr=pword(s,i) : if ert then goto exitap
      w1+="jl"+w3+cr+wpfx+ins(3,typ,wr)+"jg" 'CASE X TO Y
    else
      w1+="jnz" 'CASE X
    end if
    '
    w1+=w3 : cas=1 : enu=0
    goto xcnd
    '
  end if
  '
  '
  '--------
  'CONTINUE
  '========
  '
  if md=26 then
    b=iss(ascn)
    if b then
      w1="repeat"
    else
      w1=word(s,i)
      if w1="while" then w1="do"
      w1="jmp long "+w1
    end if
    n=-1
  end if
  '
  '
  '============
  'ALL CONTROLS
  '============
  '
  if n then
    appendt(w1+cr)
    if n>0 then 
      if nsl>=99 then ert=300 : ers="too many block nestings "+wr : goto exitap
      ctb(nsl)=n : nsl+=1
    end if
    if cnd then
      if ascn=&h6e then if wordahead(s,i)="not" then i=nwd : skiplspace(s,i) : cnd=-cnd
    end if
    goto mainloop
  end if
  '
  '
  '=============================
  endcons: 'ENDDO ENDWHILE 'WEND
  '=============================

  n=0 : cnd=0
  '
  '
  '
  if (md=18)or(md=19)or(md=24) then n=2 : w1="jmp long do"+cr+".end_do"+ep
  '
  '
  '----
  'NEXT
  '====
  '
  if md=34 then
    n=4 : nx-=1
    if nx<0 then ert=10 : ers="Too many nexts" : goto exitap
    w1=nxs(nx)+"jmp long next"+cr+".end_for"+ep
    if iss(ascn)=0 then w2=word(s,i) ' swallow iterator name
  end if
  '
  '
  '------
  'ENDSEL
  '======
  '
  if md=20 then
    n=5 : slx-=1
    if slx<0 then ert=11 : ers="Too many end selects" : goto exitap
    w1=".end_cas"+cr+".end_sel"+ep
    enuc=sle(slx) : cas=slc(slx)
  end if
  '
  '
  '----
  'ELSE
  '====
  '
  if md=15 then
    if ascn=&h69 then
      if wordahead(s,i)="if" then
        md=16 : i=nwd : skiplspace(s,i) : goto else_if
      end if
    end if
    n=-1 : cnd=0
   if mid(t,j-2,2)<>cr then appendt(cr)
  end if
  '
  '
  '===============
  else_if: 'ELSEIF
  '===============
  '
  if md=16 then n=-1 : cnd=1
  '
  if n=-1 then
    appendt("jmp fwd end_if"+cr+".end_con"+cr ) : goto mainloop
  end if
  '
  '
  '------
  'END IF
  '======
  '
  if md=17  then
    n=1  : cnd=0 : w1=".end_con"+cr+".end_if"+ep
  end if
  '
  '
  '===================
  'ALL CONTROL ENDINGS
  '===================
  '
  if n then
    if len(w1) then appendt(w1)
    if nsl<1 then
      ert=300 : ers="nesting error " : w1=" (no beginning)" : m=n
    else
      nsl-=1 : m=ctb(nsl)
      if m=n then goto mainloop
      ert=301 : w1=" expected"
    end if
    '
    if m=1 then
      ers+="`end if`"
    elseif m=2 then
      ers+="`end do` / loop"
    elseif m=4 then
      ers+="`next`"
    elseif m=5 then
      ers+="`end select`"
    end if
    ers+=w1+cr : goto exitap
  end if
  '
  'EXTERN
  '
  if md=48 then
    atx=1
    do
      w1=wordahead(s,i)
      a=dic(callco,w1)
      if a then
        i=nwd : ccx=a-&h100 : continue do 'SET DEFAULT CALLING CONVENTION
      elseif w1="lib" then
        i=nwd : libr=noquotes(word(s,i)) : continue do 'SET DEFAULT LIBRARY
      elseif w1="export" then
        i=nwd : etx=1 : continue do 'SET PROCEDURES / CLASSES FOR EXPORT
      elseif instrword(" virtual com ",w1) then
        i=nwd : atx=3 : continue do 'SET CLASSES / PROCEDURES AS VIRTUAL (AND EXTERNAL)
      end if
      exit do
    loop
    goto mainloop
  end if
  '
  select case md
  case 44 : ixb=wval(mword(s,i))      : goto mainloop      'INDEXBASE
  case 45 : libr=noquotes(word(s,i)) : goto mainloop      'LIBRARY
  case 46 : dlb=libe : dlbf=1        : goto mainloop      'LOADLIBS
  case 47 : bindlprocs() : dlbf=0    : goto mainloop      'LINKLIBS
  case 51 : fpu=1                    : goto mainloop      '#FPU
  case 52 : fpu=-1                   : goto mainloop      '#CPU
  case 53 : nprec=1                  : goto mainloop      '#NOPREC
  case 54 : noin(funi)=1             : goto mainloop      '#NOINIT FLAG FOR LOCAL VARS
  case 55 : bref=0                   : goto mainloop      '#BYVAL by default
  case 56 : bref=1                   : goto mainloop      '#BYREF by default
  case 57 : readstate(word(s,i))     : goto mainloop      'READSTATE
  case 59 : typo=17                  : goto declarations2 'DEFF
  end select
  '
  'WRITESTATE
  '
  if md=58 then
    w1=writestate(me-wval(mword(s,i)),me)+cr
    appendt(w1)
    goto mainloop
  end if

end_o2h:

if mc<>-13 then nl=0 : goto addsrc



'#######################

'#######################

'     #####    ##### 
'    #     #  #     #
'    #     #        #
'    #     #   ##### 
'    #     #  #
'    #     #  # 
'     #####   #####O2

'######################

'#######################


 '==========
 oxygenword:
 '==========


  a=ascw
  '
  if mc=-13 then md=maco(mp,3) else md=0



  if md=1 then incli=1 : continue do 'INCL
  '
  '-------
  'SYMBOLS
  '=======
  '
  if md=2 then
    appendt("symbols "+mid(s,i,8)+cr)
    symbols(s,i) : continue do
  end if


  '--------
  'INDEXERS
  '========
  '
  if md=3 then
    if nl=1 then
      '
      'AS FIRST WORD IN STATEMENT
      '--------------------------
      '
      b=swd
      '
      if lclv then aoffl=aoff else aoffs=aoff ' retain when switching
      '
      wd=noquotes(word(s,i))
      '
      if wd="retn" then
        reto(funi)=aoff-retb : maco(mqf,1)=reto(funi) ' PARAMS NBYTES
      elseif wd="local"  then
        regs=regsl : aoff=aoffl : lclv=1 : asce=ascel
      elseif wd="static" then
        regs=regss : aoff=aoffs : lclv=0 : asce=asces
      else
        if (wd="ebp")or(wd="rbp") then 'ALWAYS REGISTER FOR LOCAL ADDRESSING
          lclv=1 : 'regsl=wd
        else
          lclv=0 : regss=wd 
        end if
        regs=wd
      end if
      '
    else
      '
      'NOT AS FIRST WORD
      '
      inserts(s,regs+" ",i)
    end if
    continue do
  end if



  '------
  'OFFSET
  '======
  '
  if md=5 then
    if nl=1 then
      '
      'AS FIRST WORD IN STATEMENT
      '
      b=swd
      wordval(s,i,i) : aoff=dv
      if iss(ascn)=0 then
        wr=word(s,i) : asce=0
        if wr="ascending" then retb=aoff : asce=1 '''
        if wr="descending" then asce=-1 '''
      end if
      if asce=0 then ers="offset n ascending or descending? "+wr : ert=14 : goto exitap
      if lclv then
        aoffl=aoff : ascel=asce
      else
        aoffs=aoff : asces=asce
      end if
      '
    else
      '
      'NOT AS FIRST WORD
      '
      inserts(s,str(aoff)+" ",i)
    end if
    continue do
  end if


  '----
  'RETN
  '====
  '
  if md=4 then
    if reto(funi) then w1="ret "+str(reto(funi)) else w1="ret"
    appendt(w1+cr) : goto mainloop
  end if


  '========================
  nl=0 ' clear newline flag
  '========================


  '----
  'SKIP
  '====
  '
  if md=6 then
    '
    ' wont be passed to assembler single line or multi line (...)
    '
    capturi(s,m,b,i) : if ert then goto exitap
    skiplspace(s,i) : goto mainloop
  end if


  '----
  'WITH
  '====

  if md=7 then 'WITH
    if isx(ascn) then wth="" else wth=noquotes(word(s,i))
    wi=len(wth)
    goto mainloop
  end if



  '---------
  'DATASPACE
  '=========

  if md=8 then
    ws=wr+" "+word(s,i)+cr+asg : asg=""
    appendt(ws) : goto mainloop
  end if


  '----
  'DATA
  '====
  '
  if md=9 then
    ws=captureblock(s,i,wr)
    w1=stodata(ws)+cr
    appendt(w1) : goto mainloop
  end if

  '--------------
  'O2 inline code
  '==============
  '
  if md=10 then
    ws=wr+sp+captureblock(s,i,wr)+ep+asg : asg=""
    appendt(ws) : goto mainloop
  end if

 '
  '
  '
  ''-------
  ''BUILD
  ''=======
  ''
  'if md=11 then
  '  wr=word(s,i) : mp=lookupm(wr) : if mp=0 then ers="def not found: "+wr : ert=11 : goto exitap
  '  appendt(macso(mp,3)) : goto mainloop
  'end if
  '
  '
  '----
  'BIND
  '====
  '
  if md=12 then
    bindl(s,i)    '
    bg=j : goto mainloop ' preprocessor loop
  end if ' bind

 




'     #####          ######          ######          ######          ######          ######         
'    ########       #########       #########       #########       #########       #########      
'   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'  ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'   ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      ##      
'   ##      ##########      ##########      ##########      ##########      ##########      ##
'   #         ######          ######          ######          ######          ######    #### 
'
'
'

'============
'DECLARATIONS
'============



  if md=14 then 'DEFS (bit) aa (n) bb cc
    '
    '
    '-----------------
    defs: 'ENUMERATION
    '=================
    '
    a=swd : i=swd : enums(s,i) : if ert then goto exitap
    goto mainloop
    '
  end if
  '

  if md=17 then 'VAR
    '
    '
    '------
    vardef:
    '======
    '
    varsal(s,i,noin(funi)) : if ert then goto exitap else goto mainloop       
    '
  end if


  typo=0
  '
  if md=15  then
    typo=1 'DEF
  elseif md=16 then
    typo=2 'TYPE
    if wr="struct" then un=8 'C STYLE TYPE
  elseif md=37 then
    typo=2 'TYPEDEF
  elseif md=38 then
    un=1 : typo=2 'UNION
  end if
  '
  if typo=0 then goto ntypo




  '   ######################
  '    MACROS AND STRUCTURES
  '    ######################
  '    ###                  ##
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ###
  '    ###                  ##
  '    ######################
  '   ## DEF  ##  TYPE  ## 
  '  ######################

  '=============
  declarations2:
  '=============  


  '  macs 0 name
  '  macs 1 prepared macro / resolved structure for types
  '  macs 2 offset and array spec for vars / raw structure spec for types
  '  macs 3 vf table building code
  '  maco 0 structure flag -3  ( -1 -19 def -2 defs/enum -3 type)
  '  maco 1 length
  '  maco 2 offset
  '  maco 3 number of params in macro (metatypes -1 -19)
  '  maco 4 size of associated class vf table / var to be used in signature (1)
  '  maco 5 vtp field flag in types (-3)
  '  maco 6 reference tally
  '
  if typo then
    '
    m=swd
    '
    w1=ow 'use the original word as the name `TYPEDEF` etc
    '
    wr=word(s,i) ' `UNION` `STRUCT` `ENUM` etc
    '
    '-------
    'TYPEDEF
    '=======
    '
    if md=37 then
      '
      '
      'STRUCT?
      '-------
      '
      a=dic(" union 1, struct 8,",wr)
      if a then
        un or=8 'FLAGS
        tdst=1 : nextinstruct(s,i)
        indt=0
        if ascn=123 then
          wr="anon" 'ANON STRUCTURE
        else
          wr=mword(s,i) ' NAMED STRUCTURE
          if ascn=42 then
            b=lookupm(wr)
            if b=0 then
              inserts(s,"{}",i) : goto isdefi 'UNDEFINED STRUCTURE
            else
              b+=512 'POINTER TO DEFINED STRUCTURE
              goto rtypedef
            end if
          end if
        end if
        goto isdefi
      end if 'union/struct
      '
      if wr="enum" then
        i=swd : enums(s,i)
        if ert then goto exitap
        b=me+511 : goto rtypedef
      end if
      '
      'TYPEDEFS
      '
      'STRUCT ALREADY DEFINED?
      '
      i=swd : wr=mword(s,i)
      '
      'CHECK WHETHER DEFINING A POINTERED FUNCTION
      '-------------------------------------------
      '
      'THE TYPE COULD BE ANOTHER TYPEDEF TYPE OR A 'C' TYPE
      '
      if (ascn=42)or(ascn=lbr) then
        if (mc=-8)or(mc=-15) then
          a=i
          if ascn=42 then i+=1 : skiplspace(s,i)
          if ascn=lbr then
            macoin me       'NAME LOCATED LATER
            maco(me,0)=-8   'SIGNAL INDIRECT TYPE
            maco(me,1)=cpuw 'LENGTH OF POINTER
            maco(me,3)=0    'INDIRECTION
            maco(me,4)=me+1 'INDEX FUNCTION TO BE DECLARED
            addme
            if ert then goto exitap
            deco=1 : a=1 : goto fundec 'PROCEDURE AS FOR FUNCTION DECLARATION
          else
            i=a 'IT WAS NOT A TYPEDEF PROC AFER ALL SO REVERT TO PRIOR POSITION
          end if
        end if
      end if
      '
      b=identype(wr)

      '
      if b=0 then
        ers="unknown type" : ert=69 : goto exitap
      end if
      '
      goto rtypedef
      '
    end if
    '
    '-----------------------------------------------------------
    isdefi:  'COMING FROM:  typedef struct or equates % $ 
    '===========================================================
    '
    '#define and macro() are now handled in o2met.bas
    '
    macoin me
    if me>=maxit then ers="Too many defs" : ert=10 : me=maxit-1 : goto exitap
    set_macro_name(wr)
    '
    lbw=wr
    '
    'CAPTURE ENTIRE DEF BLOCK
    '
    a=o2h : o2h=0 : wr=captureblock(s,i,w1) : o2h=a 'set o2h 0 prevents suffix stripping
    if ert then goto exitap
    striplineno(wr)
    '
    if iss(ascn+tdst)=0 then w3=wordahead(s,i) ' SWALLOW END TYPE XXX
    '
    if (typo=19)or(w1="#def") then
      b=1
      w1=wordahead(wr,b) : a=asc(wr,nwd) 
      if (a=42)or(a=43)or(a=45)or(a=47) then
        v=metaval(wr,b,w2) ' EVALUATE CONSTANTS 'but not for H headers.
        wr=w2+mid(wr,b)
      end if
    end if
    '
    skiplspace(s,i)
    '
    '=====
    'CLASS
    '=====
    '
    '
    'CHECK FOR EMBEDDED ITEMS IN CLASS
    '=================================
    '
    '
    if w1="class" then
      '
      vtp=atx : f=etx
      '
      w3="" : w1=macso(me,0) : w4=w1 : c=0 : d=0 : e=0 : b=1 : nwd=b : a=1
      '
      if vtp then if len(libr) then w3=" lib "+"`"+libr+"`" : c=atx
      '
      do
        w2=wordahead(wr,nwd)
        '
        'THE OBJECTS IN THIS CLASS WILL CONTAIN A VIRTUAL TABLE POINTER
        '
        if instrword(" extern external ",w2) then a=nwd : vtp or=1 : continue do
        if instrword(" com virtual ",w2) then a=nwd : vtp or=2 : c=vtp : continue do
        '
        'CASE-SENSITIVE NAME OF IMPORTED/EXPORTED CLASS
        '
        if w2="alias" then w4=noquotes(wordahead(wr,nwd)) : a=nwd :  : continue do
        '
        '
        'THE CLASS IS TO BE IMPORTED FROM A DLL
        '
        if w2="lib" then w3=" lib `"+wordahead(wr,nwd)+"`" : b=nwd : c=1 : continue do
        '
        'THE CLASS IS TO BE EXPORTED AS PART OF A CLASS LIBRARY
        '
        if w2="export" then f=1 : b=nwd : continue do
        exit do
      loop
      '
      if vtp then maco(me,2)=1 'virtual table present
      '
      'BLANK OUT PROCESSED PARAMS AND GET REST OF CLASS
      '
      if b>a then a=b
      if a>1 then
        mid(wr,1)=space(a-1)
        if a>=len(wr) then wr=captureblock(s,i,"class")
        striplineno(wr)
      end if
      '
      'EXTERNALITY WAS WAS DETECTED
      '
      '
      'RECEIVING CLASS LIBRARY TABLE
      '-----------------------------
      '
      'a library was specified for the class
      '
      if c=3 then
        goto mclass 'NOT LOOKING FOR METHODS HERE
      elseif c=1 then
        w3="declare sub _setup_"+w1+w3+" alias `_setup_"+w4+"` (long p)"+cr+_
        "_setup_"+w1+" &"+w1+"_table"+cr
        inserts(s,w3,i) : goto mclass 'NOT LOOKING FOR METHODS HERE
      end if
      '
      'SENDING CLASS LIBRARY TABLE
      '---------------------------
      '
      if f then
        vtp or=1
        w3="sub _setup_"+w1+" alias `_setup_"+w4+"` (byval p) export"+cr+_
        "copyn p, &"+w1+"_table, extentof "+w1+"_table"+cr+_
        "end sub"+cr
         inserts(s,w3,i)
         '
         'THEN PROCESS AS NORMAL CLASS
         '
      end if
      '
      if vtp and 2 then
        goto mclass 'VIRTUAL CLASS WITH NO CLIENT-SIDE VFT
      end if
      '
      makeheaders(wr,w4,w3,2)
      '
      '
      'COMPOSE VIRTUAL SECTION AND MAIN BODY
      '
      if len(w4) then wr=w4+cr+"/"+cr+wr
      '
      if len(w3)+len(w4) then
        '
        'COMPOSE METHODS BLOCK AND INSERT BACK INTO SOURCE STREAM
        'the methods block is needed even if it is empty
        '
        w3=cr+"methods of "+macso(me,0)+cr+w3+cr+"end methods"+cr+cr
        inserts(s,w3,i)
      end if
      mclass:
      if vtp then if instr(wr,"/")=0 then wr+="/"+cr

    end if
    '
    '------
    nclass:
    '------
    '
    nocomments(wr)
    macsi(wr,me,1)
    '
    '==========================
    'MACRO: % DEF CONST #DEFINE
    '==========================
    '
    if (typo=1)or(typo=17)or(typo=19) then
      maco(me,0)=-typo
      addme : if ert then goto exitap
      goto mainloop
    end if
    '
    '
    if typo<>2 then goto ntypo
    '
    '
    '
    types(un) 'RESOLVE TYPE STRUCTURE
    '
    '
    '
    if ert then goto exitap
    '
    'TYPEDEF STRUCTS (-8)
    '
    skiplspace(s,i)
    '
    if tdst<>0 then
      b=me+511 : indt=0
      '
      '----------------------------
      rtypedef: 'LOOP FOR EACH TYPE
      '============================
      '
      c=indt 'b carries index to the type
      '
      do
        wr=word(s,i)
        '
        'INDIRECT TYPES
        '
        if ascw=42 then c+=1 : continue do
        exit do
      loop
      '
      'ARRAY TYPES
      'FUNCTION POINTERS
      '
      w2=""
      '
      do
        if (ascn=lbr)or(ascn=91) then
          capture(s,m,i,a) : w2+=mid(s,m,i-m)
          skiplspace(s,i) : continue do
        end if
        exit do
      loop
      '
      macsi(w2,me,2)
      '
      if ascn=95 then
        w1=wordahead(s,i)
        '
        'ATTRIBUTE STUB
        '
        'itr macros
        '
        if w1="__attribute__" then
          i=nwd : capture(s,m,i,a) : skiplspace(s,i)
        end if
      end if
      '
      '
      macoin me : set_macro_name(wr)
      '
      '------------------------------------------
      maco(me,0)=-8   'SIGNAL INDIRECT TYPE
      maco(me,1)=lent '
      maco(me,3)=c    'INDIRECTION
      maco(me,4)=b    'UDT or PRIMITIVE / POINTER
      '------------------------------------------
      '
      addme : if ert then goto exitap
      '
      if ascn=44 then i+=1 : goto rtypedef
      '
      'itr semicolons: treat as linebreaks
      '
    end if


    '
    'RESUME MAIN PREP LOOP
    '
    tdst=0 : un=0
    goto mainloop
    '
  end if ' end defs

ntypo:

'    #################
'    # INCLUDE FILES #
'    #################
'    ###
'    ###
'    ###
'    ##############
'    ##############
'    ###
'    ###
'    ###
'    ###
'    ###
'    ####
    '
    '-----------------
    'INCLUDE '#INCLUDE
    '=================
    '
    if md=18 then
      '
      '
      'CHECK FOR FILES ALREADY INCLUDED
      '--------------------------------
      '
      '
      a=0 : c=0
      do
        wd=noquotec(wword(s,i))
        if wd="once" then a=1 else exit do
      loop
      w1=filename(wd)
      if a then
        b=0
        do
          if b>=fql then exit do
          if w1=ssn(b) then c=1 : d=ssh(b) : exit do
          b+=1
        loop
      end if
      '
      ssn(fql)=w1 'NAME LOG (WITH HASH)

      if len(wd)>0 then
        if fq>63   then ers="Too many nested 'include' files "+wd : ert=40 : goto exitap
        if fql>999 then ers="Too many 'include' files "+wd : ert=40 : goto exitap
        '
        'RESOLVE FILE PATH
        '-----------------
        '
        '
        if len(ipath) then
          wd=ipath+wd
        end if

        #IFDEF HOSTED
        '
        inclpath(wd)
        '
        #ENDIF

        '
        ssf(fq)=wd            'REMEMBER NAME
        '
        'SAVE REMAINING PARENTAL
        '-----------------------
        '
        sst(fq)=mid(s,i) 
        i=1 : bgl=1
        '
        'GET THE INCLUDE
        '---------------
        '
        dim as any ptr ps,pw        
        ps=varptr(s)
        pw=strptr(wd)
        asm
          push [pw]
          call getfile
          push [ps]
          push eax
          call bstr_to_fstr
        end asm
      
        '
        'CHECK FOR EMPTY OR NON-EXISTENT FILE
        '------------------------------------
        '
        if s="" then
          ers="Problem with file: "+wd : ert=40
          goto exitap
        end if
        '
        'CHECK IF PRIOR FILE SEEMS IDENTICAL
        '-----------------------------------
        '
        e=hashid(s)

        if c then
          if d=e then
            s=sst(fq) : continue do 'ALREADY SEEN SO REVERT TO PARENT
          end if
        end if
        '
        ssh(fql)=e : stb(fq)=s : fq+=1 : fql+=1
        '
        if linemarkers then linemark(s) 'tag each line with line number
      end if
      '
      goto mainloop
      '
    end if


  '==================
  'OTHER o2 KEYWORDS:
  '==================



  a=0
  if md=19 then o2h=0 : bref=0 : a=1 '#ASM 'ASM
  if md=20 then o2h=1 : bref=1 : a=1 '#O2H 'O2H '#BASIC 'BASIC
  '
  if a then
    while isx(ascn)=0
      cpus(word(s,i))
    wend
    goto mainloop
  end if


  'EXPOSED
  '
  if md=21 then
    appendt("o2 sx"+cr)
    a=i : captproch(s,i) : wx+="declare "+mid$(s,a,i-a)+cr : i=a
    goto mainloop
  end if



  'INCLUDEPATH
  '
  if md=30 then
    paths(s,i,ipath)
     goto mainloop
  end if



  'LIBRARYPATH
  '
  if md=31 then
    paths(s,i,lpath)
    goto mainloop
  end if


  if md=42 then leaf=1                : goto mainloop 'LEAF


  'O2PATH
  '
  if md=32 then
    hostdll=noquotes(mword(s,i))
    goto mainloop
  end if


  '#ALERT
  '#ERROR
  '
  if (md=46)or(md=47) then
    ers=captureblock(s,i,wr) : ert=md-45 : ow=""
    goto exitap
  end if

  '#LOOKAHEAD
  '
  if md=43 then
    MakeHeaders(mid(s,i),w1,"",1)
    inserts(s,w1,i)
    if ert then goto exitap
    goto mainloop
  end if


  '#AUTODIM
  '-------
  '
  if md=44 then 
    yesno(s,i,relaxed) : goto mainloop
  end if


  '#MINORMAJOR
  '----------
  '
  if md=45 then 
    yesno(s,i,minormajor) : goto mainloop
  end if

  '#UNIQUE
  '-------
  '
  if md=49 then 
    yesno(s,i,uniq) : goto mainloop
  end if


  '#CONSOLE
  '-------
  '
  if md=50 then 
    cnsl=1 : goto mainloop
  end if


  'REM
  '#PRAGMA
  '-------
  '
  if (md=25)or(md=48) then
    endline(s,i) : appendt(cr)
    goto mainloop
  end if

  '#CASE
  '-----
  '
  if md=41 then
    if isx(ascn)=0 then
      wr=lcase(word(s,i))
      casf=dic(" insensitive 1, sensitive 2, capital 3, capitalsensitive 3, ",wr)
    end if
    goto mainloop
  end if

  '
  '#FILE
  '-----
  '
  if md=35 then
    if isx(ascn)=0 then
      pexn=noquotes(mword(s,i))
      w1=lcase(right(pexn,3))
      pef=0
      if w1="dll" then pef=1
      if w1="exe" then pef=2
      do
        if isx(ascn) then exit do
        w1=word(s,i)
        if w1="independent" then independent=1
        cpus(w1)
      loop
    end if
    goto mainloop
  end if

  


  '------------------------
  'COMPILE TIME DIAGNOSTICS
  '========================
  '
  if md>200 then
    a=swd
    if ise(ascn)=0 then w1=word(s,i) 'no macro expansion
    endline(s,i) : w2=mid(s,a,i-a) : striplineno(w2)
    w3=""
    select case md
    case 201
      w3=" "+str(brc) '#BLOCKDEPTH
    case 202
      a=lookupm(w1)
      if a then w3=cr+writestate(a,a) else w3="Not found" '#RECORDOF
    end select
    qq w2+w3,md 'display at compile time
    goto mainloop
  end if


  '-------------------------
  'META COMMANDS: #IFDEF ETC
  '=========================
  '
  if md>=100 then
    metaco(s,i)
    if ert then goto exitap
    goto mainloop
  end if

  

  '########################

  'ADD ANY UNPROCESSED CODE
  'CHECK FOR OTHER STREAMS

  '########################


  '======
  addsrc:
  '======


    'PASS THRU UNPROCESSED WORDS
    '---------------------------
    '
    'INCLUDE SINGLE CR/LF (NOT MULTIPLE CR)
    '
    a=asc(s,i)
    if a=13 then i+=2 ' ASSUME CRLF
    if a=10 then i+=1 ' ASSUME LF ONLY
    wsg=mid(s,swd,i-swd)
    appendt(wsg) ' given spacing, line breaks etc
    nl=0
    '
    'END-OF-LINE CHECKS
    '------------------
    '
    if a<=13 then
      '
      'ANY REMAINING ASSIGNMENT CODE
      '-----------------------------
      '
      if len(asg) then mid(t,j)=asg : j+=len(asg) : asg="" : a=13
      '
      if a=0 then
        '
        'END OF CURRENT SOURCE STREAM
        '----------------------------
        '
        '
        '------------------------------------
        'INSERT NEXT INCLUDED CONTENT, IF ANY
        '------------------------------------
        '
        if fq then
          fq-=1 ' resume previous source string
          i=1 : s=sst(fq) : skiplspace(s,i)
          goto mainloop
        end if
        '
        'EXPRESS DECLARATIONS HERE ---> BIND DLLS
        '-------------------------
        '
        if impo then appendt(sq) : bindlprocs() : appendt(eq+cr) ' : goto mainloop
        '
        'CHECK FOR REMAINING CODE
        '------------------------        '
        '
        'default termination coding
        '
        if (tmnt=0)and(o2h=1)and(dep=0) then
          if pef=1 then
            wva(19)+=cr+"sub finish() external : terminate : end sub"+cr 'WHEN DLL IS UNLOADED
          else
            wva(19)+=cr+"terminate"+cr 'FOR NON-PERSISTENT PROGS
          end if
          tmnt=1
        end if
        '
        s=wva(19) : if len(s) then wva(19)="" : i=1 : goto mainloop
        '
        'EXHAUSTED ALL INPUT STREAMS
        '---------------------------
        '
        exit do ' no proc mapping
        '
      end if
      '
      goto mainloop
      '
    end if


  '=============================================
  exitap: 'COMPILE TERMINATION AND ERROR HANDLING
  '==============================================


  if ert=0 then
    if brc=-100 then
      lnmk=0 : ow="" : lbw=""
      ers="unclosed brackets at end of script ("+str(brc)+")" : ert=29
    end if
  end if

  if ert>0 then
    '
    'RECOVER ORIGINAL LINE OF SOURCE CODE
    '
    if linemarkers then
      if fq then s=stb(fq-1) else s=ss 'RESTORE `INCLUDE` BUFFER OR PRIMARY BUFFER
      linemark(s)
      findline(s,a,b)
      if a then ers=mid(s,a,b-a)+cr+ers
    end if
    '
    if ert=101 then ers+="Macro undefined or out of scope"
    if ert=102 then ers+="Macro recursion suspected: "
    if ert=103 then ers+="Method/property element not implemented"
    if ert=104 then ers+="Method pointer must have a size of "+str(cpuw)+" bytes"
    '
    if ert=1 then w1="ALERT:" else w1="ERROR:"
    endline(s,i) :    ers =w1+cr+ers+cr
    '
    if len(ow)   then ers+="WORD: "+htb+ow+cr
    if fq        then ers+="FILE: "+htb+ssf(fq-1)+cr
    if len(lbw)  then ers+="BELOW:"+htb+lbw+cr
    if lnmk      then ers+="LINE: "+htb+str(linenumber(lnmk))+cr
    '
    if vew>=2 then appendt(ers)
    '
    exit do
    '
  end if
  '
  '==========================
  loop 'FOR ANOTHER STATEMENT
  '==========================

  '
  '--------------------------------
  'STRUCTURE CODE READ FOR ASSEMBLY
  '================================
  '
  #include "o2fini.bas"

end function


