'O2 Lex

' 18:21 29/07/2008  collect lexing functions
' 09:48 27/08/2008  OOP adaptations / virtual tables
' 10:18 31/08/2008  isq isc ise functions
' 16:14 07/09/2008  array cleaning initb: null size car error 103
' 11:24 08/09/2008  %h hex ascii for macros
' 05:55 06/11/2008  split off o2sem.bas




'==================
'STRING CONVERSIONS
'==================


    '-----------------------------------------------------------------
    function ps_to_str(byval ps as any ptr, byval le as sys) as string
    '=================================================================
    dim as string src
    dim as any ptr pd
    src=space(le)
    pd=strptr(src)
    asm
      mov esi,[ps]
      mov edi,[pd]
      mov ecx,[le] 'length of data
      nexch:
        mov al,[esi] ' src
        mov [edi],al ' dest
        inc esi
        inc edi
        dec ecx
      jnz nexch
    end asm
    function=src
    end function


    '-----------------------------------------
    function lenzs(byval ps as any ptr) as sys
    '=========================================
      asm
      mov edx,[ps]
      mov ecx,0
      cmp edx,0
      jz xlenzs
      rlenzs:
        cmp byte ptr [edx],0
        jz xlenzs
        inc ecx
        inc edx
      jmp rlenzs
      xlenzs:
      mov [function],ecx
      end asm 
    end function


    '-----------------------------------------
    function lenws(byval ps as any ptr) as sys
    '=========================================
      asm
      mov edx,[ps]
      mov ecx,0
      cmp edx,0
      jz xlenws
      rlenws:
        cmp word ptr [edx],0
        jz xlenws
        inc ecx
        inc edx
        inc ecx
        inc edx
      jmp rlenws
      xlenws:
      mov [function],ecx
      end asm 
    end function


    '-------------------------------------------------------------
    function acode(byval ps as any ptr, byval le as sys) as string
    '=============================================================
      dim as any ptr p
      le*=.5
      function=string(le,chr(0))
      asm
        mov esi,[ps]
        mov edi,[function]
        mov ecx,[le]
        racode:
          dec ecx
          jl xacode
          mov al,[esi]
          mov [edi],al
          inc esi
          inc esi
          inc edi
          jmp racode
        xacode:
      end asm      
    end function



    '-------------------------------------------------------------
    function ucode(byval ps as any ptr, byval le as sys) as string
    '=============================================================
      le*=2
      function=string(le+2,chr(0))
      asm
        mov esi,[ps]
        mov edi,[function]
        mov ecx,[le]
        rucode:
          dec ecx
          jl xucode
          mov al,[esi]
          mov [edi],al
          inc esi
          inc edi
          inc edi
          jmp rucode
        xucode:
      end asm      
    end function


  #ifdef freebasic
    '---------------------------------------------------------------------------------
    sub bstr_to_fstr alias "bstr_to_fstr" ( byval srcBSTR as BSTR, byref src as string)
    '==================================================================================
    dim as sys i
    dim as any ptr j
    src=""
    if srcBSTR=0 then exit sub
    '
    'GET LENGTH
    '
    asm
      mov eax,[srcBSTR]
      mov ecx,[eax-4]
      mov [i],ecx
    end asm
    '
    if i<=0 then exit sub
    '
    'COPY DATA
    '
    src=ps_to_str(cast(any ptr,srcBSTR),i)
    '
    end sub
  #else
   macro bstr_to_fstr(a,b) b=a
  #endif



    '-----------------------------------------------------------------
    function fstr_to_ostr(byval ps as any ptr, byval le as sys) as sys
    '=================================================================
    dim as sys a=omo and 7
    static as string uc
    if a=2 then uc=ucode(ps,le)
    if (omo and 8) then
      if a<=1 then
        function=cast(long,AllocString(ps,le))
      elseif a=2 then
        function=cast(long,AllocString(strptr(uc),le*2))
      end if
    else
      if a<=1 then
        function=cast(long,ps)
      elseif a=2 then
        function=cast(long,strptr(uc))
      end if
    end if
    end function


    '---------------------------------------------------
    function istr_to_fstr(byval ps as any ptr) as string
    '===================================================
    if ps=0 then exit function
    dim as sys a=omo and 7
    if a=2 then function=acode(ps,lenws(ps)) else function=ps_to_str(ps,lenzs(ps))
    end function





'========
'IS WHAT?
'========



'QUOTEMARK

'----------------------------------
function isq(byval a as sys) as sys
'==================================

  asm
    mov al,[a]
    xor ecx,ecx
    inc ecx
    cmp al,[iq1]
    jz disq
    cmp al,[iq2]
    jz disq
    cmp al,[iq3]
    jz disq
    cmp al,250 'IQ4
    jz disq
    jmp xisq
    disq:
    mov [function],ecx
    xisq:
  end asm
end function


'COMMENT

'----------------------------------
function isc(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    xor ecx,ecx
    inc ecx
    cmp al,[ct1]
    jz disco
    cmp al,[ct2]
    jz disco
    jmp xisco
    disco:
    mov [function],ecx
    xisco:
  end asm
end function


'END OF LINE OR COMMENT

'----------------------------------
function ise(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    xor ecx,ecx
    inc ecx
    cmp al,[ct1]
    jz dise
    cmp al,[ct2]
    jz dise
    cmp al,13
    jbe dise
    jmp xise
    dise:
    mov [function],ecx
    xise:
  end asm
end function


'END OF STATEMENT

'----------------------------------
function iss(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    xor ecx,ecx
    inc ecx
    cmp al,[ct1]
    jz diss
    cmp al,[ct2]
    jz diss
    cmp al,58
    jz diss
    cmp al,13
    jbe diss
    jmp xiss
    diss:
    mov [function],ecx
    xiss:
  end asm
end function


'END OF EXPRESSION

'----------------------------------
function isx(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    xor ecx,ecx
    inc ecx
    cmp al,44
    jz disx
    cmp al,[rbr]
    jz disx
    cmp al,93
    jz disx
    cmp al,125
    jz disx
    cmp al,58
    jz disx
    cmp al,13
    jbe disx
    cmp al,[ct1]
    jz disx
    cmp al,[ct2]
    jz disx
    jmp xisx
    disx:
    mov [function],ecx
    xisx:
  end asm
end function


'COMPARATORS

'----------------------------------
function isi(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    cmp al,60
    jb nisi
    cmp al,62
    ja nisi
    mov dword ptr [function],1
    nisi:
  end asm
end function


'ALPHA (including all ascii above 126)
  
'----------------------------------
function isa(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    '
    cmp al,64 '@ included
    jb nisa
    cmp al,122
    ja nisa
    '
    cmp al,91
    jb yisa
    cmp al,96
    ja yisa
    cmp al,95 '_ underscore
    jz yisa
    '
    jmp nisa
    yisa:
    mov dword ptr [function],1
    '
    nisa:
    '
  end asm
end function


'NOT A SYMBOL (but # @ _ are counted in) (also all ascii above 126)

'----------------------------------
function isk(byval a as sys) as sys
'==================================
  asm
    mov al,[a]
    cmp al,35 'include hash
    jz yisk
    cmp al,48
    jb nisk
    cmp al,126
    ja yisk
    cmp al,122
    ja nisk
    cmp al,96
    ja yisk
    cmp al,95 'include underscore
    jz yisk
    cmp al,90
    ja nisk
    cmp al,63
    ja yisk 'include @
    cmp al,57
    ja nisk
    yisk:
    mov dword ptr [function],1
    nisk:
  end asm
  '
end function


'-------------------------------------------------------------
sub init4(byval p as any ptr, byval le as sys, byval c as sys)
'=============================================================
  asm
  mov edx,[p]
  mov ecx,[le]
  mov eax,[c]
  inil:
    mov [edx],eax
    add edx,4
    dec ecx
  jg inil
  end asm
end sub



'------------------------------------------
function hashcode(byref s as string) as sys
'==========================================
  dim as sys le
  dim as any ptr p
  le=len(s) : p=strptr(s)
  asm
  xor eax,eax
  mov ecx, [le]
  mov edx, [p]     ' name pointer
  mov ah,  cl      ' length
  mov al,  [edx]   ' 1st letter
  cmp cl,1
  jz xhash
  shl eax,3
  xor al,  [edx+1] ' 2nd letter
  shl eax,3
  nexh:
    rol eax,1
    xor al, [edx]
    inc edx
    dec ecx
  jnz nexh
  xhash:
  mov [function],eax
  end asm 
  '
end function



'=====================
'STRING POOL FUNCTIONS
'=====================

'-------------------------
sub macoin(byval m as sys)
'=========================
 init4 @maco(m,0),smaco,0
end sub


'-----------------------------------------------------------
sub macsi(byref w as string, byval m as sys, byval n as sys)
'===========================================================
  '
  'STORE STRING IN BUFFER
  'INDEX IT IN MACO (WITH OFFSET OF N)
  '
  dim as sys le
  n+=omacs
  le=len(w) : if le=0 then maco(m,n)=0 : exit sub
  maco(m,n)=spe
  mid(sps,spe)=mkl(le)+w
  spe=spe+le+4
end sub



'-------------------------------------------------------
function macso(byval m as sys, byval n as sys) as string
'========================================================
  dim as sys a,le
  dim as any ptr p
  n+=omacs
  a=maco(m,n) : if a=0 then exit function
  p=strptr(sps)
  asm
    mov eax,[p]
    add eax,[a]
    dec eax
    mov eax,[eax]
    mov [le],eax
    add dword ptr [a],4
  end asm
  function=mid(sps,a,le)
end function


'-------------------------------------------------------
function cmpsp(byval w as string, byval i as sys) as sys
'=======================================================
dim as sys le
dim as any ptr p,q
le=len(w) : p=strptr(w) : q=strptr(sps)
asm
  mov ecx,[p]
  mov edx,[q]
  add edx,[i]
  dec edx
  mov eax,[edx]
  cmp eax,[le]
  jnz xcmpsp 'FAIL LENGTH MATCH
  '----------
  and eax,255
  mov ah,al
  add edx,3
  dec ecx
  '---------
  rcmpsp:
  '---------
  inc edx
  inc ecx 
  sub ah,1
  jl dcmpsp 'SUCCESS
  mov al,[edx]
  cmp al,[ecx]
  jz rcmpsp 'LOOP OTHERWISE FAIL CHAR MATCH
xcmpsp:
  mov eax,0
  jmp fcmpsp
dcmpsp:
  mov eax,-1
fcmpsp:
  mov [function],eax
end asm
end function


'----------------------------------
function isw(byval a as sys) as sys
'==================================
  asm

  xor ecx,ecx
  inc ecx
  '
  mov al,[a]
  '
  cmp al,48
  jl aa1
  cmp al,57
  jle chok
  aa1:
  '
  cmp al,97
  jl aa2
  cmp al,122
  jle chok
  aa2:
  '
  cmp al,64
  jl aa3
  cmp al,90
  jle chok
  aa3:
  '
  cmp al,35
  jz chok
  '
  cmp al,95
  jz chok
  '
  cmp al,127
  jl aa4
  cmp al,199
  jle chok
  '
  aa4:
  '
  jmp xchok 'TERMINATING SYMBOL
  '
  chok:
  '
  mov [function],ecx
  '
  xchok:
  '
  end asm
  '
end function


'------------------------------------------
function lookupm(byref wd as string) as sys
'==========================================
  '
  dim as sys f,v,i,k
  i=hashcode(wd)
  '
  'TAKE THE BOTTOM 9 BITS OF THE HASH CODE
  'TO FORM A BASE INDEX TO SELECT A CHAIN
  '
  v=i and 511
  '
  'FIND THE LAST MATCHING NAME IN THE CHAIN
  '
  f=0
  do
    if mach(v).h=i then ' match#
      k=mach(v).m
      if k>=me then
        mach(v).m=0  'ZERO MACS PTR WHEN OUT OF SCOPE
      else
        if k>0 then if cmpsp(wd,maco(k,omacs)) then f=k : mph=v 'MATCH CANDIDATE
      end if
    end if
    '
    'GET THE NEXT INDEX IN THE CHAIN
    '
    v=mach(v).l
    '
    'AND CHECK FOR CHAIN TERMINATION
    '
    if v<512 then exit do 'NO MORE AVAILABLE
  loop
  '
  if f then
    mach(mph).t+=1
    function=f 'INDEX OF MATCHING NAME OR NULL
  end if
  '
end function

'------------------------------------------
function lookupc(byref wd as string) as sys
'==========================================
  dim as sys v,i
  i=hashcode(wd):v=i and 511
  do
    if opd(v,0)=i then ' match#
      if wd=opn(v) then exit do ' confirm perfect match
    end if
    v=opd(v,1) : if v=-1 then exit do
  loop
  function=v
end function


'--------------------------------------------------------------
function instrword(byref s as string, byref w as string) as sys
'==============================================================
  '
  dim as sys a,b,c,d,e,f
  if w="" then exit function
  a=ascw : b=ascn : c=swd : d=1 : e=len(w)
  do
    d=instr(d,s,w) : f=0
    if d=0 then exit do 'NOT FOUND  
    if d=1 then
      f=1 'LEFT BOUNDARY
    else
      if asc(s,d-1)<33 then f=1
    end if
    if (f=1)and(asc(s,d+e)<33) then exit do
    d+=e 
  loop
  ascw=a : ascn=b : swd=c ' restore state
  '
  function=d
  '
end function


'---------------------------------------------
function isreserved(byref wr as string) as sys
'=============================================
  dim as sys a,b
  if wr="" then exit function
  '
  a=lookupm(wr)
  if a then
    if uniq then
      if mach(mph).b=brc then
        ers="'"+wr+"' is already defined"  : ert=13 : function=-1
        exit function
      end if
    end if
    b=maco(a,0)
    if (b=-9)or(b=-10) then
      ers="'"+wr+"' is a reserved word"  : ert=13 : function=-1
    elseif a<mesb then
      'ers="'"+wr+"' is a reserved symbol"  : ert=13 : function=-1
    end if
  end if
  '
  if lookupc(wr)>=0 then
    ers="'"+wr+"' is ASM instruction" : ert=13 : function=-1
  end if
  '
  'if instrword(" fld fadd fsub fmul fdiv fst ",wr) then function=1
  'if instrword(" mov add sub mul div inc dec shl shr sal sar rol ror ",wr) then function=1
  '
end function


'----------
sub addme()
'==========
  me+=1 : if me>=maxit then ers="Too many definitions" : ert=10 : me=maxit-1
end sub


'-------------------------
sub addmin(byval m as sys)
'=========================
  '
  dim as sys i,j,k,t
  '
  i=hashcode(macso(m,0)) : if i=0 then ers="zero hash failure: "+macso(m,0) : ert=13 : exit sub
  j=i and 511
  do
    t+=1
    if (mach(j).l<=0)or(mach(j).l>=mle)or(mach(j).m>=me) then
      if mle>=maxit then
        ers="Too many entities to include "+macso(m,0) : ert=13 : exit do
      end if
      if (j>=512)or(mach(j).h<>0) then
        mach(j).l=mle : j=mle : mle+=1
      end if
      '
      mach(j).t=0   'USAGE TALLY
      mach(j).h=i   'FULL HASH CODE
      mach(j).l=0   'LINK TO NEXT
      mach(j).m=m   'INDEX TO MACO
      mach(j).b=brc 'NESTING LEVEL
      exit do 
      '
    end if
    j=mach(j).l ' next in chain
  loop
  if t>lmax then lmax=t
  '
end sub

'-----------------------
sub addm(byval m as sys)
'=======================
  if isreserved(macso(me,0)) then exit sub
  addmin(m)
end sub


'------------------------------------------------------
function capm(byval i as sys, byval k as sys) as string
'======================================================
  function=str(maco(i,k))+snp+cr
end function

'------------------------------------------------------------
function writestate(byval b as sys, byval e as sys) as string
'============================================================
  dim as string s,w1,w2,c
  dim as sys i,k,le
  c=snp+cr
  k=1
  for i=b to e
    w1=capm(i,0)+capm(i,1)+capm(i,2)+capm(i,3)+capm(i,4)+capm(i,5)
    w2=macso(i,0)+c+macso(i,1)+c+macso(i,2)+c+macso(i,3)+c
    le=len(w1)+len(w2)
    if k+le>len(s) then s+=space(8000)
    mid(s,k)=w1+w2
    k+=le
  next
  if k>1 then function=iq+left(s,k-1)+iq+cr
end function


'---------------------------------------------------------
function nexm(byref s as string, byref i as sys) as string
'=========================================================
  dim as sys k
  k=instr(i,s,snp)
  if k then function=mid(s,i,k-i)
  i=k+3 ' skip snp followed by cr
end function



'-------------------------------
sub readstate(byref s as string)
'===============================
  dim as sys c,i,k
  dim as string w1
  i=2
  do
    if i>=len(s) then exit do
    k=me : addme : if ert then exit do
    for c=0 to 5 'omacs-1
      w1=nexm(s,i)
      maco(k,c)=wval(w1)
    next
    for c=0 to 3
      w1=nexm(s,i)
      macsi(w1,k,c)
    next
    addm(k) : if ert then exit do
  loop
end sub



'=======================
'=======================



'---------------------------------------------
sub symbols(byref s as string, byref i as sys)
'=============================================
  '
  'DEFAULT ()"``';
  '
  lbr=asc(s,i) : i+=1 'LEFT BRACKET
  rbr=asc(s,i) : i+=1 'RIGHT BRACKET
  iq1=asc(s,i) : i+=1 'QUOTE MARK 1
  iq2=asc(s,i) : i+=1 'QUOTE MARK 2
  iq3=asc(s,i) : i+=1 'QUOTE MARK 3
  ct1=asc(s,i) : i+=1 'COMMENT MARK 1
  ct2=asc(s,i) : i+=1 'COMMENT MARK 2
  i+=1
end sub


'-----------------------------------------------
sub nextspace(byref s as string, byref i as sys)
'===============================================
  '
  dim as sys le
  dim as any ptr p
  p=strptr(s)
  le=len(s)
  asm
    mov ecx,[p]
    mov esi,ecx 'copy of p
    mov edi,[i] 'i byref
    mov eax,[edi]
    cmp eax,[le]
    ja xnexspc
    dec eax
    add ecx,eax
    rnexspc:
      mov al,[ecx]
      inc ecx
      cmp al,32
    ja rnexspc
    sub ecx,esi   'calc new i
    mov [edi],ecx 'update i
    xnexspc:
  end asm
  '
end sub


'  #####  #####  #####  #####  #####
'  #####  #####  #####  #####  #####
'  #####  #####  #####  #####  #####






'----------
sub lascn()
'==========
asm
  cmp al,65
  jl skuc
  cmp al,90
  jg skuc
  add al,32
  skuc:
  mov [ascn],al
end asm
end sub


#if 0
'--------------------------------------------------------
function skipsp(byref s as string, byref i as sys) as sys
'========================================================
dim as sys le=len(s)
dim as any ptr p=strptr(s)
if le=0 then i=1 : exit function
asm
  mov ecx,[p]
'  mov ecx,[s]
'  mov ecx,[ecx]
  mov edi,ecx
  mov esi,[le]
  mov edx,[i]
  mov edx,[edx]
  add ecx,edx
  dec ecx
  rskp:
  inc ecx
  cmp edx,esi ' PAST END OF STRING?
  jle skpd
    mov al,0
    jmp xskp
  skpd:
  inc edx
  mov al,[ecx-1]
  cmp al,0 ' NULL
  jz xskp
  cmp al,32 'OTHER WHITE SPACE
  jbe rskp
  xskp:
  mov [function],al
  sub ecx,edi
  mov eax,[i]
  mov [eax],ecx
  'mov nwd,ecx
end asm
end function
#endif

'-----------------------------------------------
sub skipspace(byref s as string, byref i as sys)
'===============================================
dim as sys le=len(s)
dim as any ptr p=strptr(s)
asm
  mov ecx,[p]
  'mov ecx,[ecx] 'deref
  mov edi,ecx
  mov esi,[le]
  mov edx,[i]
  mov edx,[edx]
'cmp edx,0
'jg leok
'mov edx,1 'MIN INDEX
'leok:
  add ecx,edx
  dec ecx
  rskip:
  inc ecx
  cmp edx,esi ' PAST END OF STRING?
  jle skbd
    mov al,0
    jmp xskip
  skbd:
  inc edx
  mov al,[ecx-1]
  cmp al,0 ' NULL
  jz xskip
  cmp al,32 'OTHER WHITE SPACE
  jbe rskip
  xskip:
  call lascn
  sub ecx,edi
  mov eax,[i]
  mov [eax],ecx
  'mov nwd,ecx
end asm
end sub



'-------------------------------------------------
sub skiplspace (byref s as string, byref i as sys)
'=================================================
dim as sys le=len(s)
dim as any ptr p=strptr(s)
asm
  mov ecx,[p]
  'mov ecx,[ecx] 'deref
  mov edi,ecx
  mov esi,[le]
  mov edx,[i]
  mov edx,[edx]
  add ecx,edx
  dec ecx
  rskipl:
  inc ecx
  cmp edx,esi ' END OF STRING
  jle skbld
    mov al,0
    jmp xskipl
  skbld:
  inc edx
  mov al,[ecx-1]
  cmp al,9 ' TAB
  jz rskipl
  cmp al,13 ' END OF LINE
  jbe xskipl
  cmp al,32 'OTHER WHITE SPACE
  jbe rskipl
  xskipl:
  call lascn
  sub ecx,edi
  mov eax,[i]
  mov [eax],ecx 'SAVE INDEX BYREF
  mov nwd,ecx
end asm
end sub



'--------------------------------------------
sub endline(byref s as string,byref i as sys)
'============================================
dim as sys le=len(s)
dim as any ptr p=strptr(s)
asm
  mov ecx,[p]
  'mov ecx,[ecx] 'deref
  mov edi,ecx
  mov esi,[le]
  mov edx,[i]
  mov edx,[edx]
  add ecx,edx
  dec ecx
  rskl:
  inc ecx
  cmp edx,esi ' END OF STRING
  jle skld
    mov al,0
    jmp xskipl
  skld:
  inc edx
  mov al,[ecx-1]
  cmp al,10 ' LINE FEED
  jz xskl
  cmp al,13 ' RETURN
  jz xskl
  jmp rskl
  xskl:
  sub ecx,edi
  mov eax,[i]
  mov [eax],ecx
end asm
end sub


'-----------------------------
sub clcase(byref wr as string)
'=============================
  '
  '0 CASE INSENSITIVE
  '1 CASE INSENSITIVE
  '2 CASE SENSITIVE
  '3 CAPITALISED WORD SENSITIVE
  '
  dim as any ptr p=strptr(wr)
  asm
  mov ecx,[p]
  'mov ecx,[ecx] 'DEREF
  cmp ecx,0
  jz xclcase 'NULL STRING ?
  mov ah,0
  mov edx,[casf]
  cmp edx,2
  jz xclcase  'CASE SENSITIVE
  jl rclcaseL 'CASE INSENSITIVE
  jg rclcaseC  'CASE CAPITAL
  '
  rclcaseL: 'CONVERT LOWER CASE
    mov al,[ecx]
    inc ecx
    cmp al,33
    jb xclcase
    cmp al,65
    jb rclcaseL
    cmp al,90
    ja rclcaseL
    or al,32
    mov [ecx-1],al
    jmp rclcaseL
    '
  rclcaseC:
    mov al,[ecx]
    inc ecx
    cmp al,33
    jb xclcase
    'TEST FOR NON LOWERCASE
    cmp al,97
    jb rclcaseC
    cmp al,122
    ja rclcaseC
    'OTHERWISE CONVERT ALL TO LOWERCASE
    mov ecx,[p]
    'mov ecx,[ecx] 'DEREF
    jmp rclcaseL
  '
  xclcase:
  end asm
  '
end sub


'---------------------------------------------------------
function ccomment(byref s as string,byref i as sys) as sys
'=========================================================
  dim as sys b,c
  b=asc(s,i+1)
  if b=47 then
    c=i
    endline(s,i) : function=1
  elseif b=42 then
    c=instr(i+2,s,"*/") : if c then i=c+2 : function=2
  else
    exit function
  end if
  skiplspace(s,i)
end function


'------------------------------------------------------------
function ccommentbl(byref s as string, byref i as sys) as sys
'============================================================
  dim as sys a,b
  b=i : a=ccomment(s,i)
  if a then
    mid(s,b)=space(i-b)
    function=a
  end if
end function


'--------------------------------------------------
sub nextinstruct(byref s as string, byref i as sys)
'==================================================
  '
  'SKIP COMMENTS AND BLANK LINES
  '
  do
    skipspace(s,i)
    if ascn=0 then exit do
    if ise(ascn) then endline(s,i) : continue do
    if ascn=47 then if ccomment(s,i) then continue do
    exit do
  loop
end sub


'------------------------------------------------
sub skipcomcom(byref s as string, byref i as sys)
'================================================
  '
  'IGNORE COMMA AND ANY SUBSEQUENT BLANK LINES AND LINE COMMENTS
  '
  if ascn=44 then i+=1 : nextinstruct(s,i)
  '
end sub 
     '

'----------------------------------------------------------
function tline(byref s as string, byref i as sys) as string
'==========================================================
  '
  dim as sys b=i
  endline(s,i)
  '
  function=mid(s,b,i-b)
  '
end function


'-----------------------------------------------
sub lineblank(byref s as string, byref i as sys)
'===============================================
  '
  'BLANK OUT REST OF LINE WITH SPACES
  '
  dim as sys le=len(s)
  dim as any ptr p=strptr(s)
  asm
    mov edi,[i]
    mov eax,[edi] 'i byref
    cmp eax,[le]
    ja xlinbln
    'mov esi,[s]
    mov ecx,[p] 's byref
    mov esi,ecx   'copy of s
    dec eax
    add ecx,eax 'position
    mov ah,32 'space
    rlinbln:
      mov al,[ecx]
      cmp al,13
      jz xlinbln
      cmp al,10
      jz xlinbln
      cmp al,0
      jz xlinbln
      mov [ecx],ah 'patch in space
      inc ecx
      jmp rlinbln
      sub ecx,esi   'calc i
      inc ecx
      mov [edi],ecx 'update i
      xlinbln:
  end asm
end sub


'-----------------------------------------------------------
function repeat(byref w as string, byval n as sys) as string
'===========================================================
  '
  dim as string s
  dim as sys i,e,lw
  lw=len(w) : e=lw*n
  s=string(e,chr(0))
  i=1
  do
    if i>e then exit do
    mid(s,i)=w : i+=lw
  loop
  '
  function=s
  '
end function


'----------------------------------------------------------------------------
sub inserts(byref s as string, byref ws as string, byref i as sys) ' reinsert
'============================================================================
  '
  'NORMAL INSERTION
  '
  if pres then
    s=left(s,i-1)+ws+mid(s,i) : exit sub
  end if
  '
  'DESTRUCTIVE INSERTION
  '
  leni=len(ws) : ascn=ascl(ws,1)
  if i>len(s) then i=len(s)+1
  '
  'PATCH STRING INTO USED BUFFER SPACE
  '
  if i>leni then inpi=i : i-=leni : mid(s,i)=ws : exit sub
  '
  'OR CHOP BUFFER AND APPEND STRING
  '
  s=ws+mid(s,i) : i=1 : inpi=len(ws)+1
  '
end sub


'----------------------------------------------
function noquotes(byref wr as string) as string
'==============================================
  '
  dim as sys a,b,c
  a=asc(wr) : b=1 : c=len(wr)
  if isq(a) then b+=1 : c-=2
  '
  function=mid(wr,b,c)
  '
end function

'----------------------------------------------
function noquotec(byref wr as string) as string
'==============================================
  '
  dim as sys a,b,c
  a=asc(wr) : b=1 : c=len(wr)
  if (isq(a))or(a=60) then b+=1 : c-=2
  '
  function=mid(wr,b,c)
  '
end function


'-----------------------------------------------
sub captquote(byval a as sys,byref p as any ptr)
'===============================================
  asm
  mov ecx,[p]
  mov edx,[ecx]
  mov ah,[a]
  inc edx
  rquoten:
    mov al,[edx]
    cmp al,0
    jz nquoten
    inc edx
    cmp al,ah
    jz nquoten
    jmp rquoten
  nquoten:
  mov [ecx],edx
  end asm
end sub



'----------------------------------------------------------
function yword(byref s as string, byref i as sys) as string
'==========================================================
  dim as sys a
  dim as any ptr p
  p=strptr(s)
  skipspace(s,i)
  asm
    mov dword ptr [lenw],0
    mov ecx,[p]
    cmp ecx,0
    jz zyword 'NULL POINTER
    mov edx,[i]
    mov eax,[edx]
    mov [swd],eax
    add ecx,eax
    dec ecx 'S POINTER
    mov edi,ecx
    ryword:
      mov al,[ecx]
      cmp al,32
      jbe xyword
      inc ecx
      jmp ryword
    xyword:
    sub ecx,edi
    mov [lenw],ecx
    add [edx],ecx 'i
    zyword:
  end asm
  skiplspace(s,i)
  if lenw>0 then function=mid(s,swd,lenw)
end function


'----------------------------------------------------------
function uword(byref s as string, byref i as sys) as string
'==========================================================
  dim as sys a
  dim as any ptr p
  p=strptr(s)
  skipspace(s,i)
  asm
    mov dword ptr [lenw],0
    mov ecx,[p]
    cmp ecx,0
    jz zuword 'NULL POINTER
    mov edx,[i]
    mov eax,[edx]
    mov [swd],eax
    add ecx,eax
    dec ecx 'S POINTER
    mov edi,ecx
    ruword:
      mov al,[ecx]
      cmp al,32
      jbe xuword
      cmp al,44
      jz xuword
      cmp al,40
      jz xuword
      cmp al,41
      jz xuword
      inc ecx
      jmp ruword
    xuword:
    sub ecx,edi
    mov [lenw],ecx
    add [edx],ecx 'i
    zuword:
  end asm
  skiplspace(s,i)
  if lenw>0 then function=mid(s,swd,lenw)
end function




'----------------------------------------------------------
function wword(byref s as string, byref i as sys) as string
'==========================================================
  dim as string wr
  wr=uword(s,i) : clcase(wr) : ascw=asc(wr) : skiplspace(s,i)
  function=wr
end function



'--------------------------------------
function encohex(byval c as sys) as sys
'======================================
'function=str(c)
'exit function
  asm
  mov eax,[c]
  mov ecx,&h10101010
  '
  mov dl,al
  shr eax,4
  and dl,&hf
  rol ecx,8
  add cl,dl
  '
  mov dl,al
  shr eax,4
  and dl,&hf
  rol ecx,8
  add cl,dl
  '
  mov dl,al
  shr eax,4
  and dl,&hf
  rol ecx,8
  add cl,dl
  '
  mov dl,al
  shr eax,4
  and dl,&hf
  rol ecx,8
  add cl,dl
  '
  '
  mov [function],ecx 'ENCODED LINE NUMBER (WORD TO UNPACKED BIGLITTLE)
  '
  end asm
end function


'-----------------------------------------
function linenumber(byval v as sys) as sys
'=========================================
  '
  asm
  mov eax,[v]
  sub eax,&h10101010 'ZERO BASE
  xor edx,edx
  '
  shl edx,4
  add dl,al
  shr eax,8
  '
  shl edx,4
  add dl,al
  shr eax,8
  '
  shl edx,4
  add dl,al
  shr eax,8
  '
  shl edx,4
  add dl,al
  shr eax,8
  '
  mov [function],edx 'DECODED LINE NUMBER (UNPACKED BIGLITTLE TO WORD )
  '
  end asm
  '
  '
end function


'------------------------------
sub LineMark(byref s as string)
'==============================
  dim as sys b,c,e,i,k,m,v,x
  dim as string d,w
  k=len(s)*1.5+100
  d=space(k) 
  i=1 : e=1 : c=0
  W=chr(16)
  do
    c+=1 'LINE COUNTER
    v=encohex(c)
    mid(d,e)=w+mkl(v) : e+=5 'ENCODED LINE NUMBER
    b=i : endline(s,i)
    if asc(s,i)=13 then i+=1
    if asc(s,i)=10 then i+=1
    m=i-b 'length of line
    if m+e>=k then d+=space(8000) : k+=8000
    mid(d,e)=mid(s,b,m)
    e+=m
    if asc(s,i)=0 then exit do 'END OF STRING
  loop
  s=left(d,e-1) 'TRIM OFF REMAINING BUFFER SPACE
 'QQ HEX(ENCOHEX(C))+CRG+STR(LINENUMBER(ENCOHEX(C))), C
end sub


'--------------------------------------------------------------
sub findline(byref s as string, byref a as sys, byref b as sys)
'==============================================================
  a=0
  if lnmk then
    a=instr(s,chr(16)+mkl(lnmk))
    if a then
     a+=5
     b=a : endline(s,b) : b+=2
    end if
  end if
end sub


'----------------------------------
sub striplineno(byref wr as string)
'==================================
  dim as sys a=1
  dim as string ke=chr(16)
  '
  'STRIP LINE NUMBERS FROM WITHIN MULTILINE STRINGS
  '
  do
    a=instr(a,wr,ke)
    if a then
      wr=left(wr,a-1)+mid(wr,a+5)
    else
      exit do
    end if
  loop
end sub




'   #######################
'  #########################
'  ###                   ###
'  ###                   ###
'  ###                   ###
'  ###                   ###
'  ###                   ### 
'  #########################
'   #######################


'--------------------------------------------------------
function wrd(byref s as string, byref i as sys) as string
'========================================================
'
' s    source
' i    position in source
' swd  start of word position
' a    ascii code
' b    quote marker
' wr   word

  dim as sys a,b,v,le
  dim as string wr
  dim as ubyte ptr p,r
  
  '
  le=len(s) : lenw=0 : ascw=0
  if (le=0)or(i>le) then  i=le+1 : swd=i : exit function
  p=strptr(s)
  '
  '======
  rwrd:
  '======
  '
  asm
    '
    'SKIP WHITE SPACE
    '
    mov ecx,[p] 'BASE OF STRING
    mov edi,ecx 'REMEMBER BASE OF STRING
    mov esi,[le]
    mov edx,[i]
    mov edx,[edx] 'BYREF I
    add ecx,edx
    dec ecx
    '
    rskp:
      mov al,[ecx]
      inc ecx
      '
      'CHECK FOR END OF STRING NULL CHAR
      '
      cmp al,0 ' NULL
      jz xskp
      '
      'CHECK FOR LINE NUMBER WATERMARK
      '
      cmp al,16
      jnz nlineno
        '
        'CAPTURE LINE NUMBER MARK
        '
        mov eax,[ecx]
        mov [lnmk],eax
        add ecx,4
        jmp rskp
        '
      nlineno:
      cmp al,32 'OTHER WHITE SPACE
      '
    jbe rskp
    '
    '
    '
    xskp: 'LOCATED START OF WORD OR END OF LINE (AL=0)
    '
    sub ecx,edi 'DEDUCT POINTER
    mov edx,[i]
    mov [edx],ecx 'SET I BYREF
    mov [swd],ecx 'SET SWD START OF WORD INDEX
    '
    add ecx,edi 'RESTORE ECX AS POINTER
    dec ecx
    mov [p],ecx 'STORE POINTER P
    mov [r],ecx
    '
    'mov [a],al 
    mov [ascw],al 'SAVE FIRST CHARACTER
    '
    'INITIAL
    '
    mov dword ptr [dtf],0
    mov dword ptr [nquot],1
    mov dword ptr [ascy],0
    '
    'CHECK FOR QUOTES
    '
    push [ascw]
    call isq
    cmp eax,0
    jz nquo
      '
      'CAPTURE QUOTE
      '
      lea eax,[p]
      push eax
      push [ascw]
      call captquote
      '
      mov eax,[p] 'GET NEW POINTER
      sub eax,[r]
      mov ecx,[i]
      add [ecx],eax 'SAVE I BYREF
      '
      mov byte ptr [nquot],0
      jmp nchechar
    '
    nquo:
    '
    '
    '=================================
    rchechar: 'LOOP FOR NEXT CHARACTER
    '=================================
    '
    xor eax,eax
    mov edx,[p]
    mov al,[edx]
    mov [a],al 'STORE CHAR
    '
    'CHECK FOR NULL TERMINATOR
    '
    cmp al,0
    jz nchechar 'EXIT WITH NULL TERMINATOR
    '
    'CHECK FOR SPACE
    '
    cmp al,33
    jb nchechar 'EXIT WITH SPACE TERMINATOR
    '
    inc dword ptr [p] 'PREINCREMENT POINTER
    '
    'CHECK FOR DOT
    '
    cmp al,46
    jnz ndotch
      '
      'WAS THERE NOT A PREVIOUS DOT?
      '
      cmp dword ptr [dtf],0
      jnz nzdtf
        '
        'RECORD DOT POSITION IN WORD
        '
        mov eax,[p]
        sub eax,[r]
        mov [dtf],eax 'FIRST DOT POSITION
      nzdtf:
      jmp rchechar
    ndotch:
    '
    'CHECK FOR NON-DELIMITING CHARACTERS
    '
    push [a]
    call isw
    cmp eax,0
    jnz rchechar 'CONTINUE IF ALPHANUM
    '
    'CHECK IF WORD WAS A SINGLE SYMBOL
    '
    mov eax,[p]
    sub eax,[r]
    dec eax
    jle nsinglsym
      dec dword ptr [p] 'THE SYMBOL WAS NOT A SELF DELIMITER
      mov eax,[a]
      mov [ascy],eax    'this records the boundary symbol
    nsinglsym:
    '
    nchechar:
    '
    'RECORD LENGTH
    '
    mov eax,[p]
    sub eax,[r]
    mov [lenw],eax
    '
    'RETURN I
    '
    add eax,[swd]
    mov ecx,[i]
    mov [ecx],eax 'i
    '
    xchechar:
    '      
  end asm

  wr=mid(s,swd,lenw)
  skiplspace(s,i)

exitw:
  '
  function=wr
  '
end function


'-----------------------------------------------------------
function quotex(byref s as string, byref i as sys) as string
'===========================================================
  dim as sys a,c,m
  dim as string wr
  nextinstruct(s,i)
  wr=yword(s,i)
  m=swd+lenw
  c=instr(m,s,wr) 'CASE SENSITIVE
  if c then 
    i=c+lenW 'SUPERQUOTE MARKER END BOUNDARY
    wr=iq+mid(s,m,c-m)+iq
    striplineno(wr) 'REMOVE LINE NUMBERS
    mid(s,swd)=wr+space(i-swd-len(wr)) 'FILL THE VOID WITH SPACES
    skiplspace(s,i) : ascw=iq4
    function=wr
  end if
end function


'---------------------------------------------------------
function word(byref s as string, byref i as sys) as string
'=========================================================
  '
  dim as string wr
  dim as sys a,b,c,m

  do 'FOR EACH UNFILTERED WORD
  '===========================

    wr=wrd(s,i)
    '
    if isq(ascw) then
      striplineno(wr)
    end if
    '
    '
    'COMPOUND SYMBOLS (case sensitive)
    '---------------------------------
    '
    if composi then
      m=composi
      do
        m-=1 : if m<0 then exit do
        a=compos(m).a
        if a=ascw then
          c=compos(m).i
          if c>=me then composi=m : continue do
          b=len(macso(c,0))-2
          if mid(s,swd,b)=mid(macso(c,0),2,b) then
            i=swd+b : mp=c : skiplspace(s,i)
            compo=mp : function=mid(s,swd,b) : goto dnword
          end if
        end if
      loop
    else
      compo=0
    end if
    '
    '
    'LINES ---- ==== **** minimum 4 characters
    '-----
    '
    a=len(s)-swd
    asm
      cmp dword ptr [a],3 'length check
      jb xlineg
      mov al,[ascw]
      cmp al,32
      jbe xlineg
      cmp al,64
      jae xlineg
      cmp al,48
      jb ylineg
      cmp al,57
      ja ylineg
      jmp xlineg
      ylineg:
      mov ecx,[s]
      mov ecx,[ecx]
      mov esi,ecx
      mov eax,[swd]
      dec eax
      add ecx,eax 'offset
      mov eax,[ecx]
      cmp al,ah
      jnz xlineg
      shr eax,8
      cmp al,ah
      jnz xlineg
      shr eax,8
      cmp al,ah
      jnz xlineg
      add ecx,4
      rlineg: 'move to end of line
        mov al,[ecx]
        inc ecx
        cmp al,13
        jz nlineg
        cmp al,10
        jz nlineg
        cmp al,0
        jz nlineg
      jmp rlineg
      nlineg:
      sub ecx,esi
      mov edx,[i]
      mov [edx],ecx 'update i
    end asm
    '
    continue do
    '
    asm
      xlineg:
    end asm
    '
    'IGNORE # $ & ? ENDINGS
    '--------------------
    '
    if o2h then
      if (ascw>47)and(ascy>0) then
        do
          asm
          mov al,[ascy]
          mov ecx,1
          cmp al,35 '#
          jz toigns
          cmp al,36 '$
          jz toigns
          cmp al,37 '%
          jz toigns
          cmp al,38 '&
          jz toigns
          cmp al,63 '?
          jz toigns
          '
          mov ecx,0 'NO MATCH
          '
          toigns:
          '
          mov [a],ecx 
          end asm
          if a then mid(s,i)=" " : i+=1 : a=0 : ascy=asc(s,i) else exit do
        loop
      end if
    end if
    '
    '
    'C COMMENTS
    '--------
    '
    if ascw=47 then
      c=swd : if ccommentbl(s,c) then i=c : continue do
    elseif ascn=47 then
      if isc(ascw)=0 then ccommentbl(s,i) 'Basic comments suppress C comments
    end if    
    '
    '
    'LINE CONTINUATION UNDERSCORES
    '=============================
    '
    if wr<>"_" then exit do
    endline(s,i) : i+=2
    mid(s,swd)=space(i-swd) 'BLANK OUT REMAINING LINE CONTENTS (COMMENTS?)
    '
  loop
  '
  'CONVERT TO LOWERCASE (except quotes)
  '====================================
  '
  if nquot then clcase(wr)
  '
  '
  '
  'LINE CONTINUATIONS
  '==================
  '
  do
    '
    if ascn<>95 then
      exit do
    else
      if asc(s,i+1)>32 then exit do 'START OF ANOTHER _WORD
    end if
    '
    'BLANK OUT UNDERSCORE AND CRLF
    '-----------------------------
    '
    b=i : endline(s,i) : i+=2
    mid(s,b)=space(i-b) : skiplspace(s,i)
    '
  loop
  '
  nadwor:
  '
  if (ascw=&h71)or(ascw=&h51) then
    if wr="quote" then
      wr=quotex(s,i)
    end if
  end if
  
  function=wr ': ewd=i-swd-lenw

  dnword:

  '
end function



'--------------------------------------------------------------
function wordahead(byref s as string, byval i as sys) as string
'==============================================================
  '
  dim as sys a,b,c,d
  a=swd : b=ascw : c=ascn : d=lnmk
  function=word(s,i)
  swd=a : ascw=b : ascn=c : lnmk=d
end function


'-------------------------------------------------------------
function instrend(byref s as string, byref w as string) as sys
'=============================================================
  dim as sys d
  d=instr(s,w)
  if d=0 then d=len(s)+1
  function=d
end function


'---------------------------------------------------------------
function splitsi(byref s as string, byref r as string) as string
'===============================================================
  dim as sys d
  d=instr(s,"@")
  if d then
    function=left(s,d-1) : r=mid(s,d+1)
  else
    function=s : r=""
  end if
end function



'--------------------------------------------------------------------
sub replacewd(byref s as string,byval w as string, byval r as string)
'====================================================================
  '
  dim as sys a,b,c,d,e,lw,lr,ls
  dim as string u
  '
  lw=len(w)
  if lw=0 then exit sub
  lr=len(r)
  '  
  do
    a=instr(a+1,s,w)
    if a=0 then exit do
    b=0
    '
    'CHECK LEFT BOUNDARY
    '-------------------
    '
    if a>1 then
      b=asc(s,a-1)
      if b=35 then
        if a>2 then
          c=asc(s,a-2)
          if c=35 then
            '
            'LEFT PASTER OPERATOR ##w
            '------------------------
            '
            s=left(s,a-3)+r+mid(s,a+lw)
            a+=lr-3
            continue do
          end if
        end if
        '
        'STRINGER OPERATOR #W
        '--------------------
        '
        '
        'QUOTE FUSION
        '------------
        '
        ls=len(s)
        '
        'FUSE LEFT
        '
        c=a-1 : d=0
        do
          if c<1 then exit do
          b=asc(s,c)
          if b=34 then d=c-1 : exit do
          if b>32 then exit do
          c-=1
        loop
        '
        'FUSE RIGHT
        '
        c=a+lw : e=0
        do
          if c>ls then exit do
          b=asc(s,c)
          if b=34 then e=c+1 : exit do
          if b>32 then exit do
          c+=1
        loop
        u=r
        if d=0 then d=a-1  : u=qu+r
        if e=0 then e=a+lw : u+=qu
        s=left(s,d)+u+mid(s,e)
        a=d+len(u)
        continue do
        '
      end if
      if isk(b) then continue do 'IS ALPHANUM
    end if
    '
    'CHECK RIGHT BOUNDARY
    '--------------------
    '
    b=asc(s,a+lw)
    '
    if b=35 then
      '
      'CHECK FOR RIGHT PASTER OPERATOR
      '-------------------------------
      '
      if asc(s,a+lw+1)=35 then
        '
        s=left(s,a-1)+r+mid(s,a+lw+2) : a+=lr-1
        continue do
        '
      end if
      '
    end if
    '
    'NO RIGHT BOUNDARY
    '-----------------
    '
    if isk(b) then continue do
    '
    'MAKE SUBSTITUTION
    '-----------------
    '
    s=left(s,a-1)+r+mid(s,a+lw) : a+=lr-1
    '
  loop
  '
end sub



'-----------
sub bytcon()
'===========
 asm
   mov al,[edi]
   and al,15
   cmp al,9
   jle nuhw1
   add al,7
   nuhw1:
   add al,48
   mov [edx],al
   dec edx
   mov al,[edi]
   shr al,4
   cmp al,9
   jle nuhw2
   add al,7
   nuhw2:
   add al,48
   mov [edx],al
  end asm
end sub



'CONVERT TO TEXT HEX (1 LEADING SPACE)

'--------------------------------------
function hexb(byval v as sys) as string
'======================================
  '
  function=space(3)
  asm
   lea edx,[function]
   mov edx,[edx]
   add edx,2
   lea edi,[v]
   call bytcon
  end asm
  '
end function


' CONVERT TO TEXT HEX WORD


'--------------------------------------
function hexw(byval v as sys) as string
'======================================
  function=space(6)
  asm
   lea edx,[function]
   mov edx,[edx]
   add edx,2
   lea edi,[v]
   call bytcon
   add edx,4
   inc edi
   call bytcon
  end asm
end function


'CONVERT TO TEXT HEX DWORD

'----------------------------------------
function hexl(byval v as ulong) as string
'========================================
  function=space(12)
  asm
   lea edx,[function]
   mov edx,[edx]
   add edx,2
   lea edi,[v]
   call bytcon
   add edx,4
   inc edi
   call bytcon
   add edx,4
   inc edi
   call bytcon
   add edx,4
   inc edi
   call bytcon
  end asm
end function


'GET VALUE OF WORD (INCLUDING FLOATING POINT AND E NOTATION)


'------------------------------------------------------
function numco(byref s as string,byref i as sys) as sys
'======================================================
  ' &h... &o... but excluding & h... * o...
  '
  dim as sys a,b,c,e
  dim as string ws
  a=asc(s,swd) : if isn(a) then function=1 : exit function 'IS A DECIMAL NUMBER
  if a<>38 then exit function                          'IS NOT HEX/OCT/BIN BASED NUMBER
  a=ascl(s,swd+1)
  if (a=&h62)or(a=&h68)or(a=&h6f) then
    ws=wordahead(s,i)
    a=ascl(ws,1)
    if a=&h68 then b=&h78 else b=a
    c=2 : e=len(ws)
    do
      if c>e then exit do
      a=instr(".0123456789abcdef",mid(ws,c,1))
      if a=0 then
        exit function             'NOT HEX
      elseif b=&h61 then
        if a>3 then exit function 'NOT BINARY
      elseif b=&h6f then
        if a>9 then exit function 'NOT OCTAL
      end if
      c+=1
    loop
    mid(s,swd)="0"+chr(b) : ascw=48 : function=1 'CONVERT FOR ISN() TEST
  end if
end function

'--------------------------------------------------------------
sub wordval(byref s as string, byref st as sys, byref i as sys)
'==============================================================
  '
  dim as string wd
  dim as sys sg,a,b,d
  nan=0
  i=st
  wd=word(s,i) : a=ascw
  if a=38 then '&
    if i=swd+1 then wd+=word(s,i)
    goto exwordval
  end if
  if a=45 then
    if (isn(ascn)=0)or(ascn=45) then dv=0 : nan=1 : exit sub
    b=swd : wd=word(s,i) : a=ascw : sg=1 : swd=b
  end if
  if dtf=1 then a=asc(wd,2)
  if isn(a)=0 then dv=0 : nan=1 : exit sub
  if dtf then if sg then dtf+=1
  
  d=dtf
  '
  'E NUMBERS
  '
  if ascl(wd,len(wd))=&h65 then
    a=asc(s,i)
    if (a=45)or(a=43) then i+=1 : wd+=chr(a)+word(s,i)
  end if
  '
  exwordval:
  '
  dv=Wval(wd)
  swd=st
  if sg then dv=-dv
  dtf=d
end sub

'--------------------------------------------------------------
sub wordeval(byref s as string,byref st as sys, byref i as sys)
'==============================================================
  '
  ' COMBINE SUMS OF LITERAL NUMBERS
  '
  dim as sys a,b,c,D
  dim as string w1
  dim as double vv
  b=st
  '
  'itr subsequent &h numbers not detected
  'itr no precedence
  '
  i=st
  do
    if asc(s,b)=35 then
      w1=word(s,b) : a=getvarptr(mid(w1,2)) : i=b : dv=a
      if a=0 then ers="e000 Cant find: "+w1 : ert=1 : exit sub
    else
      wordval(s,b,i)
    end if
    '
    if d then dv+=vv
    if (ascn=43)or(ascn=45) then
      c=ascn : w1=wordahead(s,i)
      if isn(asc(s,nwd)) then
        b=nwd : vv=dv : if c=45 then b=i
        d=1 : continue do
      end if
    end if
    exit do
  loop
  ascw=asc(s,st)
end sub



'----------------------------------------------------------------------------
function instrwd(byval i as sys, byref s as string, byref w as string) as sys
'============================================================================
  '
  dim as sys k
  dim as string r
  k=swd
  do
    r=word(s,i)
    if r="" then exit do
    if r=w then function=swd : exit do
  loop
  swd=k
end function


'-------------------------------------------------------------
function wordfrag(byref s as string, byref i as sys) as string
'=============================================================
  '
  ' a boundary character
  ' r last char of fragment
  '
  dim as sys b,j
  '
  'SKIP SPACE AND MARKERS
  '
  do
    b=asc(s,i)
    if b=0 then exit do
    if (b>35)and(b<>64) then exit do
    i+=1
  loop
  j=i
  '
  'LOCATE NEXT SPACE OR MARKER
  '
  do
    b=asc(s,i)
    if (b<36)or(b=64) then exit do
    i+=1
  loop
  function=mid(s,j,i-j)
end function


'-----------------------------------------------
sub skipquote(byref s as string, byref i as sys)
'===============================================
  dim as sys a,b
' skip quoted expression
  b=asc(s,i)
  do
    i+=1 : a=asc(s,i)
    if (a=b)or(a=0) then i+=1 : exit do
  loop
end sub

'CAPTURE BRACKETED SOURCE CODE OR GENERAL TEXT



'-----------------------------------------------------------------------------
sub capture(byref s as string, byref m as sys, byref i as sys, byref c as sys)
'=============================================================================
  '
  ' s source string
  ' m beginning of capture (o)
  ' i source index (io)
  ' c beginning ascci char code
  ' v nesting depth counter
  ' k nesting flag
  ' a ascii code
  ' b another ascii code
  '
  'itr bypass c comments composite names etc. need to use word()
  '
  dim as sys v,k,a,b,e,br,rb
  dim as string wr
  skipspace(s,i)
  e=len(s)
  m=i
  c=asc(s,m)
  v=0
  do
    if i>e then
      if v>0 then
        ers="e000 brackets not closed "
      else
        ers="e000 Unexpected end of source code"
      end if
      ert=1 : exit do 'past end of string
    end if
    '
    a=asc(s,i)
    '
    if isq(a) then skipquote(s,i) : continue do
    if a=47 then if ccommentbl(s,i) then continue do
    '
    if (a=&h51)or(a=&h71) then
      if wordahead(s,i)="quote" then
        a=0
        if i>1 then if asc(s,i-1)<33 then a=1
        if a=1 then i=nwd : wr=quotex(s,i)
        continue do
      end if
    end if
    '
    'END OF SINGLE LINE MACRO?
    '
    if k=0 then if ise(a) then exit do
    '
    if (a=91)or(a=123) then if br=0 then br=a : rb=a+2
    if a=lbr then if br=0 then br=lbr : rb=rbr
    if a=br then k=1
    if k=1 then
      if isc(a) then endline(s,i) : continue do 'BYPASS COMMENT
      if a=br then
        '
        'INCR NESTING LEVEL
        '
        v+=1
      elseif a=rb then
        '
        'DECR NESTING LEVEL
        '
        v-=1
        '
        'END OF NESTING
        '
        if v<=0 then
          '
          'TERMINATING BRACKET?
          '
          if c=br then i+=1 : exit do ' include end bracket
          '
          'OTHERWISE REVERT TO SINGLE LINE MODE
          '
          k=0
          '
        end if
      end if
      '
      'REACHED END OF STRING
      '
      'if a=0 then
      'end if
      '
    end if
    i+=1
  loop
end sub



'------------------------------------------------------------------------------
sub capturi (byref s as string, byref m as sys, byref b as sys, byref i as sys)
'==============================================================================
    dim as sys a
    capture(s,m,i,a) : b=i-m : if (a=lbr)or(a=123) then m+=1 : b-=2
end sub


'-------------------------------------------------------------------------------
sub captures (byref s as string, byref m as sys, byref b as sys, byref i as sys)
'===============================================================================
  dim as sys a,c
  dim as string wr
  skiplspace(s,i) : m=i : a=ascn : c=i
  do
    if iss(ascn) then exit do
    wr=word(s,i)
  loop
  b=i-m
  ascw=a : swd=c ' first word or end of statement/line
end sub


'----------------------------------------------------------------------------------------------------
sub capturend (byref s as string, byref m as sys, byref b as sys, byref i as sys, byref we as string)
'====================================================================================================
  dim as sys a
  dim as string wr
  skipspace(s,i)
  m=i
  do
    wr=word(s,i)
    if wr="" then
      b=0 : i=m : exit do ' no terminator found so null capture
    elseif (ascw=lbr)or(ascw=91) then
      a+=1 ' ( [ nestings bypass
    elseif (ascw=rbr)or(ascw=93) then
      a-=1 ' ) ]
    elseif isc(ascw) then
      endline(s,i)
    elseif wr=we then
      a+=1
    elseif wr="end" then
      if wordahead(s,i)=we then
        b=swd-m
        wr=word(s,i)
        if a<=0 then exit do
        a-=1
      end if
    end if
  loop
  if mid(s,m+b-2,2)=cr then b-=2 ' REMOVE CRLF TO MAINTAIN INLINE
end sub


'--------------------------------------------------------------------------------------------------
sub captureb(byref s as string, byref i as sys, byref m as sys, byref b as sys, byref wr as string)
'==================================================================================================
  dim as sys a
  dim as string w1
  skiplspace(s,i)
  if ascn=44 then skipcomcom(s,i)
  if ise(ascn) then
    nextinstruct(s,i)
    if (ascn<>lbr)and(ascn<>123) then capturend(s,m,b,i,wr) : exit sub
  end if
  '
  '
  '
  'OTHERWISE LOOK FOR END BRACKET
  '
  capturi(s,m,b,i)
  '
  'BUT ALSO LOOKAHEAD TO SEE IF `END ???` EXISTS
  '
  if wordahead(s,i)="end" then
    skipspace(s,i) : a=i
    if wordahead(s,nwd)=wr then m-=1 : b=a-m : i=nwd 
  end if
  if mid(s,m+b-2,2)=cr then b-=2 ' OMIT FINAL CRLF TO MAINTAIN INLINE
  '
end sub


'--------------------------------------------------------------------------------------------------
sub captured(byref s as string, byref i as sys, byref m as sys, byref b as sys, byref wr as string)
'==================================================================================================
  dim as string w1
  if (ascw=lbr)or(ascw=123) then
    i-=1 : ascn=ascw
  else
    '
    'CONTINUE TILL NEXT BOUNDARY
    '
    do
      if (isx(ascn)>0)or(ascn=lbr)or(ascn=123) then exit do
      w1=word(s,i)
    loop
    '
  end if
  '
  'SKIP BLOCK
  '
  captureb(s,i,m,b,wr)
  '
  skiplspace(s,i)
  do
    skipcomcom(s,i)
    if isx(ascn) then endline(s,i) : i+=2 : exit do
    w1=word(s,i) '
  loop
end sub

'-------------------------------------------------------------------------------------
function captureblock(byref s as string, byref i as sys, byref wr as string) as string
'=====================================================================================
  dim as sys m,b
  captureb(s,i,m,b,wr)
  if b then function=mid(s,m,b)
  'endline(s,i)
end function


'---------------------------------------------------
sub endcomcomline(byref s as string, byref i as sys)
'===================================================
  '
  'SKIP TO THE NEXT LINE END THAT HAS NO CONTINUATION COMMA
  '
  dim as string wr
  dim as sys m,b
  skiplspace(s,i) : if iss(ascn) then exit sub
  do
    wr=word(s,i)
    if (ascw=lbr)or(ascw=123) then i=swd : capturi(s,m,b,i) : skiplspace(s,i)
    if iss(ascn) then
      if ascw<>44 then exit do
      endline(s,i)
    end if
  loop
  if isc(ascn) then endline(s,i)
end sub      '



'--------------------------------------------------------------------
sub capts(byref s as string, byref i as sys) ' next statement or line
'====================================================================
  '
  'CAPTURE EXPRESSION
  '
  dim as sys a,b,m
  dim as string wr
  skiplspace(s,i) : b=i
  do
    if (ascn=lbr)or(ascn=91)or(ascn=123) then
      capture(s,m,i,a) : skiplspace(s,i) : continue do
    end if
    if isc(ascn) then
      endline(s,i) : exit do
    end if
    if isx(ascn) then
      exit do ' ,:;)
    end if
    '
    wr=word(s,i)
    '
    if wr="data" then
      do
        skipspace(s,i)
        if isc(ascn) then endline(s,i) : continue do else exit do
      loop
    end if
    '
    if (wr="as")or(wr="at") then
      i=swd : ascn=97 : exit do
    end if
    '
    if instrword(" + - * / & | < = > ! and or xor not ",wr) then nextinstruct(s,i)
    '
  loop
  swd=b
end sub


'----------------------------------------------------------------------------
function findas(byref s as string, byref i as sys, byref wr as string) as sys
'============================================================================
  dim as sys j
  j=instr(i,s,","+wr+"=")
  if j then function=j+len(wr)+2
end function

'----------------------------------------------------------------
sub replas(byref s as string, byref i as sys, byref wr as string)
'================================================================
  dim as sys j
  j=i
  capts(s,i)
  s=left(s,j-1)+wr+mid(s,i)
  i=j+len(wr)
end sub

'----------------------------------------------------------------
sub subsas(byref s as string, byref i as sys, byref u as string )
'================================================================
  dim as sys a,j
  dim as string wr
  do
    wr=word(s,i)
    if ascw=44 then continue do
    if ascn<>61 then exit do
    i+=1
    a=findas(u,1,wr)
    j=i : capts(s,i) : wr=mid(s,j,i-j)
    if a then
      replas(u,a,wr)
    end if
  loop
end sub


'-----------------------------
sub stripas(byref s as string)
'=============================
  ' (,a=3,b=4,) becomes (   3,  4 )
  dim as sys i=2,j
  dim as string wr
  do
    wr=word(s,i)
    if wr="" then exit do
    if ascw=44 then
      if ascn=rbr then
        mid(s,2)=" " : mid(s,swd)=" " : exit do
      end if
      j=i
      wr=word(s,i)
      if ascn=61 then
        i+=1
        mid(s,j,i)=space(i-j)
        capts(s,i)
      end if
    end if
  loop
end sub


'------------------------------
sub appendt(byref wt as string)
'==============================
  '
  'APPEND TO ASSEMBLY BUFFER
  '
  dim as sys le=len(wt)
  if len(t)<j+le then t+=space(le+4000)
  pwd=wt : mid(t,j)=wt : j+=len(pwd)
end sub


'------------------------------------------------------------
sub ape(byref s as string,byref k as sys, byref wt as string)
'============================================================
  dim as sys le=len(wt)
  if len(s)<=k+le then s+=string(le+4096,chr(0))
  mid(s,k+1)=wt : k+=len(wt)
end sub

'-----------------------------------------------------------------
sub appendm(byref s as string, byref k as sys, byref wt as string)
'=================================================================
  dim as sys le=len(wt)
  if len(s)<k+le then s+=space(le+2000)
  mid(s,k)=wt : k+=len(wt)
end sub


'---------------------------------
sub nocomments(byref wr as string)
'=================================
  '
  'strip out comments
  '
  dim as sys a,c,m
  dim as string w1
  a=1
  do
    w1=wrd(wr,a) : c=ascw
    if c=0 then exit do
    if isc(c) then
      m=swd : endline(wr,a)
      wr=left(wr,m-1)+mid(wr,a)
      a=m-1
    end if
  loop
end sub


'--------------------------------------------------------------
sub blankout(byref s as string, byval w as sys, byval i as sys)
'==============================================================
  '
  'blank all visible chars
  dim as sys a,b
  a=w
  do
    if a>=i then exit do
    b=asc(s,a)
    if b>32 then mid(s,a)=" "
    a+=1
  loop
end sub


'---------------------------------------------
function filename(byref s as string) as string
'=============================================
  dim as sys a,b
  do
    a=b+1
    b=instr(a,s,":") : if b then continue do
    b=instr(a,s,"\") : if b then continue do
    b=instr(a,s,"/") : if b then continue do
    exit do
  loop
  function=mid(s,a)
end function


'----------------------------------------
function hashid(byref s as string) as sys
'========================================
dim as sys le=len(s)
dim as any ptr p=strptr(s)
asm
  xor eax,eax
  mov edi,[le]
  mov esi,[p]
  rhashid:
    sub edi,4
    jl xhashid
    rol eax,7
    xor eax,[esi]
    add esi,4 
  jmp rhashid
  xhashid:
  mov [function],eax
end asm

end function


'---------------------------------------------
sub fixsqbr(byref s as string, byval i as sys)
'=============================================
  dim as sys m,a
  capture(s,m,i,a)
  mid(s,m)=chr(lbr) : mid(s,i-1)=chr(rbr)
  ascn=lbr : i=m
end sub


'------------------------------------
function booli(byval n as sys) as sys
'====================================
  if n then function=1
end function


'--------------------------------------
function yes(byref wr as string) as sys
'======================================
  function=booli(instrword(" 1 yes true on enabled active ",wr))
end function


'-------------------------------------
function no(byref wr as string) as sys
'=====================================
  function=booli(instrword(" 0 no false off disabled inactive idle ",wr))
end function


'------------------------------------------------------
function isnt(byref s as string, byref i as sys) as sys
'======================================================
  dim as string wr
  dim as sys a,v
  do
    if isx(ascn) then exit do
    wr=wordahead(s,i) : a=isx(asc(s,nwd))
    if a=0 then
      if instrword(" not isnt ",wr) then
        i=nwd : v=1-v : continue do
      elseif instrword(" is be mode switched turned ",wr) then
        i=nwd : continue do
      end if
    end if
    exit do
  loop
  function=v
end function


'----------------------------------------------------------
sub yesno(byref s as string,byref  i as sys,byref r as sys)
'==========================================================
  '
  'R IS ALTERED ONLY WHEN LOGICAL KEYWORDS ARE IDENTIFIED
  '
  dim as string wr
  dim as sys t,f,v
  if isx(ascn)=0 then
    v=isnt(s,i)
    wr=word(s,i)
    t=yes(wr)
    if t=0 then f=no(wr)
    '
    if t then
      r=1 xor v
    elseif f then
      r=0 xor v
    end if
  end if
end sub


'------------------------------------------------------------------------------
function instrevn(byval i as sys, byref s as string, byref wr as string) as sys
'==============================================================================
  dim as sys a,k,le
  '
  if i<0 then i=len(s)+1 '-1 indicates start from right
  if i<=1 then exit function
  le=len(wr)
  if le=0 then exit function
  k=asc(wr)
  '
  do
    i-=1
    if i<1 then exit do
    a=asc(s,i)
    if a=k then
      if wr=mid(s,i,le) then exit do
    end if
  loop
  '
  function=i
  '
end function


'--------------------------------
sub blankinstruct(byval a as sys)
'================================
  dim as sys b
  b=instr(a,t,cr)
  mid(t,a)=space(b-a) 'BLANK OUT
end sub

'---------------------------------------------------------
function dic(byref s as string, byref wr as string) as sys
'=========================================================
  '
  'LOOKUP KEYWORD AND RETURN NUMBER (ASSUMED HEAXDECIMAL)
  '
  dim as sys a
  a=instr(s," "+wr+" ") : if a then function=wval("&h"+mid(s,a+len(wr)+2,4))
  '
end function


'-----------------------------------------------------------
function revdic(byref s as string, byref v as sys) as string
'===========================================================
  '
  'REVERSE DIC
  '
  'hexadecimal is assumed to be trimmed of leading zeros, and capitalised
  '
  dim as sys a,b
  b=instr(s," "+hex(v)+",")
  if b then
    a=b
    do
      a-=1
      if asc(s,a)<=32 then a+=1 : exit do
    loop
    function=mid(s,a,b-a)
  end if
end function



'----------------------------------------------------------
function dicsn(byref s as string, byref a as sys) as string
'==========================================================
  '
  'LOOKUP LIST OF DECIMAL NUMBERS AND RETURN PHRASE
  '
  dim as sys v,k
  v=instr(s," "+str(a)+" ")
  if v then 
    v=instr(v+1,s," ") : skiplspace(s,v)
    k=instr(v,S,",") 'PHRASE DELIMITED BY COMMA
    if k then
      function=mid(s,v,k-v)
    end if
  end if
end function


'--------------------------------------------------------
function midval(byref s as string, byval i as sys) as sys
'========================================================
  if cpuw=4 then
    function=cvl(mid(s,i,4))
  else
    function=cvlongint(mid(s,i,4))
  end if
end function


'------------------------------------------------------------------
sub replace(byref s as string,byval w as string, byval r as string)
'==================================================================
  '
  dim as sys a,b,lw,lr
  '
  lw=len(W)
  lr=len(r)
  '  
  do
    a=instr(a+1,s,w)
    if a=0 then
      exit do
    else
      s=left(s,a-1)+r+mid(s,a+lw)
    end if
    a=lr+a-1
    continue do
  loop
  '
end sub
