


'       #  #        ###       ##  ########  #########    ##
'       #  #         # #     # #   #            #       #  #
'   ############     #  #   #  #   #            #      #    #
'       #  #         #   # #   #   #####        #     #      #
'   ############     #    #    #   #            #    ##########
'       #  #         #         #   #            #   #          #
'       #  #         #         #  ########      #  ##          ##
'

'-------------------------------------------------------------
sub metaskip(byref s as string, byref i as sys,byval f as sys)
'=============================================================
  '
  'destructive # skip
  '
  dim as sys a,b,c,d
  dim as string wr
  b=i
  wr=word(s,i) 'ALWAYS SKIP FIRST WORD
  do
    if ascn=0 then exit do 'PREMATURE END OF STRING TREATED AS TERMINATOR
    '
    wr=word(s,i) : if isc(ascw) then endline(s,i) : continue do
    '
    if ascw=35 then
      '
      '------------------
      'SAME NESTING DEPTH
      '------------------
      '
      if d<=0 then 
        '
        'F=0: BLANK OUT TILL THE NEXT #ELSE / #ELSEIF / #ENDIF
        'F=1: BLANK OUT TILL #ENDIF
        'F>1: NO BLANKING (SKIP TO #ENDIF ONLY)
        '
        if f=0 then
          if (wr="#else")or(wr="#elseif")or(wr="#elif") then
            '
            'BLANK OUT THE PRIOR CODE WHICH FAILED THE CONDITION
            '
            mid(s,b)=space(i-b)
            '
            if wr<>"#else" then
              '
              'REPLACE (#IF #ELSEIF #ELIF) WITH #IF
              '
              i-=4 : mid(s,i)="#if " 'PATCHED BACK INTO CODE STREAM
              '
            end if
            '
            exit sub 'DONE
            '
          end if '#ELSE ETC
          '
        end if 'D=0
        '
        if (wr="#endif")or(wr="#fi") then exit do
        '
      end if
      '
      'ADJUST DEPTH
      '------------
      '
      if left(wr,3)="#if" then d+=1 'INCREASING NESTING DEPTH
      '
      if (wr="#endif")or(wr="#fi") then d-=1 'DECREASING NESTING DEPTH
      '
    end if
  loop
  '
  if f<=1 then mid(s,b)=space(i-b) 'BLANK ALL
  '
  skiplspace(s,i)
  '
end sub


'----------------------------------------------------------
function cword(byref s as string, byref i as sys) as string
'==========================================================
  dim as sys a,b
  dim as string wr
  wr=word(s,i)
  '
  if ascw=37 then
    mid(s,swd)=" " : wr=word(s,i) ' IGNORE % PREFIX
  end if
  '
  'CHECK FOR OPERATORS WITH COMPUND SYMBOLS
  '----------------------------------------
  '
  b=ascw
  a=identop(s,swd,i,wr)
  ascw=b
  '
  if a then
    if ascn=61 then wr+="=" : i+=1
  end if
  '
  '
  if (ascw=60)or(ascw=62) then
    '
    '<< >> <>
    '
    if (ascn=62)or(ascn=ascw) then wr+=chr(ascn) : i+=1
  end if
  '
  skiplspace(s,i) : function=wr
  '
end function


'----------------------------------------------------------
function sword(byref s as string, byref i as sys) as string
'==========================================================
  dim as sys a
  a=instr(i,s,sq)
  if a then function=mid(s,i,a-i) : i=a+1
end function

'---------------------------------------------------------
function sval(byref s as string, byref i as sys) as double
'=========================================================
  dim as sys a
  a=instr(i,s,sq)
  if a then function=wval(mid(s,i,a-i)) : i=a+1
end function


'META LANGUAGE:
'==============
'SIMPLE ARITHMETIC ON CONSTACTANTS
' LOGIC FOR PRESENCE OR ABSENCE OF SYMBOL

declare function precedence( byref s as string, byref i as sys, byval q as sys) as string


'-------------------------------------------------------------------------------
function metaval(byref s as string, byref i as sys,byref wa as string) as double
'===============================================================================
  '
  dim as sys a,k,n,t,o,r
  dim as double b,v,w
  dim as string w1,w2,wr,wp,ws
  wa=""
  '
  '
    if nprec=0 then inserts(s,precedence(s,i,0),i)
    '
    
    'PRELOAD OPERATOR
    '----------------
    '
    if ascn=lbr then i+=1 : r=1 : skiplspace(s,i)
    wr="."
    if ascn=45 then wr=word(s,i)
    '
    do
      '
      '----------
      'OPERATIONs
      '----------
      '
      w=0
      '
      if instrword(" + - * /  ) and or < > = . ! & | ",wr) then
        '
        'UNSTACK OR GET NEXT OPERAND
        '---------------------------
        '
        k=1
        if wr=")" then
           w=v : n=sval(ws,k) : v=sval(ws,k) : wr=sword(ws,k) :  ws=mid(ws,k)
           if n then w=not w
           goto metoperate
        end if
        '
        'DOUBLE SYMBOL OPERATORS
        '-----------------------
        '
        if (ascn>60)and(ascn<=62) then
          wr+=chr(ascn) : i+=1
        end if
        '
        'OPERAND
        '-------
        '
        wp=cword(s,i)
        if isq(ascw) then wa+=noquotes(wp)  ' ACCUMULATE STRINGS
        b=0 : n=0
        '
        'EXAMPLES:
        '---------
        '
        ' IF NOT (...)
        ' IF NOT ISDEF ( X )
        ' OR ISNDEF ( X )
        ' AND NOT (...)
        '
        'NOT ISDEF ISNDEF
        '----------------
        '
        if (wp="not")or(wp="!") then n=not n : wp=cword(s,i)
        if ascw=lbr then goto metastack
        if instrword(" #ndef ndef undefined ",wp) then b=2 : n=not n ' INVERT LOGIC
        if instrword(" #def def defined ",wp) then b=1
        ' 
        if wp="leftmatch" then
          w1=wword(s,i) : w2=wword(s,i)
          a=len(w2) : w=0
          if left(w1,a)=w2 then w=-1
          if n then w=not w 'NOT
          wp=""
        end if
        '
        if b then
          if ascn=lbr then i+=1 'IGNORE (
          wp=cword(s,i)
          if ascn=rbr then  i+=1'IGNORE )
          mp=lookupm(wp) : w=0
          if mp then w=not w 'TRUE
          if n then w=not w 'INVERT LOGIC
          wp=""
        end if
        '
        'STACK
        '-----
        '
        metastack:
        '
        if wp="(" then
          '
          ws=str(n)+sq+str(v)+sq+wr+sq+ws : v=0 : wr="."
          if ascn=45 then wr=word(s,i) 'NEG SIGN
          continue do
          '
        end if
        '
        '
        'CHECK IF LITERAL NUMBER
        '-----------------------
        '
        a=asc(wp)
        if isn(a)or(a=38) then 
          wordeval(s,swd,i) : w=dv : goto metoperate
        end if
        '
        'CHECK IF SYMBOL
        '---------------
        '
        if len(wp) then
          '
          a=lookupm(wp)
          if a=0 then
            if asc(wp)=35 then
              w=getvarptr(wp)
              if w=0 then ert=502 : ers="Can't find Symbol: "+wp : exit do
            end if
            '
          else
            '
            'ACCEPT % DEF #DEFINE metatypes
            '------------------------------
            '
            wp=macso(a,1)
            '
            if maco(a,0)=-1 then
              w=wval(wp)
              if len(wa) then wa+=wp
            else
              if isq(asc(wp)) then wa+=noquotes(wp) else w=wval(wp)
            end if
            '
          end if
          '
        end if
        '
        '----------
        metoperate:
        '----------
        '
        wp=""
        '
        '-------------------------
        ' V ACCUM   W OPERAND
        '=========================
        '
        if wr="." then
          v=w
        elseif wr="and" then
          v and=w
        elseif wr="&" then
          v and=w
        elseif wr="or" then
          v or=w
        elseif wr="|" then
          v or=w
        elseif wr="xor" then
          v xor=w
        elseif wr="^" then 'itr xor / power
          v xor=w
        elseif wr="<<" then 
          v=v shl w
        elseif wr=">>" then 
          v=v shr w
        elseif wr="+" then
          v+=w
        elseif wr="-" then
          v-=w
        elseif wr="*" then
          v*=w
        elseif wr="/" then
          v/=w
        elseif wr="&&" then
          v=0 : if (b<>0)and(w<>0) then v=-1
        elseif wr="||" then
          v=0 : if (b<>0)or(w<>0) then v=-1
        elseif wr="^^" then
          v=0 : if b<>w then v=-1
        end if
        '=========================
        '
        'COMPARATORS
        '-----------
        '
        if instrword(" = < > == <> >= <= != ",wr) then
          b=v : v=0
          '
          if wr="="  then
            if b=w  then v=-1
          elseif wr=">"  then
            if b>w  then v=-1
          elseif wr="<"  then
            if b<w  then v=-1
          elseif wr="==" then
            if b=w  then v=-1
          elseif wr="<>" then
            if b<>w then v=-1
          elseif wr="!=" then
            if b<>w then v=-1
          elseif wr=">=" then
            if b>=w then v=-1
          elseif wr="<=" then
            if b<=w then v=-1
          elseif wr="!=" then
            if b<>w then v=-1
          end if
          '
        end if 'COMPARATORS
        '
      end if ' OPERATORS
      '
      '
      'CHECK IF END OF STATEMENT
      '-------------------------
      '
      skiplspace(s,i)
      if (ascn<=32)or(ascn=93)or(ascn=44)or(ascn=58) then exit do ' end of [...] , :
      if r then if ascn=rbr then if ws="" then i+=1 : skiplspace(s,i) : exit do
      'if ascn=35 then w1=wordahead(s,i) : if (w1="#fi")or(w1="#endif") then exit do
      '
      'NEXT OPERATOR OR BRACKET
      '------------------------
      '
      wr=cword(s,i)
    loop ' # EXPRESSION LOOP
    '
    if wa="" then wa=str(v) else wa=iq+wa+iq
    function=v
end function



'--------------------------------------------
sub metaco(byref s as string, byref i as sys)
'============================================

  dim as sys a,b,c,d,m
  dim as double v
  dim as string wr,w1,w2,w3,w4

  m=swd ' START OF BLOCK
  c=md
  '
  '-------------------------
  'HIGH LEVEL '#DEFINE MACRO
  '=========================
  '
  if (md=104)or(md=109) then
    '
    '
    do
      m=swd : w1=noquotes(wword(s,i))
      if w1="function" then continue do 'PB MACRO FUNCTIONS
      exit do
    loop
    ' 
    '
    'CHECK FOR PARAMS IN BRACKETS
    '----------------------------
    '
    a=0
    '
    if ascn=lbr then
      if md=104 then
        '
        'MUST BE NO SPACE BETWEEN IDENTIFIER AND BRACKET EG: M(A, B, C)
        '
        if i=swd+len(w1) then a=1
        '
      else 'md=109
        '
        'OXYGEN MACRO WILL ACCEPT EMPTY BRACKETS ()
        '
        a=1
      end if
    end if
    '
    'IF PARAMETERS WERE DETECTED...
    '
    if a then
      c=i
      capturi(s,m,b,i) : w3=mid(s,m,b) : striplineno(w3)
      '
      'PARSE FOR PARAMETERS (EXCLUDE IF OTHER CONTENT)
      '
      b=1 : d=0
      do
        w4=word(w3,b)
        if ise(ascw) then exit do
        if (isa(ascw)=0)or(isx(ascn)=0) then w3="" : i=c : goto nmparam 'DETECT NON NAMES
        if ise(ascn) then exit do
        b+=1 'SKIP COMMA
      loop
    else
      w3=""
    end if
    '
    '-------
    nmparam:
    '-------
    '
    skiplspace(s,i)
    '
    '-------
    '#DEFINE
    '=======
    '
    'CHECK FOR C TYPE MULTILINE \ ASCII 92
    '
    if md=104 then
      m=i
      do
        do
          if ise(ascn) then ascw=0 : exit do
          w2=word(s,i)
          if ascw=92 then exit do
        loop
        '
        if ascw<>92 then exit do
        mid(s,swd)=" " : ascn=32 'BLANK OUT `\`
      loop
      b=i-m
    end if
    '
    'OTHERWISE CAPTURE BLOCK
    '
    '-----
    'MACRO
    '=====
    '
    if md=109 then
      captureb(s,i,m,b,"macro")
      '
      skiplspace(s,i)
      if ascn=61 then
        endline(s,i) 'PB: END MACRO=??TEMP
      end if
      '
    end if
    '
    '
    if b>0 then w2=mid(s,m,b) : striplineno(w2) else w2=""
    '
    macoin(me)
    set_macro_name(w1)
    macsi(w2,me,1)
    macsi(w2,me,2)
    macsi(w3,me,3)
    maco(me,0)=-20
    maco(me,5)=md '104 for '#define'  109 for 'macro'
    addme : if ert then exit sub
    exit sub
  end if



  '------
  '#UNDEF
  '======
  '
  if md=107 then
    wr=word(s,i) : mp=lookupm(wr)
    if mp then macsi("",mp,0) ' knockout
    exit sub
  end if
  '
  '
  '-----------------------------------
  'ALIAS TYPE AS OTHERNAME (thinBasic)
  '===================================
  '
  if md=108 then
    w1=word(s,i) : nextspace(s,i) : wr=word(s,i)
    macoin me
    set_macro_name(wr)
    macsi(w1,me,1)
    maco(me,0)=-1
    addme
    exit sub
  end if
  '
  '
  '====================
  'OTHER # METACOMMANDS
  '====================
  '  
  '---
  '#IF
  '===
  '
  if c=100 then
    '
    v=metaval(s,i,wr)
    '
  end if '  #IF
  '
  '
  '-------------------
  '#ELSE #ELSEIF #ELIF
  '===================
  '
  'AFTER ACCEPTING VALID BLOCK:
  'DELETE REMAINDER
  '
  if (c=101)or(c=102) then
    i=m : metaskip(s,i,1) 'BLANK OUT ALL INCLUDING THE TERMINATING #ENDIF
    goto xmetaco
  end if
  '
  '------
  '#ENDIF
  '======
  '
  if c=103 then v=-1
  '
  '--------------
  '#IFDEF #IFNDEF
  '==============
  '
  if (c=105)or(c=106) then
    '
    wr=word(s,i) : mp=lookupm(wr)
    v=-1
    if c=105 then if mp=0  then v=0
    if c=106 then if mp>0 then v=0
    '
  end if
  '
  '-----------
  'META ACTION
  '===========
  '
  if v=0 then
    '
    'BLANK OUT THIS INVALID BLOCK INCLUDING THE META EXPRESSION
    'BUT STOP WHEN #ELSE #ELSEIF ALTERNATIVE IS ENCOUNTERED
    '
    i=m : metaskip(s,i,0)
  else
    '
    'THE BLOCK IS VALID THEREFORE
    'BLANK OUT THE TESTING META EXPRESSION ONLY
    '
    'endline(s,i)
    mid(s,m)=space(i-m)
  end if
  '
  xmetaco: 'DONE
  '
end sub





