
'-------------
sub regnames()
'=============
  if cpuw=4 then
    '
    qeax="eax" : peax="[eax]"
    qecx="ecx" : pecx="[ecx]"
    qedx="edx"
    qebx="ebx"
    qesp="esp" : pesp="[esp]"
    qebp="ebp"
    qesi="esi"
    qedi="edi" : pedi="[edi]"
    ledi="lea edi,"
    spw1="esp,4"
    spw2="esp,8"
    'CPU
    regn(3)=qesi : regn(4)=qedi
    'FLOATS MUST BE PASSED BYREF
    '
  else
    '
    qeax="rax" : peax="[rax]"
    qecx="rcx" : pecx="[rcx]"
    qedx="rdx"
    qebx="rbx"
    qesp="rsp" : pesp="[rsp]"
    qebp="rbp"
    qesi="rsi"
    qedi="rdi" : pedi="[rdi]"
    ledi="lea rdi,"
    spw1="rsp,8"
    spw2="rsp,16"
    'CPU
    regn(3)="r8" : regn(4)="r9"
    'FLOATS
    regn(8)="xmm0" : regn(9)="xmm1" : regn(10)="xmm2" : regn(11)="xmm3"
    '
  end if
  '
  regn(0)=qeax : regn(1)=qecx : regn(2)=qedx
  '
  'O2 LIBRARY / GLOBAL / STATIC REGISTER
  '
  regss=qebx : regsl=qebp : regs=regss
  '
end sub



'------------------------------------------------------------
function memreg(byref rg as string, byval d as sys) as string
'============================================================
  dim as string wa
  if d>0 then wa="+"
  if d<>0 then wa+=str(d)
  function="["+rg+wa+"]"
end function


'-----------------------------------------------------------
function memregsl(byval d as sys, byval pn as sys) as string
'===========================================================
  '
  'SPILL REG PARAMS INTO STACK MEMORY
  '
  dim as sys i,a,e,f
  dim as string w1
  e=pn
  if e>4 then e=4
  for i=1 to e
    a=typl(i)
    if (a>=&h60)and(a<&h80) then f=i+7 : else f=i
    w1+=" : mov [rbp+"+str(d)+"],"+regn(f) : d+=16
  next
  function=w1
end function



'--------------------------------------------
function leaedi(byref wr as string) as string
'============================================
  if wr<>pedi then function=ledi+wr+cr
end function


'--------------------------------------
function rtl(byval p as sys) as string
'======================================
  function="call "+memreg(qebx,p)
end function


'-------------------------------------
sub set_macro_name(byref wr as string)
'=====================================
  '
  dim as sys a
  macsi(wr,me,0) : addm(me) : a=asc(wr)
  if isq(a) then compos(composi).i=me : compos(composi).a=ascl(wr,2) : composi+=1
  '
end sub



'------------
sub loadops()
'============
  dim as sys a,i,j,k,v,f,n
  dim as sys t,u,uu,tal
  dim as string s,wd
  'f=freefile: err=0
  'open mdl_path+"oxygenlib\o2asm.data" for input as f
  'if err then ers="Problem accessing o2asm.data": ert=9: exit sub
  restore opcode_data
  ope=0
  n=512
  init4 @opd(0,0),9000,-1
  do
    'if eof(f) then exit do
    'line input #f, s
    read s
    i=1
    wd=word(s,i): a=ascw
    if a=33 then exit do '!end!'
    if isc(a) then continue do ' comment
    if wd="" then continue do
    v=hashcode(wd): ope=v and 511
    'print wd,ope
    u+=1
    if len(opn(ope))>0 then
      'print "Chain: "+wd
       uu+=1
       t=0
       do
         'print "link",opn(ope)
         if opd(ope,1)=-1 then opd(ope,1)=n:ope=n:n+=1:exit do
         t+=1: if t>tal then tal=t
         ope=opd(ope,1)
       loop
       if n>999 then ers="Too many instruction definitions":ert=9:ope=0: exit sub
     end if
     opn(ope)=wd
     opd(ope,0)=v ' 32 bit #
     'print ope, wd, hex(v)
     ' ops prefix codes
     ' opd flags and opcodes
     ' k=0 32bit name #
     ' k=1 lk link index
     ' k=2 flt
     ' k=3 pn
     ' k=4 b1
     ' k=5 c
     ' k=6 ima
     ' k=7 im
     ' k=8 ic
     ' k=9 dn
     k=1
     do
       k+=1: if k>9 then exit do
       wd=word(s,i): a=ascw
       if a<=13 then exit do
       if isq(a) then k-=1:ops(ope)=mid(wd,2,len(wd)-2):continue do
       if a=43 then wd=word(s,i):k=9:a=ascw '3dnow postfix code
       if a=45 then continue do ' leave default -1
       if isc(a) then exit do ' comment
       opd(ope,k)=wval("&h"+wd)
     loop
  loop
  ' coincidence check
  i=-1
  do
    i+=1:if i>=n then exit do
    j=opd(i,1): if j=-1 then continue do ' not links
    do
      if opd(i,0)=opd(j,0) then
        ert=9:ers="!! instruction hash not unique: "+opn(i)+" "+opn(j)+" "+hex(opd(j,0))
        'messagebox 0,ers,"Coincidence check",0
        exit sub 
      end if
      j=opd(j,1) ' next in chain
      if j=-1 then exit do
    loop
  loop
  '------------------
  ''print "Extra ",n-512
  ' messagebox 0, str(tal)+" "+str(u)+" "+str(uu),"Maxlinks",0
  ' ert=9:ers="error test"
end sub






'       #######
'      #       #
'      #       #
'              #
'             #
'       ######
'      #
'      #
'
'     ###
'     # #
'     ###

    '========
    'IDENTIFY
    '========




'=======================
' IDENTIFY x86 REGISTERS
'=======================

'----------------------------------------
function isreg(byref wr as string) as sys
'========================================
  '
  dim as sys a
  a=lookupm(wr)
  if a then if maco(a,0)=-10 then function=maco(a,2)+1
  '
end function


'DETECT XMMX OR MMX REGISTER

'----------------------------------------------------------
function xmmxid( byval w as string, byref ds as sys) as sys
'==========================================================
  '
  'XMM MM MMX
  '
  dim as sys a=asc(w),b=1,e=len(w)
  ds=0 : rexi=0 : function=-1
  if (a<97)or(e>5)or(e<3) then exit function
  if a=&h78 then ds=1 : b+=1
  if (asc(w,b)<>&h6d)or(asc(w,b+1)<>&h6d) then exit function
  a=asc(w,e)-48
  if (a>=0)and(a<10) then
    if asc(w,e-1)=49 then a+=10
    if (a>=0)and(a<16) then
      if a>=8 then rexi=1
      function=a
    end if

  end if
  '
end function


'--------------------------------------------------------
function regid(byref wr as string, byref l as sys) as sys
'========================================================
  dim as sys a,b,v=-1
  l=0 : a=lookupm(wr) : rexi=0
  if a then
    if maco(a,0)=-10 then
      b=maco(a,3) : if b=9 then rexi=1 : b=1
      if b=1 then l=maco(a,1) : v=maco(a,2)
    end if
  end if
  function=v
end function


'DETECT CONTROL,DEBUG AND SEGMENT REGISTERS
'
'---------------------------------------------------------
function sregid(byref w as string, byref ds as sys) as sys
'=========================================================
  '
  dim as sys a,b,rg
  ds=0 : rg=-1 : rexi=0 : a=lookupm(w)
  if a=0 then goto xsreg
  if maco(a,0)<>-10 then goto xsreg
  b=maco(a,3) : if b>4 then rg=maco(a,2) : ds=b+124
  xsreg:
  function=rg
  '
end function



'==============
'IDENTIFY TYPES
'==============



'----------------------------------------------------------------------------
function himac(byval mm as sys, byref  s as string, byref i as sys) as string
'============================================================================
  dim as sys a,b,m,n,md
  dim as string w1,w2,w3,w4,w5
  md=maco(mm,5)  ' MODE 104 #DEFINE 109 ,MACRO
  w1=macso(mm,1) ' BODY
  w3=macso(mm,3) ' PROTOTYPE
  skiplspace(s,i)
  a=ascn
  if a=lbr then
    i+=1 : skiplspace(s,i)
  else
    goto nhimac 'NO BRACKET NO PARAMS
  end if
  '
  b=1
  do
    if ascn=rbr then i+=1 : exit do  ' FINISH WHEN RIGHT BRACKET ENCOUNTERED
    if ise(ascn) then exit do        ' FINISH WHEN END OF LINE
    m=i : capts(s,i)                 ' CAPTURE SINGLE WORD OR EXPRESSION
    w2=mid(s,m,i-m)                 ' CAPTURE PARAM
    a=ascn
    '
    'CHECK MACRO EXPANSION OF THE PARAM
    '
    m=lookupm(w2)
    if m then
      n=maco(m,0)
      if (n=-1)or(n=-19)or(n=-20) then
        w2=macso(m,1)                'EXPANSION TO 1 LEVEL
      end if
    end if
    '
    w4=word(w3,b) : b+=1             ' CAPTURE PARAM FROM PROTOTYPE
    replacewd(w1,w4,w2)              ' REPLACE W4 WITH W2 IN BODY W1
    ascn=a                           ' RESTORE ASCN
    if ascn=44 then i+=1 : skiplspace(s,i)
  loop
  nhimac:
  function=w1
  '
end function




'---------------------------------------------------------------
sub ctype(byref s as string, byref i as sys, byref wr as string)
'===============================================================
  '
  'TRANSLATE C PRIMITIVES
  '
  '
  'arrays and pointers and functions resolved in o2prep.bas
  '
  'UNSIGNED SHORT INTEGER ETC
  '
  dim as sys a,b,c,d,m
  dim as string wn
  m=2
  '
  if wr="unsigned" then a=&h20 : b=2
  if wr="signed" then a=&h00 : b=2
  '
  if b=2 then
    d=0 : wn=wordahead(s,i) : c=lookupm(wn)
    if c then c=maco(c,0) : if c=-15 then i=nwd : wr=wn 'ready for next word
  end if
  '
  if wr="short" then m=1 : b=3
  if (wr="long")or(wr="wide")  then m=4 : b=3
  '
  if b=3 then
    d=0 : wn=wordahead(s,i) : c=lookupm(wn)
    if c then c=maco(c,0) : if c=-15 then i=nwd : wr=wn 'ready for next word
    if d=0 then m=2
  end if
  '
  '
  'FORMULATE TYPE CODE
  '
  if instrword(" sys any bool ",wr) then
    '
    'DEFAULT SYSTEM TYPE
    '
    typ=cpuw : lent=cpuw
    '
  elseif (m=2)and(instrword(idtype,wr)>0) then
    '
    'C TYPE IS SAME AS STANDARD OXYGEN PRIMITIVE
    '
  else
    '
    c=lookupm(wr) : typ=maco(c,5)
    lent=typ and 31 : typ and=&h1e0
    if typ<&h40 then typ or=a
    lent*=(m*.5)
    typ or=lent
    '
    'RESOLVE TO STANDARD PRIMITIVE TYPE NAME
    '
    wn=revdic(idtype,typ) : if len(wn) then wr=wn 'itr error report
    '
  end if
  '
  skiplspace(s,i)
  '
end sub


'-------------------------------------------
function identype(byref s as string) as sys
'===========================================
  '
  dim as sys a,b,c,n
  static as string w1,wm
  wm=s
  
  '---------
  ridentype:
  '=========

  indt=0 'TYPE INDIRECTION ACCUMULATOR
  ary="" 'TYPE ARRAY ACCUM
  '
  if wm="" then exit function
  '
  'STANDARD PRIMITIVE TYPES
  '------------------------
  '
  n=dic(idtype,wm)
  idvt:
  if n then
    if n=&h1ff then
      n=cpuw : lent=n 'SYS OR ANY
    elseif n=&h11f then
      lent=cpuw 'SUB FUNCTION METHOD
    elseif (n>=&hc0)and(n<&h100) then
      lent=cpuw
    else
      lent=n and 31 ' pointer (BSTR or BSTR byref)
    end if
  end if
  '
  '
  'UDT / C CHECK
  '-------------
  '
  if n=0 then 
    a=lookupm(wm)
    if a then
      '
      'C PRIMITIVE TYPE
      '----------------
      '
      if maco(a,0)=-15 then function=-a : exit function
      '
      'TYPEDEF STRUCT CHECK
      '--------------------
      '
      do
        b=maco(a,0)
        if (b=-1)or(b=-20) then 
          wm=macso(a,1) : goto ridentype 'MACRO RECURSE
        end if
        '
        'RESOLVE TYPEDEF TYPE
        '
        if b<>-8 then exit do
        c=maco(a,3)' and 255
        indt+=c 'INDIRECTION
        '
        w1=macso(a,2)
        if len(w1) then
          if minormajor=0 then
            ary+=" "+w1 'ARRAY MAJOR TO MINOR / FUNCTION ACCUM
          else
            ary=w1+" "+ary 'MINORMAJOR MODE ACCUM
          end if
        end if
        '
        b=maco(a,4) 'GET UNDERLYING TYPE
        if b<512 then
          n=b : lent=maco(a,1) : exit do 'PRIMITIVE TYPE
        else
          a=b-512 'LOCATE TYPE OR TYPEDEF
        end if
      loop
      '
      if b=-2 then lent=cpuw : n=a+512    'ENUMERATION
      if b=-3 then n=a+512 : lent=maco(a,1)      'TYPE / STRUCT / CLASS
      if b=-10 then lent=maco(a,1) : n=maco(a,1) 'REGISTER (RETURNING 8 QUAD 4=LONG 2=SHORT OR 1=BYTE)
    end if
  end if
  function=n
  '
end function


'--------------------------------------------
function identypes(byval tp as sys) as string
'============================================
  '
  dim as sys l
  dim as string wr
  l=tp and 31
  if l=1  then  wr="byte  "
  if l=2  then  wr="word  "
  if l=4  then  wr="dword "
  if l=8  then  wr="qword "
  if l=10 then  wr="eword "
  if l=16 then  wr="oword "
  function=wr
  '
end function

'-----------------------------------------------------------------------------------
sub varreg(byval pn as sys, byval dd as sys, byref wt as string, byref ws as string)
'===================================================================================
  dim as sys a,b
  if dd then a=cpuw else a=identype(wt)
  b=pn
  if (a>=&h40)and(a<=&h80) then b+=7 'XMM REGISTER
  ws+=" at "+regn(b)
end sub



'--------------------------------------------
sub indir(byref wr as string, byval n as sys)
'============================================
  '
  wpfx+="mov "+qedi+cm+wr+cr+repeat("mov "+qedi+cm+pedi+cr,n-1)
  '
end sub



'------------------------------------------------------------------------------------------------------
function addtablesection(byref wr as string, byval w as sys, byval a as sys, byval ao as sys) as string
'======================================================================================================
  '
  dim as sys k
  dim as string w1
  k=lookupm(wr+"_table") : w1=macso(k,1)
  if cpuw=4 then
    function="'ADD TABLE SECTION:"+cr+_
    "lea edx,["+regss+"+"+str(ao+w)+"] : lea edi,"+w1+" : mov ecx,"+str(maco(a,4)*0.25)+cr+_
    "( : mov eax,[edi] : mov [edx],eax : add edi,4 : add edx,4 : dec ecx : ja repeat : )"+cr
  else
    function="'ADD TABLE SECTION:"+cr+_
    "lea rdx,[rsi+"+str(ao+w)+"] : lea rdi,"+w1+" : mov rcx,"+str(maco(a,4)*0.125)+cr+_
    "( : mov rax,[rdi] : mov [rdx],rax : add rdi,8 : add rdx,8 : dec rcx : ja repeat : )"+cr
  end if
  '
end function


'-----------------------------------------------------------
function readval(byref wm as string, byref k as sys)  as sys
'===========================================================
  '
  dim as sys a
  skipspace(wm,k)
  a=wval(mid(wm,k,5))
  nextspace(wm,k) : k+=1
  function=a
  '
end function


'-----------------------------------------------
sub readvals(byref wm as string, byref k as sys)
'===============================================
  '
  woff   = readval(wm,k) ' OFFSET
  elsize = readval(wm,k) ' SIZE
  varf   = readval(wm,k) ' ELEMENT VAR/PROC/METHOD
  priv   = readval(wm,k) ' PUBLIC/PRIVATE/PROTECTED 
  '
  if elsize=0 then ert=103               ' ELEMENT NOT IMPLEMENTED
  if (varf>2)and(elsize<>cpuw) then ert=104 ' POINTER SIZE MUST BE 4 or 8
  '
  'SIGNATURES ETC
  '==============
  '
  dim as sys a,c,m,v
  dim as string w1
  '
  'CALLING-CONVENTION ETC
  '----------------------
  '
  cco=asc(uword(wm,k))-65
  '
  'PARAMS SIGNATURE
  '----------------
  '
  if ascn=44 then sig="" : k+=1 else sig=uword(wm,k)
  '
  '
  'DEFAULT PARAM VALUES (,a=3,b=4,)
  '--------------------------------
  '
  if ascn=40 then
    capture(wm,m,k,a) : dvl=mid(wm,m,k-m)
  end if
  '
  '
  'RETURN SIGNATURE (AND TYPE)
  '---------------------------
  '
  sog=uword(wm,k) : if ascw<48 then sog=""
  typ=wval(sog)
  if typ=0 then typ=identype(sog)
  '
end sub



'----------------------------------------
function getreg(byval m as sys) as string
'========================================
  function=mid(macso(m,1),2,3)
end function


'-----------------------------------------------------------------
sub matchm(byref wki as string,byref wr as string,byref ki as sys)
'=================================================================
  '
  dim as sys a,b,m,n,v,c,k,dt,chmp,ml
  dim as string wm,wn,w1,wk
  '
  wk=wki : ml=mp
  '
  'IS IT A VARIABLE?
  '=================
  '
  m=maco(ml,0)
  '
  'STRUCTURE INDEX
  '
  if m>=0 then
    ind=maco(ml,3) and 255  'INDIRECTION
    voff=maco(ml,2) 'BASE OFFSET OF VARIABLE
    '
    if ind=0 then 
      wn=getreg(ml) ' regs if is a var
    else
      wn=qedi : indir(macso(ml,1),ind) 'CREATE INDIRECTION CODE
    end if
    '
  else 'NOT A VAR
    '
    m=ml : ind=0 : voff=0 'ASSUME IT IS A TYPE STRUCTURE
    wn=""
    '
  end if
  '
  '
  '
  '-------------------------------------------------
  rmatchm:  'RECURSION POINT FOR INDIRECT STRUCTURES
  '-------------------------------------------------
  '
  'GET STRUCTURE
  '-------------
  '
  wm=macso(m,1)
  if dt=0 then k=ki
  vtp=maco(m,5) 'virtual table pointer field is present?
  '
  '
  'CHECK ELEMENT EXISTS
  '--------------------

  a=instrevn(k,wm,htb+wk+" ") : chmp=0

  if a=0 then
    '
    'CHECK FOR INDIRECT STRUCTURE
    '----------------------------
    '
    'LOOK FOR DOTTED PART OF NAME
    '
    b=instr(wk,".")
    '
    if b then
      w1=left(wk,b-1)
      '
      a=instrevn(k,wm,htb+w1+" ")
      '
      if a=0 then
        ki=0 : exit sub 'NOT LOCATED
      end if
      '
      wk=mid(wk,b+1) 'CHOMP W1
      b=len(w1) 'first part of name located
      chmp=1
      '
    else
      '
      ki=0 : exit sub 'NOT LOCATED
      '
    end if
  else 'main name located
    b=len(wk)
  end if
  '
  'SET PRIMARY LOCATOR AND DISABLE FURTHER UPDATES
  '
  if dt=0 then ki=a : dt=1
  '
  'READ ATTRIBUTES
  '===============
  '
  k=a+b+2 'skip over identified name
  '
  readvals(wm,k)
  '
  'INHERITED METHODS
  '-----------------
  '
  v=0 : c=m 'SET C SAME AS STRUCTURE
  '
  if varf then
    '
    if varf<9 then v=woff 'STRUCTURE OFFSET
    '
    'CHECK FOR CLASS STATIC ELEMENTS AND METHODS
    '-------------------------------------------
    '
    'VARF CODES
    '
    '1   body member
    '2   static member
    '3   pointer body member
    '4   pointer static member
    '8   procedure pointer
    '9   method pointer
    '10+ inherited method pointer
    '
    if (varf=2)or(varf=4)or(varf>8) then
      '
      c=lookupm(macso(m,0)+"_table")
      '
      if c then
        regst=getreg(c)
        toff=maco(c,2) 'TABLE BASE OFFSET USED LATER
        '
        'STATIC ELEMENTS
        '---------------
        '
        if (varf=2)or(varf=4) then
          wn=regss : voff=toff 'USE TABLE BASE FOR STATIC VARIABLES
        end if
        '
      end if
      '
    end if
    '
  end if ' VARF
  '
  'VISIBILITY RESTRICTIONS
  '-----------------------
  '
  'private properties are invisible
  'looking at the last code word in the record:

  if priv<>9 then
    if macso(ml,0)<>"this" then
      ers="Private / Protected member: "+ow : ert=401
    end if
  end if
  '
  'STATIC VARIABLE OFFSET
  '----------------------
  '
  if (ind=0)or(varf=2)or(varf=4) then
    if (ml<>c) then v+=voff 'ADD VARIABLE BASE IF VF TABLE IS USED
  end if
  '
  'REBUILD THE ADDRESS OPERAND
  '===========================
  '
  if v<>0 then
    '
    m=asc(wn)
    '
    'RESOLVE HOST ADDRESS WITH OFFSET
    '--------------------------------
    '
    if m=35 then
      'resolve to abs address
      n=getvarptr(wn) : if n=0 then ert=300 : ers="Host variable not located: "+wn
      wn=str(n+v)
      v=0
    end if
    '
    'ADJUST ABSOLUTE ADDRESS OFFSET
    '------------------------------
    '
    if isn(m) then
      '
      'QUICK HEXADECIMAL CHECK
      '
      n=asc(wn,2)
      if n=&h78 then mid(wn,1)="&h"
      wn=str(wval(wn)+v)
      v=0
    end if
    '
    'ADJUST OFFSET
    '-------------
    '
    'REGISTER NAME WN
    '
    if v>0 then wn+="+"
    if v<>0 then wn+=str(v)
  end if
  '
  wr="["+wn+"] " 'COMPOSED ASM VARIABLE ADDRESS
  '
  '
  'CHECK IF INDIRECT STRUCTURE POINTER
  '===================================
  '
  if (varf=3)or(varf=4) then
    if len(wk) then
      '
      'IF FURTHER RESOLUTION REQUIRED
      '
      wpfx+="mov "+qedi+cm+wr+cr : wn=qedi
      '
      if chmp=0 then
        wr="[edi]"
        exit sub 'RESOLVED
      end if
      '
      ml=typ-512
      m=ml : ind=0
      voff=0 : toff=0
      k=-1
      goto rmatchm 'LOOP RECURSE FOR NEXT STRUCTURE
    end if
  end if
  '
  '
end sub


'--------------------------------------------
sub nextel(byref wm as string,byref k as sys)
'============================================
  '
  'GET NEXT ELEMENT IN STRUCTURE
  '-----------------------------
  '
  dim as sys a
  dim as string w1
  typ=0
  if k=0 then k=-1
  do
    k=instr(k,wm,htb)
    if k=0 then exit do
    k+=1
    w1=wordahead(wm,k)
    if right(w1,2)="__" then continue do 'SKIP __ names (pvft and private)
    k=instr(k,wm," ")
    if k=0 then exit do
    '
    'READ ATTRIBUTES
    '===============
    '
    readvals(wm,k)
    if (typ=0)or(typ>=512) then continue do
    exit do
  loop
end sub



'---------------------------------------------------------------------------------------------
function identop(byref s as string, byval k as sys, byref i as sys, byval wr as string) as sys
'=============================================================================================
  '
  ' n   operator code
  ' prl precedence level
  dim as sys n,a,b
  '
  '
  if len(wr)=1 then
    '
    a=asc(wr) : n=a
    '
    'higher prl means higher precedence
    '----------------------------------
    if a=94 then prl=8 : goto idop '^ power or C Xor ??
    if a=92 then prl=7 : goto idop '\
    if a=47 then prl=7 : goto idop '/
    if a=42 then prl=7 : goto idop '*
    '----------------------------------
    'shifts      5
    'comparators 4
    'logicals    3 2 1
    '----------------------------------
    '
    b=asc(s,k+1)
    '
    if (a=43)or(a=45) then
      prl=6                    '+ -
      if a=b then i+=1 : prl=9 '++ --
      goto idop '+
    end if
    '
    n=0
    '
    'AND && &
    '
    if a=38 then
      if b<>a then
        if (i>k+1)or(b=lbr) then n=33 : prl=3 : goto idop '&
        goto idop ' &h ignore
      end if
      i+=1 : n=71 : prl=3 : goto idop '&&
    end if
    '
    'OR || |
    '
    if a=124 then
      prl=1
      if b<>a then n=34 : goto idop    '|
      i+=1 : prl=1 : n=72 : goto idop  '||
    end if
    '
    if a=33 then
      if b=61 then i+=1 '!=
      n=101 : prl=4
      goto idop 'NOT !
    end if
    '
    '<< < <= <>
    '
    if a=60 then
      if b=60 then i+=1 : n=74 : prl=5 : goto idop '>> SHIFT LEFT
      prl=4             '<
      if b=61 then i+=1 '<=
      if b=62 then i+=1 '<>
      n=101 : goto idop 'COMPARE
    end if
    '
    '= ==
    '
    if a=61 then
      prl=4             '=
      if b=61 then i+=1 '==
      n=101 : goto idop 'COMPARE
    end if
    '
    '>> > >=
    '
    if a=62 then
      if b=62 then i+=1 : n=75 : prl=5 : goto idop 'SHIFT RIGHT
      prl=4             '>
      if b=61 then i+=1 '>=
      n=101 : goto idop 'COMPARE
    end if
  else
    '
    'LENGTH WORD >1
    '
    if wr="and"  then n=33 : prl=3 : goto idop
    if wr="xor"  then n=35 : prl=2 : goto idop
    if wr="or"   then n=34 : prl=1 : goto idop
  end if
  '
  'unaries?
  '
  'USER DEFINED OPERATORS
  '
  a=lookupm(wr) : if a then if macO(a,0)=-21 then n=a+512 : prl=maco(a,4)
  '
  idop:
  '
  function=n
  '
end function


'-------------------------------------------------------------------------------
function identopeq(byref s as string, byref i as sys, byref w1 as string) as sys
'===============================================================================
  dim as sys a
  if ascw=61 then
    function=2
    w1="mov "
    if cnd then
      function=&h14
      if asc(s,swd+1)=61 then i+=1 : skiplspace(s,i)
    end if
    exit function
  end if
  '
  a=identop(s,swd,i,wordahead(s,swd))
  if a=0 then exit function
  '
  ascw=61 : i+=1 : skiplspace(s,i) 'JUMP OVER `=`
  '
 if a=43 then
    w1="add " : function=8  ' +=
  elseif a=45 then
    w1="sub " : function=9  ' -=
  elseif a=42 then
    w1="mul " : function=14 '*=
  elseif a=47 then
    w1="div " : function=15 '/=
  elseif a=33 then
    w1="and " : function=65 'AND=    
  elseif a=34  then
    w1="or "  : function=66 'OR=
  elseif a=35 then
    w1="xor " : function=67 'XOR=
  end if
end function


'------------------------------------------
function identops(byval n as sys) as string
'==========================================
dim as sys a
dim as string w1
  '
  'CHECK FOR USER DEFINED / EXOTIC OP
  '
  if n>512 then function=noquotes(macso(n-512,0)) : exit function
  a=instr(opname," "+str(n)+" ")
  if a then
    w1=word(opname,a) : function=noquotes(word(opname,a))
  end if
end function



'----------------------------------------------------------------------------------
function attributes(byval kn as sys, byref kv as sys, byref wk as string) as string
'==================================================================================
  '
  dim as sys a,b,k,v
  dim as string wr,w1
  '
  wr="0" : k=mp : a=mc
  '
  'VARIABLE OR STRUCTURE ?
  '
  if a>=0 then
    if maco(mp,3)=0 then v=maco(mp,2) 'VAR OFFSET (static only)
    if a>0 then
      k=a  'REFER TO STRUCTURE
    end if
  end if
  '
  'NOT ELEMENTS OR MEMBERS
  '
  if dtf=0 then
    '
    '3 SPANOFF 9 EXTENTOF
    '
    if (kn=3)or(kn=9) then
      if kn=9 then
        kv=maco(mp,4) 'NUMBER OF DIMENSIONS
      end if
      v=instr(macso(mp,2),chr(kv+64))
      '
      if v then
        wr=str(wval(mid(macso(mp,2),v+1))) 'LOCATE DIMENSION DATA
      else
        wr=str(maco(mp,1))
      end if
      '
      goto attri
    '
    elseif kn<3 then
      wr=str(maco(mp,kn))              '1 SIZEOF 2 OFFSETOF
    elseif kn=4 then                    'TYPEOF
      '
      if a<0 then
        wr="metatype "+str(a)+" "+_
       dicsn(metatypes,a)               '(TYPEOF TYPE)
      elseif a=0 then
        wr=revdic(idtype,maco(mp,5))      '(PRIMITIVE)
      else 'if a>0 then
        wr=word(macso(maco(a,0),0),1)   '(DEFINED TYPE)
      end if
      '
      goto attris
    elseif kn=5 then
      wr=macso(k,1) : goto attris       'STRUCTUREOF / ENCODINGOF / RECORDOF
    'elseif kn=6 then
    '  wr=macso(k,2) : goto attris       'SCRIPTOF
    elseif k>=0 then
      if kn=8 then wr=str(maco(mp,4))  'TERMSOF (number of dimensions)
    end if
    '
    goto attri
    '
  end if
  '
  'ELEMENTS OR MEMBERS
  '===================
  '
  w1=macso(k,1)
  a=instrevn(-1,w1,htb+wk+" ") 'GET THE ELEMENT RECORD
  if a=0 then ers="Undefined element "+ow : ert=10 : goto attri
  b=instr(a,w1,cr) : a+=1
  w1=mid(w1,a,b-a) : a=1
  '
  '
  if kn=5 then
    wr=w1 : goto attris 'STRUCTUREOF ENCODINGOF RECORDOF 
  end if
  a+=len(wk)+1
  wr=word(w1,a)
  if kn=2 then v+=wval(wr) : wr=str(v) : goto attri 'OFFSETOF
  wr=word(w1,a)
  if kn=1 then goto attri  'SIZEOF
  wr=word(w1,a)
  if kn=7 then
    'STATUSOF varf 0 composite 1 element 2 dyn element 8 proc 9 method 10+ inherited method
    a=wval(wr)
    if a=0 then
      wr="composite"
    elseif a=1 then
      wr="element"
    elseif a=2 then
      wr="dynamic element"
    elseif a=8 then
      wr="procedure"
    elseif a=9 then
      wr="method"
    elseif a>9 then
      wr="inherited method"
    end if
    goto attris
  end if
  '
  wr="0" : goto attri ' default
  '
  '-----
  attris:
  '-----
  '
  wr=chr(iq2)+wr+chr(iq2)
  '
  '-----
  attri:
  '-----
  '
  function=wr
  '
end function



declare sub addlproc()
declare function metaval( byref s as string, byref i as sys, byref wa as string) as double





' #######   ######  ######
'  #     #  #       #
'  #     #  ####    ####
'  #     #  #       #
' #######   ######  #

'---------------------------------------------------------------------------
function macres(byref s as string,byref i as sys, byref wk as string) as sys
'===========================================================================
  dim as sys a,b,c,d,f,g,n,v
  dim as string w1
  '
  '---------------------------
  'LOW LEVEL MACRO (-1 or -19)
  '===========================
  '
  'CHECK FOR SUBMACROS
  '
  if dtf then
    w1=mid(ow,dtf) : a=instr(wk,w1)
    if a then a+=len(w1) : wk=captureblock(wk,a,"")
  end if
  '
  'CHECK NO SUBSTITUTIONS
  '
  if incli then exit function
  '
  'FIND HIGHEST PARAMETER
  '
  a=1 : b=48
  do
    c=asc(wk,a)
    if c=0 then exit do
    if c=37 then
      a+=1 : v=asc(wk,a)
      if (v>b)and(V<58) then b=v 'UP TO 9 PARAMS
    end if
    a+=1
  loop
  '
  'MAKE SUBSTITUTIONS
  '
  b-=48
  a=1
  wp(0)=rtrim(pwd)
  '
  'GRAB MACRO PARAMETERS
  '
  do
    b-=1 : if b<0 then exit do
    c=asc(s,i)
    '
    'CAPTURE CONTENT BETWEEN BRACKETS
    '
    if c=lbr then wp(a)=captureblock(s,i,"") : a+=1 : continue do
    if ise(c) then
      'end of line : no further params
      wp(a)="" : a+=1 : continue do
    end if
    '
    'CAPTURE INDIVIDUAL WORD / NUMBER
    '
    wp(a)=wrd(s,i)
    '
    'CHECK TO SEE IF PARAMETER IS A MACRO (BUT NO FURTHER RECURSION HERE)
    '
    if isn(ascn)=0 then
      c=lookupm(lcase(wp(a)))
      if c then
        d=maco(c,0)
        if (d=-1)or(d=-19)or(d=-20) then
          wp(a)=macso(c,1)
        end if
      end if
    end if
    '
    'ENSURE CAPTURE NEGATIVE NUMBER
    '
    if ascw=45 then
      c=asc(s,swd+1) : if isn(c) then wp(a)+=word(s,i)
    end if
    a+=1 ' capture parameters
  loop
  a=1
  '
  'SUBSTITUTE WORD SYMBOLS AND MARKUP BLOCK SYMBOLS
  '------------------------------------------------
  '
  do
    a=instr(a,wk,"%") 'ascii 37
    if a=0 then exit do
    b=ascl(wk,a+1)-48 : n=a+2
    if b=0 then g=2                                                  ' %0 swallowed previous word
    if b>9 then                                                      ' %1..%9 MACRO PARAM WORDS
      if b>63 then b=63                                              ' %  ?? CLAMP
      if b=49 then f=1 : wp(b)=chr(2)                                ' %a ASSIGN
      if b=50 then f=1 : wp(b)=chr(3)                                ' %b LEFT PART OF LINE
      if b=53 then f=1 : wp(b)=chr(4)                                ' %e NEXT BLOCK
      if b=56 then f=1 : wp(b)=chr(wval("&h"+mid(wk,a+2,2))) : n+=2   ' %h ASCII HEXADECIMAL
      if b=60 then f=1 : wp(b)=chr(5)                                ' %l NEW LINE
      if b=62 then f=1 : wp(b)=""                                    ' %n NORECURSE
    end if
    if b=-11 then ' %37
      wk=left(wk,a)+mid(wk,a+2) : a+=1
      do
        a+=1
        if asc(wk,a)<>37 then exit do
      loop
      continue do ' %% ESCAPE %
    end if
    wk=left(wk,a-1)+wp(b)+mid(wk,n) : if b=62 then exit do
    a+=len(wp(b))-1
  loop
  function=f or g
 end function



'   #####                      #####
'  ######                      ######
'  ##                              ##
'  ##   ##########    ##########   ##
'  ##  ############  ############  ##
'  ##  ##    \|/ ##  ##    \|/ ##  ##
'  ##  ##    -O- ##  ##    -O- ##  ##
'  ##  ##    /|\ ##  ##    /|\ ##  ##
'  ##  ############  ############  ##
'  ##   ##########    ##########   ##
'  ##                              ##
'  ######                      ######
'   #####                      #####



'-----------------------------------------------------------
function mword(byref s as string, byref i as sys ) as string
'===========================================================
  '
  ' s    source
  ' i    position in source
  ' swd  start of word position
  ' a    ascii code
  ' b    general purpose
  ' k    general purpose
  ' wr   word
  ' wk   struc or variable string
  ' wm   struc or variable string
  ' wn   gen
  ' wp   () capture macro parameters

    dim as sys a,b,c,k,m,n,v,kn,kv
    dim as string wr,wk,wm,wn,wo,W1

    typ=0 : varf=0 : elsize=0
    mc=0 : mp=0 : mq=0
    '
    wr=word(s,i)
    '
    if ascw>250 then goto exitmword '(not iq4 which is ascii 250)
    '
    'ASM OPERANDS
    '------------
    '
    if ascw=91 then
      a=instr(swd,s,"]")
      if a then
        a+=1 : lenw=a-swd : wr=mid(s,swd,lenw)
        i=a : skiplspace(s,i)
      end if
    end if
    '
    'EXPECTING ENUMERATION TYPE
    '--------------------------
    '
    if enu then
      if isa(ascw) then
        a=1
        '
        'CHECK FOR VARIABLE TO VARIABLE ASSIGN/COMPARE
        '---------------------------------------------
        '
        b=lookupm(wr) : if b then if maco(b,0)>0 then a=0
        '
        'OTHERWISE IT IS AN ENUMERATION VALUE TO LOCATE
        '----------------------------------------------
        '
        if a then
          inserts(s,macso(enu,0)+"."+wr+" ",i) : wr=word(s,i) : enu=0
        end if
      end if
    end if
    '
    'WITH prefix
    '-----------
    '
    if wi then if ascn=61 then inserts(s,wth+wr,i) : wr=word(s,i)
    '
    '
    ow=wr
    '
    '
    '--------------------------------------------------
    wredo: 'RECURSION POINT FOLLOWING A MACRO EXPANSION
    '==================================================
    '
    '
    'HUGE RECURSION CHECK
    '--------------------
    '
    mct+=1
    if (mct>=&h400)or(len(s)>mex) then
      ert=102 : goto exitmword
    end if
    '
    '
    wk=""
    '
    if wr="" then goto exitmword
    if compo then goto ncompo
    '
    'ASSEMBLER OPERANDS
    '------------------
    '
    if ascw=91 then
      m=swd
      a=instr(m,s,"]")
      if a>m then
        i=a+1
        '
        if i=swd+2 then goto sqbrw 'EMPTY []
        '
        wk=mid(s,m,a-m)
        '
        a=2 : w1=word(wk,a)
        '
        if ascw<>35 then
          '
          'RESOLVE VARIABLE FB SYNTAX [VAR]
          '
          a=lookupm(w1)
          if a then
            a=maco(a,0)
            if (a>=0)or(a=-14) then 'allow [function] or [method]
              wk=w1 : goto insertw 'RECURSE WITH VARIABLE NAME
            end if
          end if
        end if
        '
        'OTHERWISE ASSUME A NORMAL ASM MEMORY OPERAND
        '
        a=instr(wk,"#")
        '
        if a then
          '
          'RESOLVE  #MACRO
          '
          wn=left(wk,a-1) 'HOLD LEFT SIDE
          w1=word(wk,a)
          b=lookupm(w1)
          '
          if b then
            w1=macso(b,1) '[ .. #mac]
          else 'if b=0
           b=getvarptr(w1)
           if b then w1=str(b) 'HOST VARIABLE ADDRESS
          end if
          '
          if b then
            '
            'TEST FOR EXPRESSION
            '
            if (ascn=42)or(ascn=43)or(ascn=45) then
              wm=w1+mid(wk,a) 'REASSEMBLE EXPRESSION FOR METAVAL
              '
              b=metaval(wm,1,w1)
              '
            end if '*+- metaval 'RESOLVE METAEXPRESSION
            '
            'REASSEMBLE  AND INSERT ADDRESS OPERAND
            '
            inserts(s,wn+w1+"]",i) : m=i : i+=len(w1)+len(wn)+1
            '
          end if 'b
        end if ' #
      end if ' `]`
      '
      sqbrw: 'RETURN WHOLE [..] ASM MEMORY OPERAND
      '
      swd=m : wr=mid(s,swd,i-swd) : skiplspace(s,i)
      goto exitmword 
    end if '[..]  91
    '
    '
    'SYMBOLS, NUMBERS, DOT LABELS PASS THRU
    '--------------------------------------
    '
    '
    if isq(ascw) then typ=&ha1 : goto exitmword
    '
    if o2h then
      if (ascw>=36)and(ascw<=64) then goto exitmword
    else
      if (ascw>=45)and(ascw<=58)and(ascw<>47) then goto exitmword
    end if
    '
    '----------------------
    'CHECK FOR DOTTED NAMES
    '======================
    '
    if dtf then
      ow=wr
      'mp=lookupm(wr)
      'if mp then
      '  dtf=0 'support dotted primary names
      'else
        wk=mid(wr,dtf+1) : wr=left(wr,dtf-1) 'assume part of a structure
      'end if
    end if
    '
    '
    mp=lookupm(wr) : b=0
    if nth then nth=0 : goto notthis 'That' override
    '
    '
    'GIVE PRIORITY TO IMPLICIT `THIS` SYMBOLS IN METHODS
    '---------------------------------------------------
    '
    'BUT CORE SYMBOLS ALWAYS HAVE PRIORITY (MESB)
    '
    if ths then
      if mp=0 then
        b=ths
      elseif mp>=mesb then
        if mp<mest then b=ths
      elseif wr="this" then
        mp=ths : goto dtvar
      end if
    end if
    '
    if b then
      '
      'CHECK FOR IMPLICIT THIS.
      '------------------------
      '
      w1=wr
      m=maco(ths,0)
      c=instrevn(-1,macso(m,1),htb+w1+" ")
      if dtf then w1+="."+wk
      k=instrevn(-1,macso(m,1),htb+w1+" ")
      if k then c=k
      if c then
        if dtf=0 then dtf=5
        mp=ths : wk=w1 : goto dtvar
      end if
      '
      'OTHERWISE LET WORD PASS THRU
      '----------------------------
      '
    end if
    '
    '
    '-------
    notthis:
    '=======

    if mp=0 then goto exitmword
    '
    '------
    ncompo:
    '======
    '
    '
    'CHECK FOR C POINTERS
    '--------------------
    '
    if ascn=45 then
      '
      'CHECK FOR POINTERS ->
      '---------------------
      '
      'itr first level pointer only
      'itr check for indirection maco(mp,3)
      'itr assignment of address value to pointer a=&b ; a->x = 1
      '
      a=asc(s,i+1)
      if a=62 then
        if dtf=0 then i+=2 : dtf=lenw : wk=word(s,i)
      end if
    end if
    '
    'VARIABLES OF INTRINSIC AND USER DEFINED TYPE
    '--------------------------------------------
    '
    dtvar:
    '-----
    '
    mc=maco(mp,0) ' structure index if any
    mq=mp
    '
    if mc>=0 then
      '
      '
      'ENUMERATION VARIABLE
      '--------------------
      '
      b=maco(mc,0)
      '
      'FOR ASSIGNMENTS AND COMPARISONS
      '
      if b=-2 then
        if dtf=0 then
          if (ascn=61)or(ascn=43) then
            if enu=0 then enu=mc else enu=0
          end if
          lent=cpuw : typ=cpuw : wk=macso(mp,1)
          goto insertw 
        end if
      end if
      '
      'LOWER LOCAL BOUNDARY
      '
      if mp<mel then
        if left(macso(mp,1),4)="["+qebp then mp=0 : mc=0 : goto exitmword
      end if
      '
      if dtf=0 then wk=macso(mp,1)+" "
      '
      '
      typ=maco(mq,5)
      '
      '------------------------
      isdtf: 'IS IT A DOT NAME?
      '========================
      '
      if dtf then
        '
        '
        'USER DEFINED TYPES
        '------------------
        '
        k=-1 : matchm(wk,wr,k)
        if k=0 then ert=402 :ers="Not found : "+ow
        if ert then wr=ow : goto exitmword
        tye=typ : wk=wr : goto insertw 'recurw
      end if 'dtf
      '
      'NON DOTTED NAMES
      '----------------
      '
      '----
      ndtf:
      '====
      '
      w1=macso(mq,3) : a=1
      sog=word(w1,a) : ind=maco(mq,3) and 255
      if ascn>32 then
        sig=mid(w1,a) : typ=maco(mp,5) : varf=8 'FUNCTION POINTER WITH SIGNATURE
      end if
      skiplspace(s,i)
      if ind then indir(wk,ind) : wk=pedi
      goto insertw
    end if 'mc>0
    '
    'COMMON RESERVED WORDS
    '---------------------
    '
    if mc=-9 then goto exitmword
    '
    'REGISTERS
    '---------
    '
    if mc=-10 then
      b=maco(mp,3) : typ=maco(mp,1)
      sog=identypes(typ)
      if b=3 then typ=&h130 : sog="mmx"
      if b=4 then typ=&h150 : sog="xmm"
      goto exitmword
    end if
    '
    'O2 EXCLUSIONS
    '-------------
    '
    if o2h=0 then
      if mc<=-14 then
        if mc=-14 then
          'allow these
          if instrword(" function method operation ",wr) then wk="_return" : goto insertw
        end if
        mc=0 : mp=0 : mq=0 : goto exitmword
      end if
    end if
    '
    'ATTRIBUTES (WITH 1 OR 2 PARAMS
    '
    if (mc=-11)or(mc=-12) then
      kn=maco(mp,3) : m=mc
      if ascn=lbr then c=1 : i+=1 else c=0 'SKIP LEFT BRACKET
      '
      wr=word(s,i) : b=dtf 'HOLD DOT FLAG
      '
      if dtf then
        wk=mid(wr,dtf+1)
      end if
      '
      i=swd : wr=mword(s,i) 'RESOLVE PARAM
      '
      if c then
        if ascn=rbr then i+=1 : skiplspace(s,i) 'SKIP RIGHT BRACKET
      end if
      if m=-12 then
        if ascn=44 then i+=1
        kv=wval(word(s,i)) 'GET THE SECOND PARAM VALUE
      end if
      if mp=0 then
        goto exitmword 'ERROR: CANT LOCATE
      end if
      dtf=b 'REINSTATE DOT FLAG
      wk=attributes(kn,kv,wk)
      enu=0 : goto insertw
    end if
    '
    '
    '-----------------------
    'OTHER SPECIALISED TYPES
    '=======================
    '
    'C TYPES
    '
    if mc=-15 then
      if isn(ascn) then
        typ=0 : mc=0 : mp=0 : mq=0
        goto exitmword 'ASM int 3 int 16
      end if
      ctype(s,i,wr)
      wk=wr+" " : goto insertw
    end if
    '
    '
    select case mc
      case -3  : goto exitmword 'TYPE OR CLASS
      case -4  : wk=macso(mp,1) : varf=8 : goto insertw 'O2 INTRINSIC FUNCTION
      case -5  : varf=8 : goto exitmword 'LABELED OR VECTORED
      case -6  : varf=8 : addlproc() : wk=memreg(regss,maco(mp,2)) : goto insertw 'IMPORT
      case -7  : varf=8 : wk=macso(mp,1) : goto insertw 'EXPLICIT
      case -8  : goto exitmword 'DERIVED TYPE
      case -13 : goto exitmword 'O2 MAJOR KEYWORD
      case -14 : goto exitmword 'O2H MAJOR KEYWORD
      case -16 : varf=8 : goto exitmword 'O2H INSTRINSIC VECTORED
      case -17 : goto exitmword 'INTRINSIC FLOAT MACRO
      case -20 : wk=himac(mp,s,i)+" " : goto insertw 'HI-LEVEL MACRO
    end select
    '
    if dtf=0 then wk=macso(mp,1)+" "
    '
    'LOW LEVEL MACROS
    '----------------
    '
    if (mc=-1)or(mc=-19) then
      if mc=-19 then if instrword(" terminate freelibs freestrings freestatics ",wr) then tmnt=1
      if dtf then wk=macso(mp,1)
      a=swd : mcf=macres(s,i,wk) : b=mcf and 1
      '
      if b then
        wr=wk : goto exitmword
      else
        gotO insertw
      end if
    end if
    '


    '
    'ENUMERATION TYPES (defs and defs bit)
    '-------------------------------------
    '
    if mc=-2 then
      '
      'DIM TYPE CREATING AN ENUMERATION VARIABLE
      '-----------------------------------------
      '
      if dtf=0 then typ=mp+512 : lent=cpuw : goto exitmword
      '
      'OTHERWISE RETRIEVING AN ENUMERATION VALUE
      '-----------------------------------------
      '
      typ=cpuw
      if (ascn=43)or(ascn=124) then enu=mp else enu=0
      wm=macso(mp,1) : b=instr(wm," "+wk+" ")
      if b then wk=word(wm,b+len(wk)+2) else wk=wo
      wk+=" " : mp=0 : mq=0 : typ=cpuw
      'goto insertw
      '
    end if
    '
    '
    '-------
    insertw:
    '=======
    '
    inserts(s,wk,i) : bgl=i
    '
    '------
    recurw:
    '======
    '
    wr=word(s,i)
    if mc<>-15 then goto wredo
    '
    '---------
    exitmword:
    '=========
    '
    ascw=asc(wr)
    incli=0
    function=wr
    '
end function


'-------------------------------------------
function newvector(byval m as sys) as string
'===========================================
  '
  'ASSIGN A NEW MEMORY ADDRESS FOR A PROCEDURE VECTOR
  '
  dim as string wr
  if asce<0 then aoff-=cpuw : appendt("sub "+spw1+cr) 'RESERVE STACK SPACE
   wr=memreg(regs,aoff)
   if asce>0 then aoff+=cpuw
   if lclv=0 then aoffs=aoff
   '
   maco(m,0)=-7  'SET AS VECTORED PROCEDURE
   macsi(wr,m,1) 'SET VECTOR LOCATION
   function=wr
end function




'
'  ###################
'  #    NUMBERS      #        #       #  #  #    ###          ###    ##    #
'  #    STRINGS      #         ##      #####     #              #    # #   #
'  #    ADDRESES     # ############  ## PFX ##   # REG + OFFSET #    #  #  #
'  #    POINTERS     #         ##      #####     #              #    #   # #
'  #    VARIABLES    #        #       #  #  #    ###          ###    #    ##
'  ###################


'----------------------------------------------------------
function pword(byref s as string, byref i as sys) as string
'==========================================================
  '
  dim as sys a,b,c,e,k,m,n,v,ty,gg
  dim as string wr,ws,wt
  '
  ind=0 : nan=1 : wpfx="" : typk=0
  '
  '
  '============================
  'RECURSION POINT
  ' (FOLLOWING MACRO EXPANSION)
  '============================
  '
  rpword:
  '
  '
  '-----------
  'INDIRECTION * ** ********
  'and CASTING
  '===========
  '
  b=0 'POINTER '*' COUNTER
  do
    wr=mword(s,i)
    '
    if ert then wr=ow : exit function
    '
    ' `METHOD` `FUNCTION` RETURN VARIABLES
    '
    if (mc=-14) then
      if xpr+b then
        if (wr="function")or(wr="method") then inserts(s,"_return ",i) : continue do
        if wr="that" then nth=1 : continue do
      end if
    end if

    '
   'WORDS STARTING WITH DOT
    '
    if dtf=1 then
      if i=swd+1 then wr+=word(s,i) : swd-=1 : ascw=46 : goto xpword
    end if
    '
    'CASTING EG: (HANDLE) (void *) H
    '
    if ascw=&h62 then
      if wr="byval" then bvg=1 : ty=cpuw : continue do
    end if
    '
    if ascw=lbr then
      ws=wordahead(s,i)
      c=identype(ws)
      a=asc(s,nwd)
      if (a=rbr)or(a=42) then
        if c then
          ws=mword(s,i)
          if ascn=42 then i+=1 : b+=1 'INDIRECTION
          i+=1 : skiplspace(s,i) 'SKIP RIGHT BRACKET
          ty=typ
          if ty=0 then
            if c<0 then ty=-c+512 else ty=c
            b=indt
          end if
          continue do 'NEXT WORD OR CAST EXPRESSION
        end if
      end if
    end if
    '
    'if ty then
    '  varf=1 : exit do
    'end if
    '
    if ascw=63 then ty=cpuw : continue do '?'
    if ascw<>42 then exit do           '*'
    if ascn=61 then exit do            '*='
    '
    b+=1 'TALLY INDIRECTION
    '
  loop
  '
  if (b>0)and(ascw=91) then
    if mp then if ascn=91 then fixsqbr(s,i)
    if ascn=lbr then
      parp=b
    else
      '
      'prefix wpfx updated
      '
      indir(wr,b) : wr=pedi : inserts(s,wr,i) : swd=i : i+=len(wr) : skiplspace(s,i)
    end if
    '
    ty=cpuw ' TYPE OVERRIDE
    '
  end if
  '
  '
  '
  '
  '===========
  'ADDRESSES &
  '===========
  '
  if (ascw=38)or(ascw=64) then
    '
    if ascw=64 then i=swd+1 : skiplspace(s,i)
    '
    'ADDRESS OF STRING LITERAL
    '-------------------------
    '
    if isq(ascn) then wr=word(s,i) : ty=cpuw : goto xpword
    '
    '
    '
    'EXCLUDE BASIC `&H` `&O` NUMBERS
    '
    'use workaround for addresses that look like basic numbers: &h1 &b2 etc: & h1, & b2
    '
    if ascw=38 then
      if numco(s,i) then goto pnums
    end if
    '
    wr=mword(s,i) : typ=cpuw
    '
    '
    '
    'RENDER PROCS AS PLAIN VARIABLES
    '-------------------------------
    '
    '
    if (ascw=91)or(mc=-5)or(mc=-3)or(ascw=38) then
      '
      if varf=8 then
        '
        'CHECK IF A VECTOR NEEDS TO BE CREATED (fixed late binding)
        '
        'NOT '='
        '
        if ascn<>61 then
          if ascw=91 then varf=1 : mc=0 : goto xpword 'RETURN FUNCTION POINTER
          goto addrlab 'ASSUME TO BE A LABELLED FUNCTION
        end if
        '
        'MAKE A NEW VECTOR IF NEEDED &FUN=
        '
        if ascw<>91 then
          wr=newvector(mp)
          inserts(s,wr+" ",i) : wr=wword(s,i) 'RETURN LOCATION [..]
        end if
        '
        varf=1 : goto xpword
        '
      elseif varf>8 then
        '
        'ITR not for com  like methods with remote VA
        '
        'ADDRESS OF (NON DLL) VIRTUAL FUNCTION
        '
        'CHECK FOR PRESENCE OF METHODS TABLE
        '
        a=0
        if mc=-3 then
         if maco(mp,2) then a=1 'IS A CLASS RATHER THAN AN OBJECT
        elseif mc>0 then
          if (maco(maco(mp,0),2)) then a=1 'OTHERWISE CHECK THE CLASS OF THE OBJECT
        end if
        '
        if a then
          '
          'ACCESS FUNCTION TABLE DIRECTLY
          '
          wr=memreg(regst,toff+woff)
          '
        else
          '
          'METHODS TABLE NOT DEFINED SO ASSUME
          'EXTERNAL WITH VIRTUAL TABLE POINTER
          '
          wpfx+="mov "+qedi+cm+wr+cr
          wr=memreg(qedi,woff)
        end if
        varf=1 : goto xpword
      end if 'PROCEDURES
      '
      '&& (for passing pointer addresses)
      '----------------------------------
      '
      if ascw=38 then
        wr=mword(s,i)
        if len(wpfx) then
          mid(wpfx,1)="lea" : wr=qedi : typ=cpuw : varf=1
        else
          ers="Invalid address" : ert=7 : goto xpword
        end if
      end if
      '
      'ADDRESS DERIVED FROM ARRAY
      '--------------------------
      '
      if (ascn=lbr)or(ascn=91) then
        adra=nst+1 : varf=1 : goto xpword
      end if
      '
      'ADDRESS OF VARIABLE [ebx+/-offset] etc
      '--------------------------------------
      '
      'if wr=pedi then
      '  if len(wpfx) then mid(wpfx,1)="lea" else wr=qedi
      'elseif wr<>qedi then
      '  wpfx+=ledi+wr+cr : wr=qedi
      'end if
      '
      if wr=pedi then
        if len(wpfx) then
          'mid(wpfx,1)="lea"
          a=instrevn(-1,wpfx,"mov ")
          if a then mid(wpfx,a)="lea"
        else
          wr=qedi
        end if
      elseif wr<>qedi then
        wpfx+=ledi+wr+cr : wr=qedi
      end if

     '
      goto xpword
      '
    end if
    '
    '=======
    addrlab: 'ADDRESS OF LABEL
    '=======
    '
    if cpuw=4 then
      wpfx="call fwd here : .here : pop edi : sub edi,here : add edi,"+wr+cr
    else
      wpfx="lea rip rdi,"+wr+cr
    end if
    '
    wr=qedi : varf=1 : goto xpword
    '
  end if
  '
  '==============
  pnums: 'NUMBERS
  '==============
  '
  if isn(ascw) then
    wordval(s,swd,i) : if nan=0 then wr=mid(s,swd,i-swd) ' nan status
    goto xpword
  end if
  '
  '=======
  'STRINGS
  '=======
  '
  if isq(ascw) then
    goto xpword
  end if
  '
  '
  '===================
  'MACRO SUBSTITUTIONS
  'low level % macros
  '===================
  '
  if mcf then
    v=0 : a=0 : b=0 : k=0 : n=0 : c=0 : ws="" : wt=""
    if (mcf and 1) then
      do
        v+=1 : if v>len(wr) then exit do
        a=asc(wr,v)
        '
        'ASSIGN FLAG
        '-----------
        '
        if a=2 then
          k=1 : ws=""
        end if
        '
        'SWALLOW LEFT OF LINE
        '--------------------
        '
        if a=3 then 
          ws=mid(t,bg,j-bg) : n=1
        end if
        '
        'RIGHT BLOCK STRUCTURE
        '---------------------
        '
        if a=4 then
          if c=0 then
            capturi(s,m,b,i)
            wt=mid(s,m,b)
            c=1
          end if
          ws=wt
        end if
        '
        'LINE BREAK
        '----------
        '
        if a=5 then
          ws=cr
        end if
        '
        if (a>=2)and(a<=5) then
          wr=left(wr,v-1)+ws+mid(wr,v+1)
          v+=len(ws)-1 : ws=""
        end if
      loop
    end if
    if k=1 then asg="mov "+wr+cm+qeax+cr
    if k=0 then inserts(s,wr,i)
    if n=1 then j=bg ' swallowed left part of line
    if (mcf and 2) then if n=0 then j-=len(pwd) ' swallow previous word
    mcf=0
    '
    'RECURSE
    '-------
    '
    goto rpword
  end if
  '
xpword:
  '
  if ty then typ=ty : typk=ty
  function=wr 
  '
end function






'-----------------------------------------------------------
function namesig(byref s as string,byref k as sys) as string
'===========================================================
  '
  dim as sys a,b,pt=bref,f,j,opf
  dim as string wr,wd,wv,pts,w1
  a=k : b=swd
  do
    wr=word(s,k)
    if wr="byval" then pt=0      : continue do   'BASIC BYVAL
    if wr="byref" then pt=1      : continue do   'BASIC BYREF
    if wr="optional" then opf=49 : continue do   'OPTIONAL PARAMS
    '
    if isc(ascw) then endline(s,k) : continue do 'SKIP COMMENTS
    'if (ise(ascw))or(ascw=rbr) then exit do     'END OF PARAMS
    if ascw=rbr then exit do                     'END OF PARAMS
    '
    'CHECK FOR DEFAULT VALUES
    '
    if ascn=61 then
      wv+=wr+"=" : k+=1 : j=k
      capts(s,k)
      wv+=mid(s,j,k-j)+"," : continue do
    end if
    '
    if wr="as" then f=1 : continue do            'BASIC TYPE FOLLOWS
    if ascn=97 then
      if wordahead(s,k)="as" then
        k=nwd : f=1 : continue do                'BASIC TYPE FOLLOWS
      end if
    end if
    '
    'C STYLE
    '=======
    '
    if f=0 then
      '
      'TYPE RECOGNITION
      '----------------
      '
      k=swd : wr=mword(s,k)
      if wr="optional" then
        opf=49 : continue do
      end if
      a=identype(wr)
      if a then
        f=1 : pt=0
        do
          if ascn=42 then pt+=1 'COLLECT POINTERS
          if (ascn<>44)and(ascn<>rbr) then
            w1=word(s,k)
            '
            'CHECK FOR DEFAULT ASSIGNMENTS
            '
            if ascn=61 then
              wv+=w1+"=" : k+=1 : j=k
              capts(s,k)
              wv+=mid(s,j,k-j)+","
            end if
          else
            exit do  'SWALLOW NAMES
          end if
        loop
      end if
      '
    end if
    '
    'COLLECT POINTERS
    '----------------
    '
    do
      if (ascn=42)or(ascn=&h70) then
        if instrword(" ptr pointer * ",wordahead(s,k)) then k=nwd : pt+=1 : continue do
      end if
      exit do
    loop
    '
    if ascn=44 then k+=1 : skiplspace(s,k)
    '
    'ADD SIG FRAGMENT
    '----------------
    '
    if f=0 then wr="sys" 'DEFAULT TYPE
    '
    f=0
    '
    if pt=0 then if wr="void" then pt=bref : continue do 'no parameter
    '
    wd+="#"+wr: pts+="a"+chr(pt+opf+48) : pt=bref 'default
    'if iss(ascn) then exit do
  loop
  '
  swd=b
  if len(wd) then wd+="@"+pts       'ADD INDIRECTION DATA
  if len(wv) then wd+=" (,"+wv+") "  'ADD DEFAULT VALUES
  function=wd
  '
end function



' INTERNAL FORMAT:
'-----------------
'
' TAB NAME OFFSET LENGTH OBOFF PRIV CALLTYPE SIG SOG
'
' OBOFF
'   1 PROPERTY
'   8 CALL
'   9 METHOD
'   10+ INHERITED METHOD WITH OBJECT OFFSET
'
'

'-----------------------------------------------------------------------------------------------------------------------------------------
function encodele(byref wm as string, byref wr as string, byref k as sys, byval n as sys, byval vtl as sys, byref ws as string ) as string
'=========================================================================================================================================
  '
  ' tt as sys
  ' virtual amphibian frog(100)
  ' tt aa! (as sys) as sys

  dim as sys a,b,m
  dim as string w1,w2,w3
  '
  'DEFAULT ELEMENT
  '---------------
  '
  ws="" : m=1  ' attributes flag default
  '
  '
  'SUBS / FUNCTIONS '8'
  '--------------------
  '
  if n=&h11f then m=8
  if asc(wm,k)=33 then m=8 : k+=1

  '
  'POINTER TO OTHER TYPES '3'
  '--------------------------
  '
  if (n>=512)or(indt>0) then m=3
  '
  'METHODS AND STATIC MEMBERS 2 4 9
  '--------------------------------
  '
  if (vtl>1) then m+=1
  '
  '
  '
  skiplspace(wm,k) : b=ascn
  '
  'CALLING SIGNATURE / ARRAY SIGNATURE SIG
  '---------------------------------------
  '
  w2=","
  '
  if ascn=lbr then
    '
    k+=1 : ws=namesig(wm,k)
    '
    'SIMPLIFY SIGNATURE FOR ARRAYS
    '-----------------------------
    '
    if m<8 then ws=splitsi(ws,w3)
    if len(ws) then
      w2=ws
      a=instr(ws,"(")
      if a then ws=left(ws,a-1) 'exclude default params from signature
    end if
  end if
  '
  w1=wordahead(wm,k)
  '
  'RETURN SIGNATURE SOG
  '--------------------
  '
  w3=","
  if n>=512 then
    w3=str(n)
  elseif w1<>"as" then
    if len(wr) then w3=wr
  else
    k=nwd : w3=word(wm,k)
  end if
  '
  '
  'PRIVATE AND PROTECTED MEMBERS
  '-----------------------------
  '
  if priv then a=priv else a=57
  '
  'VARF PRIV/PROT CALLCONV SIG SOG
  '===============================
  '
  function=" "+str(m)+" "+chr(a)+" "+chr(cco+65)+" "+w2+" "+w3
  '
end function


'-----------------------------------------------------------
function arraysize(byref s as string, byref i as sys) as sys
'===========================================================
  '
  'itr macro index
  '
  dim as sys a,v,lb,rb
  dim as string wr
  lb=asc(s,i) : if lb=91 then rb=93 else rb=rbr
  v=1 : i+=1 'SKIP FIRST LEFT BRACKET
  do
    wr=word(s,i)
    if ascw=rb then
      if ascn<>lb then exit do  'EXIT AFTER FINAL RIGHT BRACKET
      i+=1 : skiplspace(s,i) 'OTHERWISE NEXT DIMENSION
      continue do
    end if
    a=wval(wr) : if a>0 then v*=a
  loop
  function=v
  '
end function


'---------------------------------------------------------------------------
function vword(byref s as string, byref i as sys, byref wr as string) as sys
'===========================================================================
  dim as sys a
  do
    a=dic(" static 10, declare 1, dim 2,  public 39, private 30, protected 31, ",wr)
    'IGNORE STATIC
    if a=0 then exit do
    if a<=2 then dcl=a
    if a>=&h30 then priv=a
    mid(s,swd)=space(i-swd) 'BLANKOUT
    if isx(ascn)=0 then wr=word(s,i) else wr="" : exit do
  loop
  function=0
end function




'------------------------------------------------
sub decidecop(byref op as sys, byval tp as sys)
'================================================
  '
  'ALTER OP FOR FPU AND UNSIGNED CPU TYPES
  '
  '-------------------unsigned integer or any float
  ' op=&h12  b   <
  ' op=&h13  ae  >=
  ' op=&h16  be  <=
  ' op=&h17  a   >
  '-------------------signed equiv
  ' op=&h1c  l   b  <
  ' op=&h1d  ge  ae >=
  ' op=&h1e  le  be <=
  ' op=&h1f  g   a  >
  '-------------------patch
  '
  if tp>=&h20 then
    '
    asm
    xor eax,eax
    mov ecx,[op] 'byref
    mov al,[ecx] 'op
      cmp al,&h1c
      jnz encoc1
      mov al,&h12
      jmp encoc
      '
      encoc1:
      cmp al,&h1d
      jnz encoc2
      mov al,&h13
      jmp encoc
      '
      encoc2:
      cmp al,&h1e
      jnz encoc3
      mov al,&h16
      jmp encoc
      '
      encoc3:
      cmp al,&h1f
      jnz encoc4
      mov al,&h17
      jmp encoc
      '
      encoc4:
    encoc:
    mov [ecx],eax
    end asm
    '
    '
  end if
end sub


'------------------------------------------------------------
function comparet(byref op as sys, byval tp as sys) as string
'============================================================
  '
  '
  'AFTER COMPARISONS: eg: wi="cmp "+pesp+",eax"
  '
  ' mov eax,-1
  ' jcond fwd nok
  ' inc eax
  ' .nok
  '
  'COMPAT INC FF C0 : NOT 40
  '
  '-------------------signed equiv
  ' op=&h14  z   =
  ' op=&h15  nz  <>
  ' op=&h1c  l   b  <
  ' op=&h1d  ge  ae >=
  ' op=&h1e  le  be <=
  ' op=&h1f  g   a  >
  '-------------------patch
  '
  dim as sys a,b
  dim as string w1
  '
  decidecop(op,tp)
  if cpuw=4 then
    w1="o2 b8 nl-1 75 02 ff c0 "+cr ' eg: true if equal
    a=13
  else
    w1="o2 48 b8 nq-1 75 03 48 ff c0 "+cr ' eg: true if equal
    a=16
  end if
  if op<>&h15 then mid(w1,a)=hex(op-&h10)
  '
  function=w1
end function


'--------------------------
function readin() as string
'==========================
dim as sys b
dim as string w1,w2
  '
  w2=string(&h1000,chr(0)) : b=1
  do
    read w1 : if w1="!end!" then exit do
    mid(w2,b)=w1+cr : b+=len(w1)+len(cr)
  loop
  function=left(w2,b-1)
end function


'--------------
sub localvars()
'==============
 if lclv then
   aoffl=aoff
 else
   aoffs=aoff : regs=regsl
 end if
 lclv=1 : aoff=aoffl : asce=-1
end sub


'--------------
sub staticvars()
'==============
 if lclv then
   aoffl=aoff : regs=regss
 else
   aoffs=aoff
 end if
 lclv=0 : aoff=aoffs : asce=1
end sub


'---------
sub nest()
'=========
  brc+=1
  if brc>99 then ers="Depth limit exceeded ((()))" : ert=10 : exit sub
  scop(brc,0)=me
  scop(brc,1)=aoff
  scop(brc,2)=asce
  scop(brc,3)=mle
  scop(brc,4)=lclv
  scop(brc,5)=spe
  scop(brc,6)=casf
  scop(brc,7)=ixb
  sregs(brc)=regs
  if lclv=0 then aoffs=aoff
end sub


'-----------
sub unnest()
'===========
  'if brc<=0 then exit sub
  '
  'LOCAL OR STATIC VARIABLES?
  '
  if lclv=0 then aoffs=aoff else aoff=aoffs 'RETAIN VARSPACE EXPANSION
  me=scop(brc,0)
  asce=scop(brc,2)
  mle=scop(brc,3)
  lclv=scop(brc,4)
  spe=scop(brc,5)
  casf=scop(brc,6)
  ixb=scop(brc,7)
  if lclv then aoff=scop(brc,1)
  regs=sregs(brc)
  brc-=1
  if brc<0 then
    brc=0
    ers="Too many right brackets (..))" : ert=10
  end if
end sub



'-------------------------------------------
function params(byval s as string) as string
'===========================================
  dim as sys a,b,c,e,i,v
  dim as string w1,w2,w3,w4,w5,w6
  '
  'TRANSLATE SIG TO PARAMETERS
  '
  w1=macso(a,3)
  c=instr(w1,"@") : if c=0 then exit function
  w2=mid(w1,c+1) : W1=left(w1,c-1) 'SEPARATE PARAMS AND INDIRECTION
  e=len(w2)
  '
  i=1
  for b=1 to e
    v=asc(w2,b)-48
    w4=wordfrag(w1,i)
    if hlo=0 then 'C
      w6+=w4+string(v,"*") 'itr typedefs
    elseif hlo=1 then 'BASIC
      if v=0 then
        w3="byval " : w5=""
      elseif v=1 then
        w3="byref " : w5=""
      else
        w4="dword" 'ANON POINTER
        w3="byval " : w5=" ptr"
      end if
    end if
    '
    w6+=w3+w4+w5+", "
    '
  next
  
  c=len(w6)-2 'TRIM LAST COMMA
  function=left(w4,c)
  '
end function




'----------------------------------------------------------------
sub nextsig(byref s as string, byref k as sys, byref w as string)
'================================================================
  k=instr(k,s,"##")
  if k then k+=1 : sig=uword(s,k) : sog=uword(s,k) : typ=identype(sog) : w=uword(s,k)
end sub


'---------------------------------------------------------------------------------------------------------
sub atadd(byref s as string, byref i as sys, byref wsig as string, byref w1 as string, byref w4 as string)
'=========================================================================================================
  if ascw<>91 then
    if (ascn=43)or(ascn=45) then
      inserts(s,w1,i) : dv=metaval(s,i,w1) 'ABSOLUTE VECTOR FIXED AT COMPILE TIME
    end if
    w1="["+w1+"]"
  end if
  '
  'ABSOLUTE ADDRESS MACRO
  '----------------------
  '
  'for runtime library: [ebx+nnnn]
  '
  'PROVIDE ADDRESS FOR HOST VARIABLE
  '
  w1=cr+"mov "+w1+cm+qeax+cr+eq+cr
  '
  if cpuw=4 then
    w4=sq+"call fwd here : .here : pop eax : sub eax,here : add eax,"+wsig+w1
    'w4=sq+"o2 e8 hl0 58 05 gl "+wsig+" 83 c0 06 "+w1
  else
    w4=sq+"lea rip rax,"+wsig+w1
  end if
  '
end sub



'-----------------------------------------------------------------
function stackspace(byval a as sys, byval noinit as sys) as string
'=================================================================
  '
  'min cpuw bytes : steps of cpuw ' 4 or 8 bytes
  '
  dim as sys b,c
  dim as string w1
  '
  if a<=0 then exit function
  '
  'ROUND UP TO MAINTAIN STACK ALIGNMENT
  '------------------------------------
  '
  if cpuw=4 then 
    c=a and &h7ffffffc : if c<a then a=c+4
  else
    c=a and &h7ffffff0 : if c<a then a=c+16
  end if
  '
  mlcl(funi)+=a
  '
  if noinit then exit function 'function="sub "+qesp+cm+str(a)+cr : exit function
  '
  if cpuw=4 then
    '
    w1=ledi+"[ebp"+str(aoff)+"] : xor eax,eax"+cr
    '
    if a<=4 then
      function=w1+"mov [edi],eax"+cr
    elseif a<=8 then
      function=w1+"mov [edi],eax : mov [edi+4],eax"+cr
    elseif a<=12 then
      function=w1+"mov [edi],eax : mov [edi+4],eax : mov [edi+8],eax"+cr
    else
      function=w1+"mov ecx,"+str(a-4)+cr+_
      "( : mov [edi+ecx],eax : sub ecx,4 : jge repeat : )"+cr
    end if
    '
  else
    '
    w1="lea rdi,[rbp"+str(aoff)+"] : xor rax,rax"+cr
    'w1="lea rdi,[rbp"+str(aoff)+"] : sub rsp,"+str(a)+" : xor rax,rax"+cr
    '
    if a<=16 then
      function=w1+"mov [rdi],rax : mov [rdi+8],rax"+cr
    else
      function=w1+"mov r10,"+str(a-8)+cr+_
      "( : mov [rdi+r10],rax : sub r10,8 : jge repeat : )"+cr
    end if
    '
  end if
end function

'-----------
sub getdvl()
'===========
  dim as sys a,k,m
  if varf=8 then
    dvl=macso(mq,3)
    k=instr(dvl,"(,")
    if k then
      capture(dvl,m,k,a)
      dvl=mid(dvl,m,k-m)        'GET PARAM DEFAULT VALUES
    else
      dvl=""
    end if
  end if
end sub


'----------------------------------------------------------
function cloneit(byref wr as string, byval b as sys) as sys
'==========================================================
  '
  'CLONE AN EXISTING ENTITY
  '
  dim as sys i
  dim as string s
  for i=0 to 6
    maco(me,i)=maco(b,i)
  next
  macsi(wr,me,0)
  for i=1 to 3
    s=macso(b,i) : macsi(s,me,i)
  next
  addm(me) : function=me : addme()
end function



'---------------------------------------------------------------------------------
sub erasek(byref w1 as string, byref w2 as string, byval b as sys, byval c as sys)
'=================================================================================
  '
  'ERASE KEYWORD IN A STRING AND C WORDS FOLLOWING
  '
  dim as sys f,m
  dim as string w3
  '
  f=instr(b,w1,w2) : if f=0 then exit sub
  m=f : f+=len(w2)
  do
    c-=1 : if c<0 then exit do
    w3=mword(w1,f)
  loop
  mid(w1,m)=space(f-m) 'erase section
end sub


'---------------------------
sub cpus(byref wr as string)
'===========================
  dim as sys a
  a=wval(wr)
  if a then
    pem=a
    if a=64 then cpuw=8 else cpuw=4
    regnames() 'SET 32/64 BIT REG NAMES
  end if
end sub



'---------------------------------------------------------------------------
function cbrencah(byref s as string, byref i as long, byval c as sys) as sys
'===========================================================================
  dim as long a,b
  a=i : b=ascn
  nextinstruct(s,i)
  if ascn=123 then
    if cbri>63 then ert=101 : ers="Too many '{' " : exit function
    cbrk(cbri)=c : cbri+=1 : i+=1 : skiplspace(s,i)
    function=1
  else
    i=a : ascn=b
  end if
end function


'----------------------------------------------------------------
sub paths(byref s as string, byref i as sys, byref pth as string)
'================================================================
 dim as sys b
 dim as string wr
 if ascn=43 then b=1 : i+=1
 wr=noquotes(mword(s,i)) 
 if b then pth+=wr else pth=wr
end sub


'---------------------------------------------
function stodata(byref wr as string) as string
'=============================================
  dim as sys a,b,q
  dim as string w1,w2,co
  if nsto then exit function
  datc+=1
  q=isq(ascw)
  '
  if dep then
    if q then wr=noquotes(wr)+chr(0)+chr(0)
    function=w2+" o2 8D 83"+hexl(aoffs)+cr
    aoffs+=len(wr) : b=aoffs
    if q then a=-cpuw : a and=aoffs : if a<aoffs then aoffs=a+cpuw 'ALIGN AOFFS
    ape(dats,dati,wr+string(aoffs-b,chr(0))) 'add padded data to data string
    if lclv=0 then aoff=aoffs
  else
    w1=hex(datc)
    if q then wr+=" 00 00"
    ape(dats,dati," gd "+w1+" "+wr+cr) 'add to data
    if cpuw=8 then w2=" 48" 'pointer returned in 64 bit rax instead of 32 bit eax
    function=w2+" o2 8D 83 gc "+w1+cr 'eventually mov eax,[ebx-????]
  end if
end function

