
'---------------------
'exo2 o2 compiler maker
'=====================

'Charles Pegge
'21 June 2010
'28 Sept 2010





  
  '------------
  'SELECTED API
  '============
  '
    '#include once "windows.bi"
    '#include once "win/ole2.bi"
    '
    #define DLL_PROCESS_ATTACH   1
    #define DLL_THREAD_ATTACH    2
    #define DLL_THREAD_DETACH    3
    #define DLL_PROCESS_DETACH   0
    #define DLL_PROCESS_VERIFIER 4
    #define sys Long
    Type HWND As sys
    Type HMODULE As sys
    Type HINSTANCE As sys
    Type BOOL As sys
    Type UINT As sys
    Type DWORD As sys
    Type BSTR As Any Ptr
    Type FARPROC As Any Ptr
    Type PVOID As Any Ptr
    Type PCVOID As Any Ptr
    Type PLONG As Long Ptr
    Type PDWORD As dword Ptr
    Type LPCSTR As Zstring Ptr
    Type LPSECURITY_ATTRIBUTES As Any Ptr
    Type LPOVERLAPPED As Any Ptr
    Type HANDLE As sys
    #define iostring bstr
    '
  Extern "windows" lib "kernel32"
    Declare Function ReadFile ( _
      As HANDLE, _
      As PVOID,  _
      As DWORD,  _
      As PDWORD,  _
      As LPOVERLAPPED) As BOOL
    Declare Function WriteFile ( _
      Byval As HANDLE, _
      As PCVOID,  _
      As DWORD,  _
      As PDWORD, _
      As LPOVERLAPPED) As BOOL
    Declare Function LoadLibrary Alias "LoadLibraryA" ( _
      As LPCSTR) As HINSTANCE
    Declare Function CreateFile Alias "CreateFileA" ( _
      As LPCSTR, _
      As DWORD, _
      As DWORD, _
      As LPSECURITY_ATTRIBUTES, _
      As DWORD, _
      As DWORD, _
      As HANDLE) As HANDLE
    Declare Function FreeLibrary(Byval As HMODULE) As BOOL
    Declare Function GetProcAddress( _
      As HINSTANCE, _
      As LPCSTR) As FARPROC
    Declare Function GetFileSize ( _
      As HANDLE, _
      As PDWORD) As DWORD
    Declare Function SetFilePointer( _
      As HANDLE, _
      As Long, _
      As PLONG, _
      As DWORD) As DWORD
    Declare Function CloseHandle( _
      As HANDLE) As BOOL
  End Extern

  Extern "windows" lib "oleaut32"
    Declare Function SysAllocStringByteLen ( _
      As Zstring Ptr, _
      As Uinteger) As BSTR
    Declare Sub SysFreeString (Byval As BSTR)
  End Extern

  Extern "windows" lib "user32"
    Declare Function MessageBox Alias "MessageBoxA" ( _
      As HWND, _
      As LPCSTR, _
      As LPCSTR, _
      As UINT) As Integer
  End Extern
    #define AllocString(p,le) SysAllocStringByteLen(p,le)
    #define FreeString(p) SysFreeString(p)
    #define Library(s) LoadLibrary(s)
    #define FreeLibr(a) FreeLibrary(a)
    #define ProcAddr(a,b) GetProcAddress(a,b)

  extern "windows-MS" lib "oxygen"

  declare sub      o2_mode  (byval m as long)
  declare sub      o2_asmo  (byval s as bstr)
  declare sub      o2_basic (byval s as bstr)
  declare function o2_exec  (byval addr as long) as long
  declare function o2_buf   (byval n as long) as long
  declare function o2_error () as zstring ptr
  declare function o2_get   () as zstring ptr
  declare function o2_len   () as long
  declare function o2_prep  (byval srcBSTR as bstr) as zstring ptr
  declare sub      o2_put   (byval c as bstr)
  declare function o2_view  (byval srcBSTR as bstr) as zstring ptr

  end extern

  extern "windows" lib "kernel32"

  declare FUNCTION GetCommandLine ALIAS "GetCommandLineA" () AS zstring ptr

  end extern

  const as string qu=chr(34)
  const as string tb=chr(9)
  const as string cr=chr(13)+chr(10)

  dim shared as string prs

  '--------------------------
  sub pri(byval s as string)
  '==========================
  prs+=s+cr
  print s+cr
  end sub

  '-----------
  'DIAGNOSTICS
  '===========
  dim as string msg,tit
  msg="here"
  tit="Tracer"
  dim shared as any ptr pmsg,ptit
  pmsg=strptr(msg)
  ptit=strptr(tit)

  #if 0
  'TRACER
  pushad
  push 0
  push [ptit]
  push [pmsg]
  push 0
  call MessageBox
  popad
  #endif

  '-------------------------------------------------------------------
  function CombiHeadfile(byval u as string, byval w as string) as bstr
  '===================================================================
  '
  dim as sys b,h,p,pf,ph,le,leh
  dim as any ptr pu,pw
  pw=strptr(w)
  pu=strptr(u)
  '
  asm
    '
    'CHECK VALID NAME
    '
    cmp dword ptr [pw],0
    jz ngetfile
    '
    'OPEN FILE
    '
    push 0             'HANDLE hTemplateFile OPT
    push 128           'FILE_ATTRIBUTE_NORMAL
    push 3             'CREATE (NEW 1) (ALWAYS 2) (OPEN 4) (OPEN EXISTING 3)
    push 0             'LP SECURITY  ATTRIBUTES OPT
    push 1             'SHARE MODE read(1) write(2)
    push &h80000000    'GENERIC_READ (0x80000000) GENERIC_WRITE (0x40000000)
    push [pw] 'name
    call Createfile
    cmp eax,0
    jz ngetfile
    mov [h],eax
    '
    'SET FILE POINTER
    '
    push 0              'DWORD dwMoveMethod 0,FILE_BEGIN(0) FILE_CURRENT(1) FILE_END (2) 
    lea eax,[ph]        'PLONG lpDistanceToMoveHigh
    push eax
    push 0              'LONG lDistanceToMove
    push [h]            'DWORD HANDLE
    call SetFilePointer '
    mov [pf],eax        'File Pointer position low
    '
    'GET FILE SIZE
    '
    lea eax,[leh]       'PLONG lpFileSizeHigh
    push eax            '
    push [h]            'DWORD HANDLE
    call GetFileSize    '
    '
    cmp eax,0           'CHECK FOR NULL FILE
    jz ngetfile         'FILE EMPTY

    mov [le],eax        'FILE LENGTH
    '
    add eax,256         'ADD SPACE FOR HEADER
    '
    '
    'CREATE STRING BUFFER
    '
    push eax            'SOURCE BUFFER LENGTH REQUIRED
    push 0              'OPTIONAL COPY POINTER
    call SysAllocStringByteLen 'CREATE BSTR
    mov [function],eax  'WILL RETURN POINTER
    '
    mov ecx,256         'MAKE SOURCE HEADER OF 256 BYTES
    mov edi,eax         'TARGET ADDRESS
    mov esi,[pu]        'SOURCE OF HEADER
    '
    rtrnhe:             'TRANSFER HEADER CONTENTS
    '
    mov al,[esi]
    cmp al,0            'CHECK FOR NULL TERMINATION BOUNDARY
    jz ntrnhe
    inc esi
    mov [edi],al
    inc edi
    dec ecx
    jg rtrnhe
    '
    ntrnhe:
    '
    sub ecx,2           'ALLOW SPACE FOR CRLF
    '
    rtrnhe2:
    '
    mov byte ptr [edi],32  'FILL WITH SPACES
    inc edi
    dec ecx
    jg rtrnhe2
    '
    mov word ptr [edi],&h0a0d 'CRLF
    add edi,2
    '
    mov [p],edi         'START ADDRESS FOR FILE CONTENT


    '
    'READ FILE
    '---------
    '
    push 0              'LPOVERLAPPED lpOverlapped
    lea eax,[b]         'lpNumberOfBytesRead
    push eax            '
    push [le]           'DWORD nNumberOfBytesToRead
    push [p]            'LPVOID lpBuffer
    push [h]            'DWORD HANDLE
    call ReadFile
    '
    'CLOSE HANDLE
    '
    push [h]
    call CloseHandle
    '
    ngetfile:
    '
  end asm

  end function 'combi


  '-------------------------------------------------------------------
  sub ExtensName(s as string, mnm as string, xnm as string, i as long)
  '===================================================================
    'including dot
    dim as sys le
    le=len(s)
    i=le+1
    do
      i-=1
      if i<0 then exit do
      if asc(s,i)=46 then exit do
    loop
    '
    if i then
      mnm=left(s,i-1)
      xnm=mid(s,i)
    else
      mnm=s
    end if
    '
  end sub


  dim z as zstring ptr 
  z=GetCommandLine

  'pri "Commandline: "+ *z

  
  dim as sys a,b,e,i,le,swa,swc,swm
  dim as string n,s,u,mnm,xnm
  dim as bstr t
  dim as zstring ptr er
  '
  n=ltrim(lcase(*z))

  '
  'SKIP COMMAND
  '
  a=asc(n)
  b=1
  if a=34 then
    b=instr(2,n,qu)
    b+=1
  end if
  '
  '
  'CHECK FOR PARAMETER FOLLOWING
  '-----------------------------
  '
  a=instr(b,n," ")
  '
  if a=0 then
    n="" : goto nofile
  end if
  '
  n=mid(n,a+1)
  n=ltrim(n)
  '
  'STRIP QUOTES ON FILENAME
  '------------------------
  '
  if asc(n)=34 then
    b=instr(2,n,qu)
    if b then n=mid(n,2,b-2)
  end if

  '
  n=ltrim(n)
  '
  '
  'SWITCHES
  '--------
  do
    if asc(n)=45 then
      a=asc(n,2)
      n=ltrim(mid(n,3))
      if a=&h61 then swa=a '-a list output
      if a=&h63 then swc=a '-c compile
      if a=&h6d then swm=a '-m show messagebox
    else
      exit do
    end if
  loop
  '
  '-------------
  nofile: 'check
  '=============
  '
  n=rtrim(n)
  '
  if len(n)=0 then
    'pri "error 2: missing filename"
    pri "compiler options:"+cr+_
          "<filename>       compiles and executes directly in memory"+cr+_
          "-a <filename>    list output"+cr+_
          "-c <filename>    compiles to an Executalbe file"+cr+_
          "more than one switch may be used"+cr+_
          ""
    goto finish
  end if

  '
  'CHECK FOR .BAS EXTENSION NAME
  '-----------------------------
  '
  s=n 'accept any
  '
  ExtensName(s,mnm,xnm,i)
  '
  u="#basic"+cr
  '
  if swc then
    u+="#file "+qu+mnm+".exe"+qu+cr
  end if
  '
  'ATTEMPT TO GET FILE
  '-------------------
  '
  t=CombiHeadFile(u,s)
  '
  if t=0 then
    pri "error 3: file empty or not found: "+s
    goto finish
  end if
  '
  'CHECK LENGTH INCLUDING HEADER
  '
  asm
    mov eax,[t]
    mov eax,[eax-4]
    mov [a],eax
  end asm
  '
  if a<=256 then 
    pri "error 4: file empty or not found: "+s
    goto finish
  end if

  'NORMAL COMPILE
  '==============


  o2_mode(0) 'read/return null terminated ascii strings
  if swa then pri *o2_view(t)
  o2_asmo(t) 'compile string


  er=o2_error()

  if len(*er) then
    pri cr+"Error: "+ *er
    goto finish
  else
    if swc=0 then o2_exec(0) else pri cr+"Okay"
    goto xfinish
  end if

  finish:
  '------


  xfinish:
  '-------

  if len(prs) then
    if swm then messagebox 0,prs,"o2",0
  end if

  if t<>0 then SysFreeString t

